# --- Automatic generated test file  ---
# Generator    : generate_knot_insert.py
# Date         : 2020-05-10
# Git revision : b'81e0a57f88c16bccbea4294775eb8bac837367d6\n'
from __future__ import annotations

import unittest

import numpy as np

import lrspline as lr


class TestInsertKnot(unittest.TestCase):
    def test_surface_2D_p22(self):
        controlpoints = np.array([[  0.,   0.],
       [ 36.,  -1.],
       [ 63.,   1.],
       [ 95.,  -2.],
       [  2.,  32.],
       [ 31.,  37.],
       [ 63.,  34.],
       [ 97.,  28.],
       [  3.,  62.],
       [ 32.,  69.],
       [ 68.,  62.],
       [104.,  65.],
       [ -3., 103.],
       [ 29.,  98.],
       [ 62., 104.],
       [ 99.,  97.]])
        n1   = 4
        p1   = 2
        knot1= np.array([0. , 0. , 1.2, 2.2, 3. , 3. ])
        n2   = 4
        p2   = 2
        knot2= np.array([0. , 0. , 0.9, 2.2, 3. , 3. ])
        surf  = lr.LRSplineSurface(n1,n2,p1,p2,knot1,knot2, controlpoints)
        surf2 = surf.clone()
        surf2.insert_knot([1.831], 0, 1) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 7)
        surf2.insert_knot([2.002], 1, 1) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 7)

        u    = np.linspace(surf.start(0), surf.end(0), 9)
        v    = np.linspace(surf.start(1), surf.end(1), 9)
        U,V  = np.meshgrid(u,v)
        pt   = surf(U,V)
        pt2  = surf2(U,V)

        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_surface_3D_p44(self):
        controlpoints = np.array([[  4.,   3.,  -5.],       [ 20.,  -2.,   2.],       [ 38.,  -5.,  -5.],       [ 59.,   0.,  -3.],       [ 83.,  -3.,  -2.],       [100.,  -4.,   2.],       [  3.,  17.,  -4.],       [ 16.,  13.,  -5.],       [ 40.,  14.,   3.],       [ 58.,  20.,   0.],       [ 77.,  18.,  -2.],       [ 96.,  14.,  -1.],       [ -5.,  32.,   3.],       [ 21.,  37.,  -2.],       [ 35.,  34.,  -2.],       [ 63.,  34.,  -5.],       [ 82.,  36.,  -1.],       [102.,  29.,   1.],       [ -4.,  49.,   2.],       [ 18.,  47.,  -3.],       [ 38.,  48.,   1.],       [ 61.,  51.,   0.],       [ 77.,  46.,  -2.],       [ 95.,  53.,  -1.],       [  0.,  70.,   3.],       [ 19.,  70.,   2.],       [ 36.,  70.,   2.],       [ 64.,  67.,   3.],       [ 82.,  64.,   3.],       [ 98.,  68.,   4.],       [  3.,  86.,   0.],       [ 18.,  79.,   1.],       [ 37.,  81.,   3.],       [ 63.,  87.,  -1.],       [ 83.,  79.,  -2.],       [101.,  84.,  -2.],       [ -4., 104.,  -4.],       [ 23., 104.,  -5.],       [ 43., 103.,   0.],       [ 61.,  99.,  -3.],       [ 81.,  96.,  -5.],       [ 97., 101.,   1.]])
        n1   = 6
        p1   = 4
        knot1= np.array([0. , 0. , 0. , 0. , 0.6, 2.1, 3. , 3. , 3. , 3. ])
        n2   = 7
        p2   = 4
        knot2= np.array([0. , 0. , 0. , 0. , 1. , 2.1, 2.8, 4. , 4. , 4. , 4. ])
        surf  = lr.LRSplineSurface(n1,n2,p1,p2,knot1,knot2, controlpoints)
        surf2 = surf.clone()
        surf2.insert_knot([1.281], 0, 1) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 11)
        surf2.insert_knot([1.427], 0, 2) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 13)
        surf2.insert_knot([2.064], 0, 3) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 16)
        surf2.insert_knot([1.322], 1, 1) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 12)
        surf2.insert_knot([1.118], 1, 2) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 14)
        surf2.insert_knot([2.326], 1, 3) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 17)

        u    = np.linspace(surf.start(0), surf.end(0), 9)
        v    = np.linspace(surf.start(1), surf.end(1), 9)
        U,V  = np.meshgrid(u,v)
        pt   = surf(U,V)
        pt2  = surf2(U,V)

        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_volume_3D_p334(self):
        controlpoints = np.array([[  2.,  -1.,  -1.],       [ 12.,  -1.,  -3.],       [ 32.,   4.,   1.],       [ 38.,  -3.,  -5.],       [ 54.,  -3.,  -3.],       [ 67.,  -4.,  -5.],       [ 81.,   2.,  -4.],       [103.,   1.,  -1.],       [  4.,  29.,  -5.],       [ 11.,  31.,   2.],       [ 29.,  28.,  -5.],       [ 41.,  29.,  -1.],       [ 55.,  36.,  -2.],       [ 70.,  31.,  -3.],       [ 89.,  29.,  -2.],       [100.,  35.,  -5.],       [  4.,  67.,   3.],       [ 16.,  68.,   0.],       [ 31.,  67.,   3.],       [ 39.,  67.,  -2.],       [ 57.,  69.,   2.],       [ 72.,  70.,   1.],       [ 87.,  64.,   1.],       [ 98.,  68.,   4.],       [ -3.,  97.,   2.],       [ 16.,  95.,  -2.],       [ 27., 101.,   2.],       [ 38.,  99.,  -2.],       [ 60., 102.,  -2.],       [ 68.,  99.,   4.],       [ 88., 100.,   4.],       [100.,  96.,  -3.],       [  3.,   3.,  15.],       [  9.,   0.,  14.],       [ 29.,  -4.,  15.],       [ 44.,  -3.,  10.],       [ 56.,  -5.,  13.],       [ 74.,  -1.,  12.],       [ 86.,  -5.,  13.],       [ 96.,  -5.,  14.],       [  4.,  31.,  14.],       [ 18.,  32.,  11.],       [ 24.,  33.,  11.],       [ 39.,  36.,  15.],       [ 59.,  32.,  14.],       [ 66.,  37.,   8.],       [ 83.,  36.,   8.],       [102.,  31.,  15.],       [ -1.,  62.,   8.],       [ 16.,  62.,  13.],       [ 31.,  63.,  17.],       [ 44.,  67.,  16.],       [ 60.,  62.,  14.],       [ 75.,  70.,  13.],       [ 80.,  66.,   9.],       [104.,  67.,  14.],       [  4.,  95.,  10.],       [ 14., 103.,  12.],       [ 29., 104.,  16.],       [ 47.,  97.,  15.],       [ 53.,  98.,   8.],       [ 68.,  99.,   7.],       [ 86., 101.,  17.],       [ 98., 100.,   8.],       [ -2.,   3.,  25.],       [ 15.,   3.,  22.],       [ 28.,  -2.,  27.],       [ 39.,   3.,  28.],       [ 60.,  -3.,  26.],       [ 73.,   4.,  28.],       [ 90.,  -4.,  23.],       [ 99.,   0.,  21.],       [ -4.,  32.,  22.],       [ 18.,  37.,  21.],       [ 30.,  35.,  27.],       [ 39.,  33.,  29.],       [ 59.,  30.,  28.],       [ 67.,  30.,  21.],       [ 86.,  37.,  25.],       [ 95.,  34.,  25.],       [  1.,  68.,  28.],       [ 13.,  61.,  27.],       [ 28.,  69.,  21.],       [ 45.,  65.,  21.],       [ 57.,  66.,  29.],       [ 74.,  64.,  28.],       [ 89.,  65.,  21.],       [103.,  69.,  21.],       [ -2., 102.,  21.],       [ 13., 101.,  26.],       [ 33.,  97.,  29.],       [ 47.,  98.,  20.],       [ 59., 100.,  22.],       [ 73.,  96.,  27.],       [ 85.,  98.,  26.],       [ 99.,  96.,  22.],       [ -2.,   3.,  34.],       [ 15.,   3.,  36.],       [ 29.,  -3.,  36.],       [ 45.,  -1.,  33.],       [ 61.,  -5.,  39.],       [ 70.,  -5.,  34.],       [ 82.,   2.,  37.],       [100.,  -1.,  34.],       [  1.,  35.,  36.],       [ 18.,  36.,  33.],       [ 31.,  33.,  32.],       [ 45.,  30.,  38.],       [ 55.,  33.,  37.],       [ 76.,  34.,  41.],       [ 84.,  30.,  34.],       [102.,  29.,  35.],       [  0.,  70.,  34.],       [ 18.,  68.,  36.],       [ 32.,  62.,  34.],       [ 42.,  62.,  34.],       [ 53.,  64.,  42.],       [ 74.,  71.,  41.],       [ 88.,  71.,  39.],       [102.,  64.,  39.],       [  2.,  98.,  32.],       [ 17., 102.,  38.],       [ 31., 103.,  38.],       [ 42., 100.,  38.],       [ 55.,  99.,  42.],       [ 66.,  95.,  39.],       [ 83., 102.,  35.],       [104.,  96.,  39.],       [ -1.,   1.,  48.],       [ 16.,  -4.,  46.],       [ 26.,   4.,  51.],       [ 40.,  -3.,  51.],       [ 59.,  -1.,  50.],       [ 75.,  -1.,  54.],       [ 85.,  -5.,  54.],       [ 99.,   3.,  47.],       [  1.,  35.,  48.],       [ 16.,  32.,  50.],       [ 33.,  29.,  48.],       [ 40.,  33.,  47.],       [ 59.,  37.,  46.],       [ 68.,  34.,  52.],       [ 83.,  34.,  54.],       [102.,  37.,  47.],       [  2.,  69.,  51.],       [ 19.,  71.,  54.],       [ 30.,  62.,  53.],       [ 45.,  62.,  53.],       [ 58.,  69.,  50.],       [ 75.,  68.,  48.],       [ 82.,  64.,  51.],       [104.,  64.,  46.],       [  4., 104.,  52.],       [ 15., 103.,  49.],       [ 28., 100.,  51.],       [ 46.,  95.,  46.],       [ 60., 101.,  48.],       [ 74., 100.,  54.],       [ 83.,  96.,  47.],       [100., 101.,  53.],       [ -1.,  -3.,  62.],       [ 13.,  -2.,  58.],       [ 25.,   3.,  66.],       [ 39.,  -5.,  62.],       [ 56.,  -3.,  57.],       [ 73.,   0.,  63.],       [ 83.,  -3.,  63.],       [102.,  -1.,  59.],       [ -1.,  36.,  58.],       [ 19.,  36.,  65.],       [ 27.,  31.,  67.],       [ 40.,  34.,  63.],       [ 58.,  34.,  64.],       [ 72.,  36.,  62.],       [ 88.,  34.,  67.],       [104.,  30.,  60.],       [  0.,  63.,  57.],       [ 17.,  68.,  64.],       [ 30.,  69.,  57.],       [ 37.,  63.,  66.],       [ 56.,  69.,  63.],       [ 75.,  63.,  67.],       [ 90.,  67.,  60.],       [103.,  62.,  66.],       [ -4., 100.,  67.],       [ 18., 102.,  58.],       [ 26., 101.,  64.],       [ 43.,  96.,  61.],       [ 60., 100.,  59.],       [ 68., 104.,  61.],       [ 88.,  98.,  60.],       [ 95.,  99.,  66.],       [ -3.,  -1.,  77.],       [ 11.,  -1.,  72.],       [ 27.,   4.,  77.],       [ 42.,   1.,  74.],       [ 59.,   3.,  74.],       [ 76.,   0.,  75.],       [ 84.,   3.,  76.],       [101.,   1.,  77.],       [  3.,  31.,  74.],       [ 10.,  29.,  76.],       [ 31.,  29.,  79.],       [ 43.,  32.,  79.],       [ 59.,  29.,  76.],       [ 73.,  34.,  77.],       [ 80.,  37.,  71.],       [100.,  30.,  70.],       [ -5.,  68.,  70.],       [ 16.,  71.,  77.],       [ 27.,  64.,  71.],       [ 39.,  63.,  78.],       [ 53.,  61.,  77.],       [ 68.,  63.,  77.],       [ 86.,  63.,  78.],       [100.,  66.,  75.],       [ -3., 100.,  75.],       [ 18., 102.,  70.],       [ 32.,  98.,  79.],       [ 44.,  97.,  77.],       [ 58., 104.,  79.],       [ 68.,  96.,  76.],       [ 81.,  95.,  78.],       [ 99., 100.,  71.],       [ -5.,   1.,  83.],       [ 12.,   2.,  90.],       [ 24.,   4.,  87.],       [ 42.,   3.,  89.],       [ 57.,  -2.,  91.],       [ 69.,  -5.,  92.],       [ 90.,   1.,  92.],       [100.,   2.,  89.],       [ -1.,  31.,  88.],       [ 17.,  32.,  89.],       [ 33.,  34.,  84.],       [ 39.,  37.,  87.],       [ 58.,  31.,  87.],       [ 71.,  34.,  87.],       [ 89.,  35.,  83.],       [ 96.,  30.,  88.],       [  1.,  71.,  90.],       [ 13.,  64.,  85.],       [ 27.,  65.,  92.],       [ 44.,  65.,  84.],       [ 55.,  68.,  84.],       [ 71.,  67.,  90.],       [ 83.,  69.,  90.],       [ 99.,  62.,  83.],       [ -2., 102.,  87.],       [ 11.,  96.,  83.],       [ 28.,  95.,  90.],       [ 41., 100.,  86.],       [ 55.,  97.,  92.],       [ 76.,  96.,  90.],       [ 87., 100.,  91.],       [103.,  95.,  86.],       [  1.,  -3.,  97.],       [ 16.,  -2.,  99.],       [ 26.,  -1.,  96.],       [ 43.,   0.,  98.],       [ 60.,  -4.,  95.],       [ 71.,  -2., 103.],       [ 89.,  -3., 101.],       [ 98.,   1., 104.],       [ -5.,  35., 102.],       [ 14.,  31., 102.],       [ 30.,  30.,  95.],       [ 41.,  38.,  95.],       [ 53.,  29.,  96.],       [ 66.,  34.,  98.],       [ 82.,  34.,  96.],       [ 96.,  29.,  98.],       [ -2.,  64.,  99.],       [ 10.,  69., 103.],       [ 24.,  64., 102.],       [ 44.,  68., 100.],       [ 61.,  69.,  99.],       [ 67.,  62., 100.],       [ 90.,  68.,  96.],       [ 97.,  62., 104.],       [  1., 103.,  96.],       [ 13., 101.,  96.],       [ 32., 102., 101.],       [ 40.,  96.,  99.],       [ 54., 101.,  98.],       [ 68.,  99.,  96.],       [ 84., 100., 102.],       [ 99., 103.,  99.]])
        n1   = 8
        p1   = 3
        knot1= np.array([0. , 0. , 0. , 1.3, 1.9, 3. , 4.3, 5.4, 6. , 6. , 6. ])
        n2   = 4
        p2   = 3
        knot2= np.array([0. , 0. , 0. , 1.2, 2. , 2. , 2. ])
        n3   = 9
        p3   = 4
        knot3= np.array([0. , 0. , 0. , 0. , 1.1, 2.3, 2.7, 4.2, 4.7, 6. , 6. , 6. , 6. ])
        vol  = lr.LRSplineVolume(n1,n2,n3,p1,p2,p3,knot1,knot2,knot3,controlpoints)
        vol2 = vol.clone()
        vol2.insert_knot([4.304], 0, 1) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 12)
        vol2.insert_knot([4.593], 0, 2) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 14)
        vol2.insert_knot([2.971], 2, 1) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 14)
        vol2.insert_knot([2.530], 2, 2) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 16)
        vol2.insert_knot([1.644], 2, 3) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 19)

        u    = np.linspace(vol.start(0), vol.end(0), 7)
        v    = np.linspace(vol.start(1), vol.end(1), 7)
        w    = np.linspace(vol.start(2), vol.end(2), 7)
        U,V,W= np.meshgrid(u,v,w)
        pt   = vol(U,V,W)
        pt2  = vol2(U,V,W)
        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_surface_5D_p24(self):
        controlpoints = np.array([[  1.,  -5.,  -4.,   4.,  -1.],       [ 22.,  -5.,   0.,   1.,   4.],       [ 35.,   2.,   3.,   1.,   1.],       [ 59.,  -2.,  -5.,   0.,   4.],       [ 80.,   4.,   3.,  -5.,  -3.],       [101.,   1.,  -4.,  -3.,  -3.],       [  2.,  14.,   2.,   2.,   4.],       [ 22.,  14.,   3.,  -3.,  -2.],       [ 36.,  16.,   4.,  -1.,   3.],       [ 60.,   9.,  -3.,  -3.,   2.],       [ 79.,  17.,   0.,   3.,  -4.],       [102.,  18.,  -5.,  -5.,   3.],       [  0.,  25.,  -1.,   2.,   1.],       [ 18.,  25.,  -2.,  -1.,   2.],       [ 35.,  31.,  -3.,  -1.,   1.],       [ 55.,  29.,   2.,  -4.,   4.],       [ 83.,  25.,  -1.,   0.,  -2.],       [ 95.,  27.,  -1.,   2.,  -4.],       [  2.,  40.,  -5.,  -1.,  -4.],       [ 15.,  38.,  -2.,  -3.,  -5.],       [ 42.,  40.,   3.,  -1.,   4.],       [ 56.,  44.,   1.,  -3.,   0.],       [ 79.,  47.,  -2.,  -1.,  -4.],       [ 97.,  39.,  -5.,  -5.,  -3.],       [  0.,  56.,  -1.,  -5.,   2.],       [ 21.,  55.,   2.,  -2.,  -4.],       [ 40.,  58.,   3.,  -4.,   4.],       [ 55.,  59.,  -2.,  -5.,   3.],       [ 79.,  55.,   0.,  -3.,   2.],       [101.,  53.,   1.,   1.,  -1.],       [ -5.,  66.,  -4.,   3.,   4.],       [ 17.,  74.,   1.,  -1.,  -4.],       [ 42.,  66.,   0.,   0.,  -2.],       [ 64.,  67.,   0.,  -3.,  -2.],       [ 79.,  68.,  -2.,  -3.,   3.],       [ 96.,  72.,   0.,   1.,  -4.],       [  2.,  86.,  -5.,  -3.,   4.],       [ 19.,  81.,  -1.,   0.,   0.],       [ 43.,  87.,  -4.,   2.,  -3.],       [ 61.,  81.,   1.,   4.,   1.],       [ 83.,  83.,  -2.,  -1.,  -5.],       [102.,  81.,   3.,   2.,  -3.],       [  0., 101.,   4.,  -4.,   4.],       [ 19.,  98.,   3.,  -3.,   2.],       [ 39.,  98.,  -4.,   1.,   2.],       [ 61., 104.,  -3.,   1.,  -2.],       [ 77.,  98.,   1.,  -2.,   1.],       [102., 102.,  -2.,   3.,   4.]])
        n1   = 6
        p1   = 2
        knot1= np.array([0. , 0. , 0.8, 1.6, 3.2, 4.2, 5. , 5. ])
        n2   = 8
        p2   = 4
        knot2= np.array([0. , 0. , 0. , 0. , 0.7, 2.1, 3.2, 4. , 5. , 5. , 5. , 5. ])
        surf  = lr.LRSplineSurface(n1,n2,p1,p2,knot1,knot2, controlpoints)
        surf2 = surf.clone()
        surf2.insert_knot([3.857], 0, 1) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 9)
        surf2.insert_knot([1.394], 1, 1) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 13)
        surf2.insert_knot([0.902], 1, 2) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 15)
        surf2.insert_knot([2.666], 1, 3) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 18)

        u    = np.linspace(surf.start(0), surf.end(0), 9)
        v    = np.linspace(surf.start(1), surf.end(1), 9)
        U,V  = np.meshgrid(u,v)
        pt   = surf(U,V)
        pt2  = surf2(U,V)

        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_volume_5D_p222(self):
        controlpoints = np.array([[ -4.,  -3.,  -3.,  -3.,   0.],       [ 49.,   2.,   3.,  -1.,   4.],       [104.,   1.,  -1.,   4.,   0.],       [  3.,  30.,   0.,   1.,   1.],       [ 51.,  29.,   0.,   3.,   2.],       [ 95.,  30.,  -4.,  -3.,   4.],       [  4.,  64.,   1.,  -2.,   4.],       [ 46.,  68.,   2.,   2.,  -3.],       [100.,  69.,  -4.,  -4.,  -1.],       [  1.,  98.,  -3.,  -1.,   2.],       [ 53.,  96.,  -2.,  -2.,   4.],       [ 96., 100.,  -2.,   3.,   1.],       [  2.,   3.,  36.,  -3.,   2.],       [ 53.,  -1.,  34.,  -5.,  -4.],       [ 98.,   2.,  34.,   1.,   0.],       [ -3.,  30.,  33.,   3.,  -4.],       [ 47.,  36.,  31.,  -4.,   0.],       [104.,  37.,  31.,   0.,  -2.],       [  3.,  69.,  31.,   0.,  -4.],       [ 53.,  69.,  38.,   3.,   3.],       [ 99.,  64.,  28.,  -5.,  -3.],       [ -3., 103.,  36.,  -5.,  -4.],       [ 45., 103.,  32.,  -5.,  -4.],       [103.,  99.,  32.,  -2.,   2.],       [  1.,  -1.,  70.,  -4.,  -2.],       [ 45.,   1.,  66.,  -2.,   4.],       [ 98.,  -3.,  62.,  -1.,   1.],       [ -4.,  29.,  62.,  -2.,  -3.],       [ 51.,  36.,  69.,   0.,  -4.],       [103.,  29.,  67.,   1.,  -2.],       [ -3.,  66.,  64.,  -5.,  -3.],       [ 50.,  71.,  67.,   3.,   3.],       [101.,  71.,  66.,  -4.,  -4.],       [ -3.,  98.,  62.,  -1.,   2.],       [ 48., 101.,  67.,  -5.,   4.],       [ 97.,  97.,  64.,  -3.,  -4.],       [  0.,  -5., 100.,   0.,  -3.],       [ 45.,   3.,  96.,  -5.,   1.],       [100.,   2.,  96.,   0.,   4.],       [ -5.,  37.,  97.,  -4.,  -3.],       [ 47.,  30., 101.,  -3.,  -4.],       [ 97.,  29., 103.,  -5.,   2.],       [ -1.,  64.,  97.,  -5.,  -3.],       [ 51.,  64.,  95.,   3.,   2.],       [ 97.,  68.,  98.,  -3.,  -3.],       [ -1., 102.,  99.,  -2.,  -4.],       [ 45., 100.,  95.,   1.,  -5.],       [ 99., 104.,  98.,   2.,   4.]])
        n1   = 3
        p1   = 2
        knot1= np.array([0. , 0. , 0.7, 2. , 2. ])
        n2   = 4
        p2   = 2
        knot2= np.array([0. , 0. , 1.1, 2.2, 3. , 3. ])
        n3   = 4
        p3   = 2
        knot3= np.array([0. , 0. , 0.7, 2.1, 3. , 3. ])
        vol  = lr.LRSplineVolume(n1,n2,n3,p1,p2,p3,knot1,knot2,knot3,controlpoints)
        vol2 = vol.clone()
        vol2.insert_knot([1.396], 1, 1) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 7)
        vol2.insert_knot([1.806], 2, 1) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 7)

        u    = np.linspace(vol.start(0), vol.end(0), 7)
        v    = np.linspace(vol.start(1), vol.end(1), 7)
        w    = np.linspace(vol.start(2), vol.end(2), 7)
        U,V,W= np.meshgrid(u,v,w)
        pt   = vol(U,V,W)
        pt2  = vol2(U,V,W)
        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_surface_2D_p65(self):
        controlpoints = np.array([[ -4.,   3.],       [ 15.,  -1.],       [ 18.,   3.],       [ 34.,  -4.],       [ 47.,  -2.],       [ 56.,  -5.],       [ 62.,  -1.],       [ 80.,  -4.],       [ 92.,  -3.],       [103.,   4.],       [ -2.,  24.],       [ 14.,  20.],       [ 25.,  16.],       [ 28.,  17.],       [ 40.,  15.],       [ 57.,  22.],       [ 64.,  16.],       [ 82.,  17.],       [ 92.,  20.],       [ 96.,  19.],       [  3.,  43.],       [ 11.,  43.],       [ 19.,  43.],       [ 34.,  41.],       [ 47.,  40.],       [ 59.,  43.],       [ 67.,  38.],       [ 80.,  40.],       [ 91.,  38.],       [101.,  35.],       [  2.,  64.],       [ 15.,  58.],       [ 22.,  55.],       [ 32.,  59.],       [ 44.,  55.],       [ 56.,  55.],       [ 68.,  61.],       [ 77.,  58.],       [ 93.,  59.],       [ 99.,  63.],       [  2.,  83.],       [ 10.,  78.],       [ 21.,  79.],       [ 35.,  83.],       [ 46.,  76.],       [ 56.,  81.],       [ 66.,  83.],       [ 76.,  83.],       [ 88.,  79.],       [ 98.,  80.],       [ -1., 103.],       [  8., 100.],       [ 22.,  97.],       [ 33., 103.],       [ 46.,  97.],       [ 54.,  95.],       [ 68.,  97.],       [ 81., 104.],       [ 89.,  97.],       [ 99.,  99.]])
        n1   = 10
        p1   = 6
        knot1= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.2, 2.4, 2.7, 4.1, 5. , 5. , 5. , 5. , 5. , 5. ])
        n2   = 6
        p2   = 5
        knot2= np.array([0. , 0. , 0. , 0. , 0. , 1.3, 2. , 2. , 2. , 2. , 2. ])
        surf  = lr.LRSplineSurface(n1,n2,p1,p2,knot1,knot2, controlpoints)
        surf2 = surf.clone()
        surf2.insert_knot([3.511], 0, 1) # insert C4-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 17)
        surf2.insert_knot([1.429], 0, 2) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 19)
        surf2.insert_knot([3.514], 0, 3) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 22)
        surf2.insert_knot([1.623], 0, 4) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 26)
        surf2.insert_knot([1.722], 0, 5) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 31)

        u    = np.linspace(surf.start(0), surf.end(0), 9)
        v    = np.linspace(surf.start(1), surf.end(1), 9)
        U,V  = np.meshgrid(u,v)
        pt   = surf(U,V)
        pt2  = surf2(U,V)

        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_surface_3D_p65(self):
        controlpoints = np.array([[  2.,   2.,   3.],       [ 13.,  -1.,  -5.],       [ 21.,   3.,   1.],       [ 34.,   3.,  -4.],       [ 44.,   0.,  -1.],       [ 50.,   4.,   2.],       [ 58.,  -4.,  -3.],       [ 71.,  -2.,   0.],       [ 81.,   1.,   0.],       [ 89.,  -4.,  -5.],       [ 98.,   2.,  -1.],       [  2.,  14.,  -2.],       [ 11.,   9.,   0.],       [ 17.,  13.,   1.],       [ 30.,  13.,   2.],       [ 44.,  18.,  -1.],       [ 48.,  11.,  -2.],       [ 56.,  10.,   0.],       [ 65.,  19.,  -2.],       [ 77.,  15.,  -5.],       [ 92.,  14.,   1.],       [ 98.,  14.,  -5.],       [ -2.,  29.,   3.],       [  5.,  25.,  -4.],       [ 24.,  32.,   3.],       [ 34.,  28.,   1.],       [ 35.,  29.,  -5.],       [ 48.,  31.,   2.],       [ 61.,  27.,  -3.],       [ 74.,  27.,  -4.],       [ 79.,  26.,  -3.],       [ 91.,  26.,   4.],       [ 98.,  31.,  -4.],       [  4.,  45.,   1.],       [ 11.,  47.,   3.],       [ 17.,  39.,   4.],       [ 26.,  42.,  -5.],       [ 39.,  45.,   4.],       [ 49.,  47.,  -3.],       [ 56.,  44.,  -4.],       [ 69.,  46.,   0.],       [ 81.,  38.,   4.],       [ 90.,  39.,   2.],       [102.,  42.,  -1.],       [  2.,  56.,  -2.],       [ 10.,  56.,  -4.],       [ 21.,  53.,  -2.],       [ 25.,  53.,  -3.],       [ 36.,  54.,   1.],       [ 48.,  52.,   1.],       [ 63.,  60.,  -4.],       [ 74.,  58.,  -1.],       [ 79.,  54.,  -4.],       [ 89.,  61.,  -3.],       [100.,  59.,   0.],       [  4.,  66.,  -1.],       [ 13.,  75.,   3.],       [ 17.,  71.,   1.],       [ 26.,  75.,  -1.],       [ 37.,  72.,   3.],       [ 52.,  66.,   4.],       [ 61.,  75.,   4.],       [ 67.,  70.,   3.],       [ 77.,  68.,   4.],       [ 85.,  71.,   2.],       [100.,  66.,   3.],       [  3.,  87.,  -5.],       [  9.,  84.,  -5.],       [ 19.,  88.,  -2.],       [ 32.,  82.,  -2.],       [ 39.,  89.,  -4.],       [ 50.,  87.,   0.],       [ 55.,  83.,   4.],       [ 65.,  84.,   2.],       [ 82.,  89.,   2.],       [ 92.,  89.,  -1.],       [103.,  84.,   1.],       [ -5., 102.,  -2.],       [ 12.,  97.,   4.],       [ 17.,  96.,   3.],       [ 29.,  96.,   4.],       [ 44., 101.,  -2.],       [ 45.,  99.,  -4.],       [ 64., 101.,   2.],       [ 74.,  97.,  -3.],       [ 83.,  97.,   1.],       [ 88.,  98.,   3.],       [ 98., 101.,  -4.]])
        n1   = 11
        p1   = 6
        knot1= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.1, 2.2, 3.3, 4. , 4.9, 6. , 6. , 6. , 6. , 6. , 6. ])
        n2   = 8
        p2   = 5
        knot2= np.array([0., 0., 0., 0., 0., 1., 2., 3., 4., 4., 4., 4., 4.])
        surf  = lr.LRSplineSurface(n1,n2,p1,p2,knot1,knot2, controlpoints)
        surf2 = surf.clone()
        surf2.insert_knot([4.355], 0, 1) # insert C4-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 18)
        surf2.insert_knot([3.665], 0, 2) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 20)
        surf2.insert_knot([2.652], 0, 3) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 23)
        surf2.insert_knot([3.662], 0, 4) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 27)
        surf2.insert_knot([1.289], 0, 5) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 32)
        surf2.insert_knot([1.324], 1, 1) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 14)
        surf2.insert_knot([1.071], 1, 2) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 16)
        surf2.insert_knot([1.629], 1, 3) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 19)
        surf2.insert_knot([1.495], 1, 4) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 23)

        u    = np.linspace(surf.start(0), surf.end(0), 9)
        v    = np.linspace(surf.start(1), surf.end(1), 9)
        U,V  = np.meshgrid(u,v)
        pt   = surf(U,V)
        pt2  = surf2(U,V)

        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_volume_3D_p464(self):
        controlpoints = np.array([[  0.,  -3.,   0.],       [ 20.,  -3.,  -2.],       [ 35.,   1.,   0.],       [ 54.,  -4.,   1.],       [ 65.,   2.,  -4.],       [ 79.,  -1.,   2.],       [ 96.,  -1.,   1.],       [  4.,  12.,   0.],       [ 21.,  12.,  -5.],       [ 29.,  15.,  -4.],       [ 48.,  13.,  -1.],       [ 66.,  15.,   3.],       [ 82.,  14.,  -3.],       [ 99.,  15.,   0.],       [  4.,  24.,  -5.],       [ 15.,  28.,   3.],       [ 33.,  28.,   3.],       [ 54.,  22.,   0.],       [ 65.,  29.,   2.],       [ 88.,  23.,  -4.],       [ 95.,  20.,  -1.],       [  3.,  37.,   3.],       [ 12.,  37.,   0.],       [ 36.,  40.,   3.],       [ 47.,  41.,   2.],       [ 65.,  36.,  -4.],       [ 86.,  41.,  -2.],       [100.,  38.,   3.],       [ -2.,  49.,   2.],       [ 15.,  51.,  -2.],       [ 33.,  54.,   1.],       [ 53.,  45.,   3.],       [ 67.,  51.,  -2.],       [ 81.,  54.,   1.],       [ 98.,  49.,   1.],       [  4.,  64.,   0.],       [ 17.,  58.,   1.],       [ 30.,  66.,   0.],       [ 49.,  66.,  -2.],       [ 68.,  59.,   0.],       [ 85.,  59.,   3.],       [101.,  65.,  -3.],       [ -1.,  77.,  -2.],       [ 17.,  71.,   2.],       [ 36.,  79.,   3.],       [ 53.,  72.,   2.],       [ 69.,  79.,  -5.],       [ 81.,  70.,  -5.],       [101.,  73.,   4.],       [  4.,  83.,  -5.],       [ 18.,  87.,   3.],       [ 31.,  85.,  -2.],       [ 46.,  89.,   0.],       [ 66.,  92.,   1.],       [ 82.,  83.,   4.],       [ 98.,  91.,  -1.],       [  3., 104.,  -3.],       [ 16., 101.,   4.],       [ 29., 102.,   1.],       [ 53.,  95.,  -3.],       [ 66., 101.,  -3.],       [ 81.,  99.,   3.],       [100.,  97.,   4.],       [ -4.,  -3.,  16.],       [ 18.,   3.,  13.],       [ 28.,   4.,  14.],       [ 51.,   3.,  12.],       [ 71.,   1.,  14.],       [ 83.,  -4.,  20.],       [102.,   4.,  18.],       [  2.,  15.,  12.],       [ 13.,   9.,  15.],       [ 35.,  13.,  13.],       [ 54.,  15.,  15.],       [ 63.,  17.,  13.],       [ 86.,   9.,  11.],       [102.,  14.,  14.],       [  4.,  29.,  18.],       [ 18.,  29.,  14.],       [ 28.,  28.,  17.],       [ 54.,  28.,  18.],       [ 70.,  20.,  16.],       [ 82.,  29.,  20.],       [ 95.,  23.,  18.],       [  1.,  42.,  14.],       [ 20.,  41.,  12.],       [ 30.,  36.,  19.],       [ 47.,  41.,  12.],       [ 68.,  34.,  19.],       [ 80.,  37.,  14.],       [ 95.,  39.,  20.],       [  2.,  53.,  14.],       [ 14.,  48.,  12.],       [ 35.,  49.,  13.],       [ 51.,  53.,  17.],       [ 69.,  51.,  13.],       [ 80.,  47.,  15.],       [100.,  47.,  16.],       [ -1.,  61.,  13.],       [ 12.,  64.,  19.],       [ 37.,  61.,  13.],       [ 50.,  63.,  17.],       [ 71.,  58.,  14.],       [ 86.,  65.,  12.],       [103.,  66.,  19.],       [  3.,  73.,  17.],       [ 16.,  71.,  12.],       [ 33.,  73.,  17.],       [ 45.,  75.,  19.],       [ 64.,  77.,  15.],       [ 82.,  76.,  16.],       [ 97.,  75.,  18.],       [  0.,  82.,  14.],       [ 12.,  92.,  13.],       [ 28.,  87.,  12.],       [ 48.,  90.,  15.],       [ 67.,  82.,  15.],       [ 80.,  91.,  13.],       [102.,  88.,  12.],       [ -4., 100.,  15.],       [ 17.,  95.,  15.],       [ 30., 104.,  21.],       [ 47.,  95.,  11.],       [ 62.,  99.,  17.],       [ 84., 100.,  19.],       [ 98., 101.,  12.],       [  0.,  -4.,  34.],       [ 17.,   4.,  34.],       [ 31.,  -2.,  31.],       [ 46.,  -4.,  32.],       [ 62.,   3.,  29.],       [ 78.,   1.,  35.],       [ 95.,   1.,  30.],       [  2.,  11.,  34.],       [ 17.,   8.,  36.],       [ 33.,  10.,  35.],       [ 49.,  12.,  28.],       [ 70.,  17.,  33.],       [ 78.,  10.,  35.],       [ 97.,  10.,  29.],       [ -1.,  20.,  32.],       [ 19.,  26.,  37.],       [ 37.,  23.,  36.],       [ 50.,  22.,  29.],       [ 66.,  22.,  31.],       [ 83.,  21.,  31.],       [ 95.,  25.,  37.],       [ -5.,  41.,  33.],       [ 19.,  40.,  32.],       [ 32.,  40.,  30.],       [ 49.,  39.,  34.],       [ 65.,  36.,  28.],       [ 85.,  41.,  31.],       [101.,  40.,  35.],       [  4.,  47.,  37.],       [ 17.,  50.,  31.],       [ 35.,  53.,  29.],       [ 45.,  46.,  29.],       [ 63.,  46.,  36.],       [ 84.,  46.,  36.],       [ 96.,  46.,  34.],       [  0.,  58.,  31.],       [ 15.,  57.,  28.],       [ 28.,  58.,  36.],       [ 47.,  58.,  34.],       [ 62.,  57.,  34.],       [ 85.,  66.,  36.],       [ 95.,  60.,  32.],       [ -2.,  79.,  33.],       [ 12.,  71.,  37.],       [ 33.,  74.,  35.],       [ 49.,  74.,  33.],       [ 63.,  79.,  37.],       [ 87.,  71.,  34.],       [ 96.,  77.,  32.],       [ -3.,  82.,  31.],       [ 19.,  86.,  35.],       [ 29.,  86.,  33.],       [ 48.,  88.,  33.],       [ 70.,  82.,  33.],       [ 85.,  87.,  28.],       [102.,  83.,  37.],       [  1., 104.,  28.],       [ 18.,  98.,  30.],       [ 33.,  97.,  31.],       [ 46.,  95.,  33.],       [ 68.,  98.,  33.],       [ 79., 104.,  30.],       [ 97., 100.,  34.],       [ -2.,   4.,  51.],       [ 17.,   1.,  50.],       [ 35.,  -4.,  52.],       [ 53.,   2.,  47.],       [ 69.,  -1.,  54.],       [ 85.,   2.,  51.],       [ 96.,   0.,  51.],       [ -5.,   8.,  51.],       [ 21.,  12.,  46.],       [ 33.,  16.,  45.],       [ 53.,  10.,  49.],       [ 62.,  16.,  54.],       [ 81.,  10.,  45.],       [104.,  15.,  47.],       [  0.,  22.,  52.],       [ 15.,  29.,  49.],       [ 29.,  20.,  51.],       [ 49.,  27.,  52.],       [ 69.,  23.,  45.],       [ 82.,  24.,  54.],       [ 99.,  26.,  49.],       [  1.,  39.,  52.],       [ 19.,  40.,  47.],       [ 37.,  36.,  47.],       [ 45.,  38.,  52.],       [ 67.,  40.,  47.],       [ 84.,  39.,  47.],       [100.,  42.,  45.],       [  0.,  47.,  52.],       [ 20.,  47.,  53.],       [ 31.,  46.,  49.],       [ 51.,  46.,  51.],       [ 66.,  47.,  54.],       [ 78.,  47.,  53.],       [100.,  48.,  46.],       [  2.,  61.,  54.],       [ 15.,  67.,  51.],       [ 31.,  57.,  54.],       [ 49.,  63.,  53.],       [ 71.,  66.,  52.],       [ 79.,  63.,  46.],       [102.,  60.,  48.],       [ -1.,  78.,  51.],       [ 20.,  79.,  50.],       [ 33.,  79.,  50.],       [ 49.,  71.,  54.],       [ 69.,  73.,  52.],       [ 82.,  75.,  48.],       [100.,  72.,  54.],       [ -3.,  82.,  45.],       [ 17.,  87.,  47.],       [ 33.,  90.,  45.],       [ 52.,  85.,  48.],       [ 64.,  82.,  49.],       [ 82.,  84.,  53.],       [100.,  86.,  49.],       [ -4.,  99.,  53.],       [ 13., 100.,  50.],       [ 36., 104.,  53.],       [ 52.,  97.,  54.],       [ 66.,  97.,  54.],       [ 79.,  97.,  47.],       [ 99.,  96.,  45.],       [ -1.,   4.,  70.],       [ 17.,   1.,  67.],       [ 33.,  -4.,  67.],       [ 50.,   1.,  67.],       [ 68.,  -4.,  62.],       [ 81.,   0.,  70.],       [101.,   4.,  61.],       [ -1.,  13.,  62.],       [ 17.,  16.,  69.],       [ 34.,   8.,  62.],       [ 54.,  12.,  64.],       [ 67.,  10.,  62.],       [ 84.,  17.,  62.],       [ 96.,  13.,  65.],       [  2.,  29.,  70.],       [ 11.,  27.,  68.],       [ 37.,  25.,  64.],       [ 50.,  26.,  70.],       [ 68.,  26.,  66.],       [ 80.,  26.,  67.],       [100.,  20.,  67.],       [ -2.,  40.,  67.],       [ 12.,  34.,  64.],       [ 37.,  36.,  64.],       [ 48.,  36.,  64.],       [ 71.,  37.,  65.],       [ 86.,  36.,  64.],       [102.,  34.,  66.],       [  4.,  46.,  64.],       [ 14.,  53.,  66.],       [ 31.,  46.,  65.],       [ 49.,  49.,  69.],       [ 70.,  48.,  67.],       [ 82.,  46.,  65.],       [ 99.,  49.,  63.],       [ -1.,  62.,  62.],       [ 18.,  64.,  63.],       [ 33.,  66.,  69.],       [ 48.,  65.,  61.],       [ 70.,  62.,  63.],       [ 79.,  58.,  69.],       [104.,  60.,  64.],       [ -3.,  74.,  67.],       [ 16.,  76.,  66.],       [ 35.,  70.,  69.],       [ 47.,  75.,  63.],       [ 68.,  75.,  68.],       [ 79.,  71.,  71.],       [ 98.,  72.,  68.],       [  1.,  90.,  69.],       [ 20.,  91.,  66.],       [ 33.,  82.,  70.],       [ 54.,  82.,  68.],       [ 66.,  86.,  66.],       [ 84.,  85.,  63.],       [ 96.,  91.,  66.],       [ -4.,  96.,  64.],       [ 21., 100.,  62.],       [ 34.,  96.,  63.],       [ 46.,  95.,  71.],       [ 64.,  98.,  66.],       [ 84., 102.,  65.],       [ 97.,  99.,  70.],       [  3.,   1.,  80.],       [ 12.,   2.,  88.],       [ 38.,   4.,  83.],       [ 45.,   4.,  83.],       [ 65.,  -5.,  82.],       [ 81.,   0.,  80.],       [ 98.,  -3.,  85.],       [ -2.,  16.,  82.],       [ 20.,  13.,  81.],       [ 36.,  16.,  85.],       [ 49.,  17.,  81.],       [ 65.,   7.,  86.],       [ 82.,  13.,  84.],       [ 97.,  11.,  88.],       [ -2.,  29.,  86.],       [ 12.,  23.,  82.],       [ 35.,  29.,  78.],       [ 49.,  27.,  79.],       [ 71.,  28.,  86.],       [ 82.,  22.,  83.],       [100.,  20.,  82.],       [ -5.,  36.,  86.],       [ 21.,  38.,  87.],       [ 37.,  34.,  86.],       [ 54.,  33.,  82.],       [ 66.,  35.,  86.],       [ 84.,  38.,  86.],       [101.,  41.,  83.],       [ -1.,  49.,  85.],       [ 14.,  49.,  86.],       [ 29.,  54.,  82.],       [ 52.,  45.,  86.],       [ 68.,  51.,  84.],       [ 81.,  49.,  83.],       [ 96.,  53.,  80.],       [ -5.,  67.,  86.],       [ 16.,  59.,  84.],       [ 32.,  63.,  79.],       [ 45.,  60.,  86.],       [ 62.,  67.,  85.],       [ 86.,  63.,  86.],       [ 97.,  66.,  82.],       [ -5.,  79.,  83.],       [ 12.,  75.,  78.],       [ 36.,  75.,  85.],       [ 52.,  78.,  84.],       [ 62.,  77.,  85.],       [ 84.,  71.,  81.],       [101.,  73.,  85.],       [  4.,  87.,  86.],       [ 18.,  83.,  81.],       [ 30.,  85.,  84.],       [ 53.,  82.,  86.],       [ 69.,  92.,  83.],       [ 81.,  84.,  85.],       [100.,  91.,  80.],       [ -3.,  96.,  82.],       [ 12.,  97.,  87.],       [ 30.,  96.,  79.],       [ 50., 101.,  84.],       [ 65., 102.,  79.],       [ 79., 103.,  87.],       [ 98.,  97.,  81.],       [  1.,  -5.,  97.],       [ 12.,   3., 100.],       [ 32.,  -1.,  99.],       [ 47.,   4.,  96.],       [ 68.,   2.,  95.],       [ 87.,   0., 102.],       [ 97.,  -3.,  97.],       [  1.,  13.,  99.],       [ 16.,  17.,  99.],       [ 28.,  16., 103.],       [ 47.,  14.,  95.],       [ 63.,  13., 102.],       [ 84.,  11.,  98.],       [ 95.,  11., 102.],       [  1.,  29.,  96.],       [ 19.,  26., 101.],       [ 31.,  26.,  99.],       [ 45.,  22., 103.],       [ 71.,  22.,  95.],       [ 84.,  23.,  99.],       [104.,  29., 102.],       [ -1.,  39.,  96.],       [ 18.,  33., 104.],       [ 36.,  40.,  97.],       [ 47.,  33.,  96.],       [ 62.,  38., 102.],       [ 86.,  34., 103.],       [102.,  34.,  99.],       [  0.,  53., 102.],       [ 15.,  49., 104.],       [ 28.,  45., 103.],       [ 50.,  53., 104.],       [ 63.,  47.,  95.],       [ 81.,  46., 100.],       [ 98.,  49.,  99.],       [  3.,  60.,  98.],       [ 13.,  63., 103.],       [ 31.,  60.,  98.],       [ 48.,  60.,  95.],       [ 64.,  63.,  97.],       [ 86.,  65., 104.],       [104.,  66., 103.],       [  3.,  74.,  99.],       [ 12.,  73.,  96.],       [ 29.,  76., 102.],       [ 54.,  75., 101.],       [ 69.,  73., 102.],       [ 84.,  71.,  99.],       [100.,  75., 104.],       [  3.,  89.,  97.],       [ 17.,  88.,  98.],       [ 34.,  86.,  95.],       [ 54.,  85., 101.],       [ 68.,  84., 104.],       [ 82.,  86., 100.],       [100.,  84., 102.],       [ -2., 100., 103.],       [ 18., 104., 100.],       [ 37.,  98., 104.],       [ 52., 103.,  98.],       [ 68.,  96.,  97.],       [ 78.,  95., 104.],       [103., 101.,  99.]])
        n1   = 7
        p1   = 4
        knot1= np.array([0. , 0. , 0. , 0. , 1. , 1.9, 3. , 4. , 4. , 4. , 4. ])
        n2   = 9
        p2   = 6
        knot2= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.2, 2.1, 2.7, 4. , 4. , 4. , 4. , 4. , 4. ])
        n3   = 7
        p3   = 4
        knot3= np.array([0. , 0. , 0. , 0. , 0.8, 2.1, 3. , 4. , 4. , 4. , 4. ])
        vol  = lr.LRSplineVolume(n1,n2,n3,p1,p2,p3,knot1,knot2,knot3,controlpoints)
        vol2 = vol.clone()
        vol2.insert_knot([2.808], 0, 1) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 12)
        vol2.insert_knot([2.025], 0, 2) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 14)
        vol2.insert_knot([1.205], 0, 3) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 17)
        vol2.insert_knot([2.647], 1, 1) # insert C4-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 16)
        vol2.insert_knot([1.844], 1, 2) # insert C3-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 18)
        vol2.insert_knot([1.715], 1, 3) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 21)
        vol2.insert_knot([2.627], 1, 4) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 25)
        vol2.insert_knot([1.206], 1, 5) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 30)
        vol2.insert_knot([1.226], 2, 1) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 12)
        vol2.insert_knot([1.402], 2, 2) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 14)
        vol2.insert_knot([1.987], 2, 3) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 17)

        u    = np.linspace(vol.start(0), vol.end(0), 7)
        v    = np.linspace(vol.start(1), vol.end(1), 7)
        w    = np.linspace(vol.start(2), vol.end(2), 7)
        U,V,W= np.meshgrid(u,v,w)
        pt   = vol(U,V,W)
        pt2  = vol2(U,V,W)
        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_surface_5D_p66(self):
        controlpoints = np.array([[ -3.,  -3.,  -1.,  -5.,   2.],       [ 13.,  -5.,  -5.,  -3.,   4.],       [ 24.,   2.,   1.,  -5.,   0.],       [ 36.,  -3.,  -2.,  -1.,   1.],       [ 40.,  -3.,   1.,  -4.,  -2.],       [ 52.,  -1.,  -3.,  -4.,  -3.],       [ 61.,   0.,   2.,   2.,   0.],       [ 81.,   0.,  -1.,  -5.,   3.],       [ 88.,  -1.,   2.,  -3.,  -4.],       [104.,  -3.,  -5.,  -2.,  -2.],       [ -2.,  13.,   4.,   4.,   1.],       [  7.,  12.,  -1.,  -5.,   2.],       [ 26.,  13.,   0.,  -2.,  -3.],       [ 34.,  18.,  -1.,   4.,   3.],       [ 49.,  18.,  -2.,   1.,  -4.],       [ 51.,  20.,   2.,  -1.,  -3.],       [ 66.,  14.,  -1.,   0.,  -2.],       [ 80.,  21.,   0.,   0.,  -1.],       [ 92.,  21.,  -1.,  -4.,  -3.],       [102.,  21.,  -2.,  -2.,   2.],       [ -3.,  29.,  -5.,   4.,  -5.],       [ 14.,  34.,  -2.,   4.,   1.],       [ 19.,  35.,  -3.,   3.,   2.],       [ 32.,  34.,  -5.,   4.,  -4.],       [ 48.,  35.,  -5.,  -5.,   1.],       [ 51.,  30.,   3.,  -4.,  -1.],       [ 70.,  35.,  -5.,  -2.,   0.],       [ 80.,  35.,   3.,   0.,  -2.],       [ 88.,  32.,  -4.,  -3.,  -2.],       [ 95.,  32.,   3.,  -1.,   0.],       [  1.,  53.,   4.,  -4.,   3.],       [  9.,  51.,  -5.,  -1.,   2.],       [ 26.,  52.,  -2.,   4.,   3.],       [ 34.,  48.,   4.,  -5.,  -3.],       [ 44.,  52.,   3.,   0.,   3.],       [ 53.,  45.,  -1.,   1.,  -3.],       [ 65.,  47.,  -4.,   4.,  -4.],       [ 81.,  45.,  -2.,   1.,   0.],       [ 90.,  45.,  -1.,  -1.,   4.],       [ 95.,  50.,   0.,   1.,  -1.],       [  2.,  71.,  -4.,   4.,   3.],       [  9.,  67.,  -4.,   2.,   2.],       [ 19.,  71.,   3.,   2.,  -5.],       [ 34.,  69.,  -3.,   0.,  -3.],       [ 46.,  61.,   4.,  -1.,   4.],       [ 60.,  65.,  -3.,   1.,  -5.],       [ 63.,  66.,   4.,   3.,  -2.],       [ 78.,  61.,   0.,   4.,  -2.],       [ 91.,  70.,  -2.,  -2.,   2.],       [101.,  68.,  -2.,  -3.,   3.],       [ -1.,  81.,   2.,  -5.,  -1.],       [ 12.,  82.,   4.,   0.,  -4.],       [ 18.,  83.,  -3.,   1.,   1.],       [ 33.,  88.,  -3.,  -4.,   4.],       [ 40.,  88.,   1.,   3.,   4.],       [ 51.,  88.,  -5.,  -2.,  -3.],       [ 65.,  79.,  -5.,  -3.,   0.],       [ 81.,  82.,   4.,   4.,  -4.],       [ 87.,  87.,  -3.,  -5.,  -5.],       [ 99.,  78.,  -4.,  -2.,   2.],       [  4.,  98.,   0.,   1.,   3.],       [ 11., 101.,  -4.,  -3.,  -1.],       [ 19.,  97.,   3.,   2.,   1.],       [ 37.,  97.,   1.,   0.,   4.],       [ 42., 102.,  -1.,   2.,   4.],       [ 58., 100.,   2.,  -3.,   1.],       [ 71.,  98.,  -4.,  -1.,  -2.],       [ 73.,  95.,   1.,  -2.,  -4.],       [ 89.,  99.,  -2.,   3.,  -5.],       [ 99.,  97.,  -2.,   1.,   3.]])
        n1   = 10
        p1   = 6
        knot1= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.1, 2.3, 3. , 4.1, 5. , 5. , 5. , 5. , 5. , 5. ])
        n2   = 7
        p2   = 6
        knot2= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.2, 2. , 2. , 2. , 2. , 2. , 2. ])
        surf  = lr.LRSplineSurface(n1,n2,p1,p2,knot1,knot2, controlpoints)
        surf2 = surf.clone()
        surf2.insert_knot([3.253], 0, 1) # insert C4-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 17)
        surf2.insert_knot([2.333], 0, 2) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 19)
        surf2.insert_knot([1.128], 0, 3) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 22)
        surf2.insert_knot([2.858], 0, 4) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 26)
        surf2.insert_knot([3.985], 0, 5) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 31)

        u    = np.linspace(surf.start(0), surf.end(0), 9)
        v    = np.linspace(surf.start(1), surf.end(1), 9)
        U,V  = np.meshgrid(u,v)
        pt   = surf(U,V)
        pt2  = surf2(U,V)

        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_volume_5D_p556(self):
        controlpoints = np.array([[  1.,   2.,   3.,   2.,   0.],       [ 12.,  -2.,  -1.,   4.,  -3.],       [ 23.,  -1.,  -1.,   4.,  -1.],       [ 40.,   0.,  -5.,  -5.,   3.],       [ 48.,  -3.,   1.,  -2.,   0.],       [ 66.,  -5.,   3.,  -1.,  -2.],       [ 75.,   3.,   3.,   3.,   3.],       [ 86.,  -5.,   2.,  -1.,  -3.],       [ 97.,   0.,   4.,   1.,  -2.],       [ -2.,  16.,   4.,   1.,  -1.],       [  9.,  15.,  -2.,  -4.,   4.],       [ 25.,  18.,  -5.,   2.,   2.],       [ 39.,  22.,  -1.,   0.,   1.],       [ 53.,  19.,   4.,  -1.,  -1.],       [ 60.,  22.,  -2.,  -3.,  -2.],       [ 78.,  24.,   2.,   2.,   0.],       [ 88.,  15.,   0.,   0.,  -3.],       [101.,  16.,   2.,   4.,  -4.],       [  1.,  44.,  -4.,   4.,   3.],       [ 16.,  43.,  -1.,   1.,  -3.],       [ 26.,  44.,  -3.,   4.,  -1.],       [ 36.,  39.,   2.,   3.,  -1.],       [ 50.,  44.,  -4.,   2.,  -2.],       [ 59.,  41.,  -3.,   1.,  -3.],       [ 70.,  40.,  -4.,   0.,  -2.],       [ 89.,  40.,   4.,   3.,   0.],       [ 95.,  41.,  -4.,  -2.,  -4.],       [ -3.,  56.,  -2.,   1.,  -5.],       [ 13.,  61.,   1.,  -2.,  -1.],       [ 24.,  63.,   0.,   2.,   2.],       [ 33.,  64.,   3.,   1.,   2.],       [ 46.,  60.,  -1.,  -5.,   0.],       [ 66.,  59.,   2.,   0.,   2.],       [ 76.,  60.,   4.,   1.,  -1.],       [ 84.,  63.,   2.,  -4.,  -3.],       [104.,  60.,   1.,   0.,   3.],       [ -2.,  75.,  -1.,   2.,   3.],       [ 12.,  77.,   0.,  -2.,   3.],       [ 24.,  79.,  -3.,  -3.,  -3.],       [ 40.,  79.,   0.,   2.,  -1.],       [ 47.,  81.,   0.,   4.,   2.],       [ 62.,  79.,  -1.,  -3.,   1.],       [ 74.,  75.,  -4.,   3.,  -3.],       [ 83.,  82.,   3.,  -1.,  -4.],       [104.,  83.,  -2.,   2.,  -5.],       [  2.,  98.,  -3.,   1.,  -5.],       [ 16., 103.,   1.,   0.,   0.],       [ 29.,  96.,   0.,  -5.,  -1.],       [ 41., 100.,   2.,  -2.,  -4.],       [ 48.,  97.,   0.,  -4.,   2.],       [ 66.,  95.,   4.,   4.,  -1.],       [ 71.,  99.,  -5.,  -3.,   1.],       [ 83., 100.,  -1.,  -3.,  -5.],       [101., 104.,   3.,  -1.,  -5.],       [ -5.,   4.,  14.,  -1.,  -2.],       [ 14.,  -1.,   5.,   4.,  -2.],       [ 23.,   2.,   9.,   4.,   0.],       [ 33.,  -3.,   5.,   0.,  -3.],       [ 53.,  -4.,   6.,   2.,  -4.],       [ 64.,   1.,  12.,  -5.,   1.],       [ 79.,   2.,  13.,   3.,  -3.],       [ 90.,   1.,  14.,  -2.,   2.],       [ 99.,   1.,   6.,  -3.,   1.],       [  4.,  23.,   5.,   0.,   1.],       [ 14.,  17.,   9.,   2.,   0.],       [ 22.,  22.,   8.,  -1.,   0.],       [ 33.,  24.,  12.,  -1.,  -2.],       [ 49.,  15.,  11.,   1.,  -3.],       [ 61.,  24.,  14.,  -1.,  -3.],       [ 77.,  20.,   6.,  -3.,   3.],       [ 84.,  23.,  12.,  -3.,  -4.],       [104.,  24.,   7.,   3.,  -1.],       [  4.,  40.,   9.,  -5.,  -2.],       [ 12.,  40.,  10.,   3.,  -1.],       [ 24.,  39.,  11.,   0.,   0.],       [ 38.,  38.,  12.,   0.,   4.],       [ 46.,  38.,  12.,   1.,   1.],       [ 61.,  44.,  14.,  -4.,   0.],       [ 76.,  35.,   5.,  -1.,  -5.],       [ 88.,  43.,   8.,   4.,  -4.],       [100.,  44.,   6.,  -4.,   4.],       [ -1.,  56.,  13.,  -5.,  -5.],       [  7.,  57.,  11.,  -5.,   1.],       [ 23.,  57.,  10.,   2.,  -2.],       [ 40.,  63.,   9.,   3.,   4.],       [ 46.,  59.,   7.,  -5.,   0.],       [ 64.,  60.,   9.,  -4.,   0.],       [ 70.,  64.,   5.,   0.,   2.],       [ 83.,  55.,   7.,  -1.,   4.],       [ 98.,  64.,  11.,  -1.,  -4.],       [  3.,  75.,   6.,  -5.,   2.],       [ 15.,  77.,   7.,  -1.,  -4.],       [ 23.,  79.,   6.,   4.,  -3.],       [ 40.,  79.,  12.,  -2.,  -3.],       [ 48.,  84.,   6.,   2.,  -2.],       [ 67.,  77.,   6.,   4.,   1.],       [ 76.,  83.,  11.,  -2.,   4.],       [ 92.,  77.,  13.,  -2.,   4.],       [103.,  79.,   6.,  -1.,   0.],       [  3.,  99.,  14.,   1.,   3.],       [ 15.,  99.,  10.,   0.,  -3.],       [ 20.,  98.,  13.,  -2.,   4.],       [ 39., 102.,   6.,   0.,   4.],       [ 46., 103.,  13.,   3.,   2.],       [ 63.,  99.,   7.,  -4.,  -2.],       [ 77., 102.,   7.,   4.,  -5.],       [ 90.,  96.,  12.,  -3.,   3.],       [ 95., 102.,   6.,   0.,  -2.],       [ -3.,  -5.,  22.,   2.,   1.],       [  8.,   1.,  20.,  -1.,  -3.],       [ 27.,   0.,  22.,  -2.,  -2.],       [ 36.,   2.,  22.,   1.,   3.],       [ 48.,  -4.,  16.,  -1.,   1.],       [ 61.,  -3.,  22.,   2.,   4.],       [ 70.,   2.,  23.,   2.,  -5.],       [ 84.,   1.,  19.,  -1.,  -4.],       [101.,  -3.,  19.,  -1.,  -5.],       [ -4.,  19.,  22.,   0.,  -1.],       [ 13.,  24.,  16.,  -5.,   2.],       [ 20.,  21.,  18.,  -4.,   0.],       [ 39.,  15.,  23.,  -4.,  -1.],       [ 54.,  17.,  17.,  -3.,   0.],       [ 62.,  22.,  17.,   2.,   1.],       [ 79.,  18.,  23.,  -3.,  -1.],       [ 85.,  24.,  23.,  -5.,   0.],       [ 95.,  22.,  23.,   2.,   4.],       [  1.,  43.,  21.,  -3.,   0.],       [  9.,  44.,  19.,  -1.,  -1.],       [ 25.,  41.,  22.,  -2.,  -4.],       [ 42.,  41.,  17.,  -3.,   2.],       [ 50.,  44.,  15.,   4.,  -5.],       [ 66.,  38.,  15.,   2.,   1.],       [ 78.,  35.,  19.,  -4.,  -5.],       [ 84.,  44.,  22.,   1.,   1.],       [100.,  36.,  20.,  -2.,   4.],       [ -4.,  63.,  23.,   3.,  -2.],       [ 13.,  63.,  22.,  -2.,   1.],       [ 24.,  64.,  16.,  -1.,  -3.],       [ 38.,  64.,  24.,   2.,  -2.],       [ 54.,  55.,  22.,   1.,  -5.],       [ 60.,  63.,  18.,  -4.,  -5.],       [ 78.,  59.,  20.,   0.,  -4.],       [ 83.,  57.,  20.,   1.,   2.],       [ 96.,  56.,  17.,  -3.,   0.],       [  4.,  82.,  24.,  -4.,  -2.],       [ 13.,  77.,  17.,   4.,   3.],       [ 22.,  84.,  18.,  -1.,   3.],       [ 33.,  78.,  18.,   2.,  -5.],       [ 49.,  77.,  21.,  -3.,   2.],       [ 61.,  84.,  21.,   3.,  -1.],       [ 72.,  77.,  22.,   1.,   0.],       [ 84.,  79.,  20.,  -4.,   2.],       [101.,  77.,  23.,   0.,  -4.],       [  1.,  99.,  17.,   3.,   3.],       [ 15.,  99.,  15.,  -3.,  -2.],       [ 24., 103.,  19.,  -5.,  -3.],       [ 41., 101.,  22.,   4.,  -1.],       [ 47., 103.,  15.,  -4.,   2.],       [ 57., 102.,  16.,  -3.,  -2.],       [ 70., 104.,  20.,   3.,  -5.],       [ 85., 100.,  20.,  -1.,  -2.],       [102.,  95.,  19.,  -3.,  -3.],       [  4.,   0.,  30.,   1.,   0.],       [ 14.,  -5.,  26.,   1.,  -2.],       [ 26.,  -1.,  30.,  -3.,  -2.],       [ 33.,   2.,  26.,   1.,  -4.],       [ 49.,   3.,  25.,  -3.,   2.],       [ 62.,   2.,  26.,   0.,   0.],       [ 75.,   2.,  30.,   0.,   2.],       [ 92.,   0.,  25.,  -4.,   0.],       [ 95.,   2.,  31.,   4.,   3.],       [  1.,  23.,  32.,  -3.,   0.],       [  9.,  20.,  25.,   2.,  -1.],       [ 26.,  15.,  29.,   2.,  -4.],       [ 41.,  19.,  25.,  -2.,  -2.],       [ 47.,  15.,  34.,  -5.,   2.],       [ 66.,  16.,  25.,   0.,  -2.],       [ 71.,  16.,  34.,  -5.,  -5.],       [ 86.,  22.,  28.,   2.,   1.],       [104.,  23.,  26.,  -5.,   2.],       [ -5.,  39.,  27.,   4.,   2.],       [  8.,  42.,  33.,  -4.,  -2.],       [ 20.,  37.,  33.,  -1.,  -1.],       [ 34.,  39.,  27.,   2.,  -2.],       [ 48.,  35.,  32.,   3.,   2.],       [ 59.,  35.,  25.,  -3.,  -1.],       [ 72.,  43.,  27.,  -5.,   4.],       [ 86.,  36.,  29.,  -4.,  -5.],       [102.,  36.,  34.,  -1.,  -2.],       [ -3.,  57.,  33.,  -5.,  -4.],       [ 14.,  63.,  31.,   4.,   2.],       [ 25.,  63.,  33.,   3.,  -1.],       [ 41.,  57.,  25.,  -1.,  -4.],       [ 46.,  61.,  33.,   1.,   1.],       [ 62.,  63.,  27.,  -3.,   4.],       [ 76.,  56.,  34.,  -2.,  -2.],       [ 86.,  57.,  31.,   3.,   2.],       [ 98.,  64.,  33.,   2.,   2.],       [ -1.,  75.,  33.,  -2.,   3.],       [ 11.,  82.,  34.,   1.,  -4.],       [ 26.,  84.,  26.,  -5.,   2.],       [ 41.,  81.,  26.,   0.,   3.],       [ 47.,  80.,  27.,   3.,  -2.],       [ 60.,  84.,  31.,   4.,   0.],       [ 74.,  84.,  34.,   0.,   0.],       [ 84.,  82.,  30.,  -3.,   1.],       [ 96.,  82.,  25.,   3.,  -4.],       [  2.,  96.,  25.,  -4.,  -3.],       [ 16., 100.,  34.,   2.,   2.],       [ 21.,  96.,  31.,   4.,  -4.],       [ 38., 103.,  32.,  -2.,   1.],       [ 47., 103.,  34.,  -1.,   1.],       [ 66.,  96.,  29.,  -3.,  -2.],       [ 72.,  95.,  25.,  -5.,  -3.],       [ 91., 100.,  28.,   3.,  -4.],       [ 98., 100.,  25.,  -1.,  -4.],       [ -3.,  -1.,  42.,   1.,   4.],       [ 13.,  -1.,  35.,  -5.,  -4.],       [ 24.,  -3.,  38.,  -1.,  -2.],       [ 39.,   3.,  43.,   2.,   2.],       [ 45.,   4.,  43.,  -4.,  -2.],       [ 61.,   3.,  43.,   2.,   4.],       [ 72.,   3.,  36.,  -5.,  -4.],       [ 88.,  -4.,  44.,   1.,  -5.],       [104.,  -1.,  42.,  -2.,  -2.],       [  0.,  22.,  35.,  -2.,   3.],       [ 12.,  24.,  38.,  -1.,   2.],       [ 20.,  17.,  42.,  -2.,   3.],       [ 32.,  23.,  40.,   4.,  -3.],       [ 53.,  23.,  43.,   1.,   3.],       [ 65.,  19.,  38.,   2.,  -5.],       [ 72.,  16.,  43.,  -3.,   1.],       [ 85.,  19.,  39.,  -3.,   3.],       [ 98.,  21.,  41.,   1.,   0.],       [  1.,  39.,  36.,  -3.,  -3.],       [ 15.,  35.,  44.,   4.,  -2.],       [ 29.,  41.,  42.,   1.,   2.],       [ 40.,  44.,  37.,  -4.,   4.],       [ 49.,  41.,  41.,  -1.,  -5.],       [ 60.,  40.,  35.,  -2.,   3.],       [ 79.,  44.,  38.,   4.,   4.],       [ 90.,  38.,  39.,   2.,  -3.],       [ 99.,  44.,  38.,   0.,   2.],       [  0.,  58.,  38.,   4.,  -2.],       [ 16.,  57.,  37.,  -2.,  -2.],       [ 27.,  64.,  44.,  -4.,   0.],       [ 36.,  55.,  37.,   4.,   3.],       [ 51.,  61.,  37.,   1.,  -4.],       [ 58.,  62.,  43.,  -2.,  -2.],       [ 79.,  56.,  44.,   3.,  -3.],       [ 90.,  56.,  42.,   4.,  -2.],       [ 95.,  57.,  38.,   0.,   2.],       [  3.,  77.,  40.,  -1.,   1.],       [ 13.,  79.,  37.,  -5.,   0.],       [ 28.,  80.,  41.,   3.,   2.],       [ 38.,  76.,  40.,  -4.,   0.],       [ 49.,  75.,  37.,  -5.,  -5.],       [ 60.,  75.,  42.,   0.,  -4.],       [ 79.,  82.,  38.,   1.,  -1.],       [ 84.,  82.,  43.,  -5.,   3.],       [104.,  76.,  41.,  -3.,   3.],       [  3.,  99.,  36.,  -2.,   4.],       [ 10.,  97.,  37.,   0.,   3.],       [ 20.,  96.,  42.,   3.,   3.],       [ 37., 100.,  37.,   2.,  -2.],       [ 47.,  98.,  37.,  -1.,  -2.],       [ 62.,  99.,  38.,  -2.,  -3.],       [ 73.,  95.,  35.,  -3.,   4.],       [ 89., 103.,  36.,   3.,   2.],       [103., 100.,  35.,   0.,   0.],       [ -3.,   0.,  48.,   2.,   2.],       [ 12.,   4.,  50.,   4.,  -2.],       [ 23.,  -3.,  45.,  -2.,  -1.],       [ 38.,   1.,  54.,   4.,  -3.],       [ 49.,  -3.,  45.,  -4.,   1.],       [ 64.,   1.,  48.,  -5.,   1.],       [ 78.,  -5.,  52.,   0.,  -2.],       [ 83.,   1.,  48.,  -1.,   1.],       [101.,  -4.,  51.,   4.,   4.],       [  2.,  20.,  53.,   3.,  -1.],       [ 14.,  21.,  50.,   1.,   0.],       [ 26.,  18.,  46.,   2.,   3.],       [ 33.,  23.,  48.,  -4.,  -2.],       [ 50.,  17.,  51.,  -3.,  -4.],       [ 63.,  18.,  45.,  -2.,  -5.],       [ 78.,  20.,  52.,  -4.,   2.],       [ 88.,  15.,  49.,   2.,   3.],       [ 95.,  24.,  49.,  -1.,  -4.],       [  3.,  41.,  47.,   0.,  -2.],       [  8.,  36.,  50.,  -5.,   1.],       [ 20.,  37.,  48.,  -2.,  -1.],       [ 32.,  36.,  45.,  -2.,   0.],       [ 46.,  44.,  47.,  -4.,  -3.],       [ 60.,  41.,  54.,  -5.,   3.],       [ 74.,  36.,  54.,  -4.,  -1.],       [ 86.,  37.,  45.,   2.,  -5.],       [104.,  41.,  49.,   4.,   0.],       [ -4.,  60.,  46.,   0.,  -1.],       [  9.,  56.,  48.,  -1.,  -3.],       [ 23.,  62.,  49.,   3.,  -3.],       [ 38.,  58.,  48.,  -5.,  -2.],       [ 47.,  61.,  48.,   4.,  -2.],       [ 61.,  61.,  51.,  -4.,  -1.],       [ 74.,  64.,  45.,  -4.,   2.],       [ 84.,  62.,  48.,  -3.,  -3.],       [ 98.,  62.,  45.,   4.,  -5.],       [  2.,  75.,  48.,  -2.,  -5.],       [ 13.,  81.,  47.,  -3.,   0.],       [ 25.,  75.,  50.,   4.,   3.],       [ 37.,  81.,  54.,  -2.,   1.],       [ 52.,  77.,  47.,  -1.,   0.],       [ 59.,  81.,  51.,   0.,   2.],       [ 78.,  78.,  45.,  -2.,   0.],       [ 91.,  81.,  53.,   1.,  -2.],       [ 97.,  82.,  54.,   0.,   4.],       [  4., 103.,  51.,  -4.,   2.],       [  8., 101.,  47.,  -5.,   3.],       [ 28.,  95.,  52.,  -1.,   2.],       [ 36., 104.,  52.,   2.,   1.],       [ 52.,  98.,  47.,   4.,  -5.],       [ 61., 102.,  48.,  -5.,   3.],       [ 77.,  97.,  51.,   0.,  -5.],       [ 88.,  99.,  48.,  -2.,  -4.],       [102.,  99.,  48.,   4.,   3.],       [  4.,  -2.,  59.,   2.,  -4.],       [ 10.,  -5.,  59.,   3.,   0.],       [ 29.,  -5.,  64.,  -4.,  -5.],       [ 35.,   0.,  63.,  -5.,   0.],       [ 47.,  -2.,  63.,   1.,  -4.],       [ 59.,  -1.,  63.,  -4.,  -3.],       [ 77.,  -1.,  62.,   1.,   2.],       [ 86.,  -2.,  57.,  -1.,  -2.],       [ 95.,  -1.,  60.,  -5.,  -2.],       [  4.,  21.,  63.,   3.,   4.],       [ 10.,  16.,  56.,   1.,  -2.],       [ 27.,  16.,  63.,  -5.,  -4.],       [ 41.,  20.,  63.,  -1.,   0.],       [ 53.,  23.,  57.,   2.,  -3.],       [ 57.,  15.,  61.,  -2.,  -5.],       [ 79.,  18.,  57.,  -4.,   2.],       [ 87.,  17.,  57.,  -3.,   0.],       [ 98.,  20.,  58.,   2.,  -5.],       [  4.,  40.,  63.,   1.,  -2.],       [ 16.,  36.,  59.,   0.,  -4.],       [ 25.,  44.,  61.,  -1.,  -3.],       [ 33.,  39.,  57.,  -5.,   0.],       [ 48.,  36.,  56.,   0.,   1.],       [ 64.,  40.,  63.,  -3.,   2.],       [ 75.,  39.,  56.,   2.,  -3.],       [ 89.,  37.,  57.,  -4.,  -5.],       [ 99.,  42.,  55.,   2.,   1.],       [  2.,  62.,  61.,  -3.,   4.],       [ 10.,  60.,  59.,  -4.,   0.],       [ 28.,  62.,  64.,  -4.,  -1.],       [ 37.,  63.,  58.,  -4.,   4.],       [ 49.,  58.,  60.,  -5.,  -1.],       [ 64.,  58.,  64.,   3.,   1.],       [ 79.,  62.,  63.,   4.,  -3.],       [ 90.,  56.,  62.,  -5.,  -5.],       [104.,  63.,  63.,   0.,   3.],       [  2.,  84.,  58.,   3.,   2.],       [ 15.,  78.,  63.,  -1.,  -1.],       [ 26.,  79.,  60.,   4.,  -5.],       [ 39.,  75.,  64.,  -2.,  -5.],       [ 45.,  81.,  58.,  -5.,   1.],       [ 60.,  80.,  62.,   4.,   0.],       [ 76.,  80.,  58.,  -5.,  -1.],       [ 92.,  84.,  63.,  -5.,  -3.],       [103.,  79.,  64.,  -2.,   3.],       [  4., 101.,  58.,  -4.,   4.],       [ 15.,  99.,  59.,   1.,  -2.],       [ 23., 101.,  59.,  -3.,  -4.],       [ 34., 100.,  55.,   4.,   3.],       [ 49.,  99.,  59.,  -4.,   1.],       [ 58.,  98.,  58.,  -4.,   1.],       [ 76.,  95.,  56.,   2.,  -5.],       [ 84.,  97.,  57.,  -4.,   2.],       [ 98., 104.,  64.,   2.,  -5.],       [ -4.,  -5.,  70.,   3.,  -4.],       [ 13.,   2.,  68.,   2.,  -1.],       [ 23.,   2.,  68.,  -1.,  -3.],       [ 37.,   3.,  73.,  -5.,  -3.],       [ 48.,  -4.,  65.,  -2.,   3.],       [ 60.,  -3.,  66.,  -3.,   0.],       [ 76.,  -5.,  70.,  -3.,   4.],       [ 88.,  -1.,  69.,   0.,   4.],       [100.,   0.,  72.,  -2.,  -3.],       [ -5.,  20.,  73.,  -4.,   0.],       [ 10.,  23.,  68.,  -2.,   3.],       [ 26.,  18.,  69.,   1.,  -5.],       [ 39.,  18.,  70.,   2.,  -2.],       [ 53.,  20.,  70.,  -1.,  -4.],       [ 67.,  20.,  73.,   0.,  -2.],       [ 73.,  16.,  66.,   2.,   2.],       [ 90.,  16.,  72.,   4.,  -1.],       [104.,  19.,  69.,  -5.,  -4.],       [  0.,  38.,  72.,   4.,   4.],       [ 14.,  35.,  74.,  -1.,   4.],       [ 20.,  37.,  68.,   0.,   2.],       [ 33.,  38.,  73.,   3.,  -1.],       [ 49.,  41.,  73.,  -5.,   0.],       [ 65.,  38.,  65.,   3.,   4.],       [ 72.,  43.,  65.,  -2.,   2.],       [ 91.,  36.,  67.,  -4.,   2.],       [100.,  42.,  71.,   0.,  -3.],       [ -5.,  64.,  73.,  -2.,  -2.],       [  9.,  60.,  72.,   1.,  -1.],       [ 23.,  64.,  67.,   1.,   4.],       [ 39.,  59.,  73.,  -5.,   3.],       [ 50.,  57.,  69.,   4.,   2.],       [ 58.,  56.,  73.,   2.,  -5.],       [ 75.,  61.,  72.,   1.,  -2.],       [ 90.,  56.,  68.,   4.,   2.],       [102.,  61.,  71.,   2.,   0.],       [  0.,  81.,  67.,  -1.,   1.],       [ 16.,  78.,  74.,  -2.,   1.],       [ 29.,  80.,  69.,   2.,   0.],       [ 35.,  84.,  69.,   2.,  -5.],       [ 53.,  75.,  68.,   3.,  -5.],       [ 63.,  78.,  65.,   1.,   4.],       [ 74.,  80.,  73.,  -1.,   2.],       [ 85.,  80.,  72.,   4.,  -4.],       [100.,  80.,  73.,   0.,  -5.],       [ -5., 102.,  74.,  -5.,  -5.],       [ 17., 102.,  72.,   1.,  -4.],       [ 28., 102.,  71.,  -4.,  -1.],       [ 40.,  95.,  65.,  -1.,   2.],       [ 54.,  96.,  74.,  -3.,   2.],       [ 60.,  95.,  70.,   4.,  -5.],       [ 75.,  95.,  72.,   3.,  -5.],       [ 84., 102.,  71.,  -2.,  -2.],       [ 96., 100.,  67.,   2.,   4.],       [  2.,   3.,  78.,   0.,  -2.],       [  8.,   4.,  81.,  -4.,   3.],       [ 23.,  -4.,  78.,   2.,  -1.],       [ 36.,   0.,  75.,  -4.,   1.],       [ 46.,  -3.,  82.,   3.,  -2.],       [ 59.,   4.,  78.,   3.,   4.],       [ 78.,   4.,  75.,  -3.,   1.],       [ 83.,   2.,  78.,  -4.,   1.],       [102.,  -2.,  81.,  -1.,  -2.],       [ -3.,  22.,  78.,   3.,  -5.],       [ 16.,  20.,  77.,  -3.,   0.],       [ 28.,  23.,  76.,   0.,   4.],       [ 37.,  22.,  81.,   2.,  -2.],       [ 51.,  21.,  83.,  -3.,  -2.],       [ 61.,  22.,  76.,   4.,   0.],       [ 79.,  15.,  81.,   0.,  -1.],       [ 83.,  17.,  81.,  -5.,  -2.],       [102.,  23.,  82.,   0.,   4.],       [ -4.,  43.,  80.,  -3.,   0.],       [  9.,  37.,  83.,   0.,  -3.],       [ 28.,  36.,  84.,   4.,   2.],       [ 35.,  38.,  76.,   3.,  -5.],       [ 46.,  39.,  82.,   4.,  -5.],       [ 65.,  37.,  80.,   0.,  -2.],       [ 76.,  44.,  81.,  -3.,  -2.],       [ 87.,  37.,  75.,  -1.,  -5.],       [ 95.,  35.,  78.,   3.,  -1.],       [  3.,  59.,  75.,  -5.,   4.],       [ 12.,  58.,  84.,  -3.,   4.],       [ 27.,  60.,  76.,   3.,   2.],       [ 35.,  58.,  75.,   2.,   2.],       [ 46.,  61.,  84.,   3.,  -4.],       [ 62.,  61.,  84.,  -5.,  -5.],       [ 78.,  55.,  78.,   0.,   3.],       [ 83.,  57.,  82.,  -2.,  -5.],       [103.,  56.,  81.,  -4.,   2.],       [  1.,  83.,  83.,   3.,  -4.],       [ 14.,  84.,  78.,  -5.,  -1.],       [ 26.,  77.,  80.,   0.,   0.],       [ 41.,  80.,  79.,  -5.,   4.],       [ 52.,  75.,  75.,   2.,  -5.],       [ 67.,  77.,  82.,  -4.,  -4.],       [ 70.,  77.,  84.,   2.,  -3.],       [ 88.,  81.,  84.,   1.,  -5.],       [101.,  80.,  84.,   4.,  -5.],       [  4.,  96.,  84.,   2.,   2.],       [ 11., 101.,  82.,  -1.,  -1.],       [ 22.,  97.,  79.,   2.,  -4.],       [ 42.,  98.,  75.,   4.,   1.],       [ 50.,  97.,  78.,  -2.,   4.],       [ 64., 101.,  81.,  -3.,   3.],       [ 79.,  98.,  79.,   0.,   2.],       [ 86., 102.,  79.,   4.,   0.],       [ 95.,  97.,  84.,   3.,   1.],       [ -2.,  -5.,  93.,   4.,  -5.],       [  8.,   4.,  88.,  -3.,   0.],       [ 22.,   1.,  87.,  -2.,  -1.],       [ 32.,   2.,  89.,   4.,   3.],       [ 49.,  -3.,  93.,   4.,   1.],       [ 66.,  -3.,  92.,  -5.,  -4.],       [ 76.,   2.,  87.,  -2.,  -2.],       [ 88.,  -1.,  88.,  -4.,  -5.],       [ 96.,   1.,  89.,   4.,  -3.],       [ -2.,  16.,  91.,  -1.,   0.],       [ 14.,  15.,  91.,   0.,  -2.],       [ 26.,  22.,  87.,   2.,   1.],       [ 41.,  23.,  86.,   0.,   1.],       [ 52.,  15.,  88.,   0.,   2.],       [ 57.,  22.,  91.,  -4.,   3.],       [ 74.,  21.,  89.,   0.,   0.],       [ 84.,  24.,  93.,   2.,   2.],       [103.,  20.,  86.,   1.,   1.],       [ -3.,  37.,  92.,   2.,   4.],       [ 12.,  41.,  87.,  -5.,   4.],       [ 25.,  35.,  86.,   1.,   4.],       [ 38.,  36.,  85.,  -5.,  -5.],       [ 53.,  44.,  89.,   4.,   1.],       [ 59.,  43.,  91.,   0.,  -3.],       [ 78.,  39.,  86.,   3.,   3.],       [ 88.,  39.,  90.,   1.,  -4.],       [102.,  35.,  93.,   1.,   1.],       [ -3.,  57.,  87.,   0.,   0.],       [  9.,  60.,  86.,   0.,  -2.],       [ 20.,  60.,  86.,   1.,   0.],       [ 38.,  58.,  88.,   4.,  -4.],       [ 49.,  61.,  92.,   3.,   4.],       [ 65.,  55.,  85.,  -4.,   1.],       [ 73.,  60.,  92.,   2.,  -5.],       [ 91.,  56.,  87.,   2.,   3.],       [103.,  63.,  91.,  -5.,   4.],       [ -2.,  82.,  94.,  -2.,   2.],       [ 12.,  76.,  89.,  -1.,  -4.],       [ 25.,  78.,  92.,  -5.,   3.],       [ 32.,  84.,  87.,  -3.,   3.],       [ 54.,  83.,  90.,  -2.,  -4.],       [ 62.,  83.,  92.,  -4.,   0.],       [ 74.,  75.,  90.,   2.,   2.],       [ 82.,  79.,  90.,   4.,   1.],       [100.,  76.,  88.,   0.,  -1.],       [  1.,  95.,  91.,  -5.,  -1.],       [ 10.,  95.,  87.,  -3.,   1.],       [ 27.,  98.,  93.,  -4.,   2.],       [ 34.,  95.,  93.,   2.,   1.],       [ 45., 103.,  92.,   3.,  -2.],       [ 66.,  95.,  85.,   4.,   0.],       [ 75., 101.,  88.,   1.,   4.],       [ 85.,  98.,  88.,  -4.,  -3.],       [101.,  99.,  92.,  -4.,   0.],       [  4.,   0., 104.,  -5.,   2.],       [ 14.,  -1., 103.,   0.,   0.],       [ 24.,   2., 102.,   1.,  -1.],       [ 40.,  -4.,  99.,   1.,   4.],       [ 45.,   1.,  98.,   1.,   0.],       [ 60.,   2., 101.,   0.,  -5.],       [ 71.,   2.,  97.,   1.,   2.],       [ 90.,  -2.,  98.,  -3.,  -2.],       [ 98.,   0.,  95.,   0.,   4.],       [ -4.,  17., 103.,   1.,   1.],       [  7.,  21.,  96.,  -4.,  -1.],       [ 20.,  20., 100.,   3.,   2.],       [ 33.,  22.,  98.,   3.,   4.],       [ 45.,  21.,  95.,   3.,  -3.],       [ 62.,  21.,  98.,  -1.,   1.],       [ 78.,  23.,  98.,   1.,  -5.],       [ 84.,  21.,  96.,   3.,  -2.],       [104.,  17., 103.,   2.,   3.],       [ -5.,  40.,  96.,   0.,  -2.],       [ 16.,  41.,  98.,   4.,   4.],       [ 26.,  44.,  98.,   2.,  -1.],       [ 35.,  40.,  95.,  -4.,   0.],       [ 48.,  42., 103.,  -5.,   3.],       [ 64.,  43.,  96.,  -1.,  -4.],       [ 75.,  40.,  99.,   4.,   1.],       [ 84.,  40., 104.,  -2.,  -5.],       [ 98.,  40.,  96.,  -3.,   0.],       [  3.,  59.,  98.,   3.,   1.],       [ 13.,  62., 100.,   2.,  -2.],       [ 29.,  61.,  96.,   3.,  -3.],       [ 39.,  60.,  95.,  -1.,  -4.],       [ 48.,  56.,  98.,  -2.,  -4.],       [ 58.,  55., 104.,   1.,   4.],       [ 74.,  63.,  98.,   1.,  -1.],       [ 87.,  63., 104.,  -2.,   3.],       [ 98.,  61., 100.,  -3.,   4.],       [ -4.,  76.,  95.,   4.,  -3.],       [  9.,  83., 104.,  -4.,  -3.],       [ 28.,  83., 103.,  -2.,   2.],       [ 32.,  83.,  98.,  -3.,   2.],       [ 52.,  82., 103.,   1.,  -4.],       [ 63.,  84.,  97.,  -2.,   3.],       [ 76.,  80., 100.,   2.,  -5.],       [ 88.,  75., 103.,   0.,  -3.],       [ 98.,  75., 101.,   2.,  -4.],       [  1., 102., 101.,  -5.,   4.],       [ 11.,  99.,  98.,   4.,   1.],       [ 20.,  96., 104.,   4.,  -3.],       [ 39., 100., 103.,  -2.,  -2.],       [ 49., 104.,  97.,  -5.,   0.],       [ 66., 104., 102.,  -4.,   4.],       [ 75., 101., 103.,   3.,  -4.],       [ 92.,  95., 101.,  -1.,   2.],       [101.,  98.,  97.,   3.,   1.]])
        n1   = 9
        p1   = 5
        knot1= np.array([0. , 0. , 0. , 0. , 0. , 1.2, 2.4, 3.3, 4.2, 5. , 5. , 5. , 5. , 5. ])
        n2   = 6
        p2   = 5
        knot2= np.array([0. , 0. , 0. , 0. , 0. , 0.9, 2. , 2. , 2. , 2. , 2. ])
        n3   = 11
        p3   = 6
        knot3= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.2, 2.2, 3.3, 4.2, 5.1, 6. , 6. , 6. , 6. , 6. , 6. ])
        vol  = lr.LRSplineVolume(n1,n2,n3,p1,p2,p3,knot1,knot2,knot3,controlpoints)
        vol2 = vol.clone()
        vol2.insert_knot([1.478], 0, 1) # insert C3-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 15)
        vol2.insert_knot([2.824], 0, 2) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 17)
        vol2.insert_knot([2.258], 0, 3) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 20)
        vol2.insert_knot([2.208], 0, 4) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 24)
        vol2.insert_knot([1.740], 2, 1) # insert C4-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 18)
        vol2.insert_knot([2.539], 2, 2) # insert C3-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 20)
        vol2.insert_knot([4.560], 2, 3) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 23)
        vol2.insert_knot([2.736], 2, 4) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 27)
        vol2.insert_knot([2.603], 2, 5) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 32)

        u    = np.linspace(vol.start(0), vol.end(0), 7)
        v    = np.linspace(vol.start(1), vol.end(1), 7)
        w    = np.linspace(vol.start(2), vol.end(2), 7)
        U,V,W= np.meshgrid(u,v,w)
        pt   = vol(U,V,W)
        pt2  = vol2(U,V,W)
        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_surface_2D_p66(self):
        controlpoints = np.array([[ -2.,   3.],       [ 12.,   3.],       [ 17.,  -3.],       [ 34.,  -1.],       [ 39.,   4.],       [ 53.,   2.],       [ 69.,   3.],       [ 79.,  -5.],       [ 85.,   1.],       [100.,   4.],       [  2.,  10.],       [ 11.,   7.],       [ 20.,  14.],       [ 31.,  14.],       [ 44.,  15.],       [ 55.,   8.],       [ 70.,   8.],       [ 72.,   6.],       [ 85.,   7.],       [102.,  15.],       [  0.,  17.],       [ 13.,  23.],       [ 21.,  25.],       [ 30.,  26.],       [ 39.,  21.],       [ 53.,  18.],       [ 68.,  20.],       [ 75.,  20.],       [ 89.,  18.],       [ 95.,  19.],       [  4.,  37.],       [ 11.,  34.],       [ 20.,  30.],       [ 33.,  31.],       [ 46.,  34.],       [ 52.,  36.],       [ 69.,  28.],       [ 74.,  34.],       [ 93.,  33.],       [ 98.,  37.],       [ -3.,  44.],       [  9.,  45.],       [ 17.,  48.],       [ 37.,  47.],       [ 48.,  41.],       [ 56.,  42.],       [ 65.,  46.],       [ 77.,  47.],       [ 89.,  43.],       [ 96.,  45.],       [  0.,  53.],       [ 14.,  55.],       [ 20.,  51.],       [ 34.,  58.],       [ 40.,  59.],       [ 57.,  54.],       [ 61.,  53.],       [ 78.,  54.],       [ 84.,  53.],       [100.,  57.],       [ -4.,  70.],       [  9.,  64.],       [ 20.,  62.],       [ 32.,  63.],       [ 43.,  64.],       [ 53.,  68.],       [ 68.,  63.],       [ 76.,  66.],       [ 85.,  61.],       [100.,  65.],       [ -4.,  79.],       [ 15.,  78.],       [ 20.,  82.],       [ 28.,  77.],       [ 41.,  74.],       [ 57.,  76.],       [ 62.,  78.],       [ 79.,  79.],       [ 84.,  82.],       [100.,  74.],       [ -5.,  91.],       [ 15.,  84.],       [ 24.,  84.],       [ 29.,  86.],       [ 47.,  87.],       [ 53.,  91.],       [ 64.,  86.],       [ 76.,  93.],       [ 85.,  92.],       [104.,  91.],       [ -5., 103.],       [ 15.,  95.],       [ 20., 101.],       [ 30., 100.],       [ 47., 102.],       [ 55.,  95.],       [ 65., 103.],       [ 82.,  97.],       [ 88.,  98.],       [ 96., 104.]])
        n1   = 10
        p1   = 6
        knot1= np.array([0. , 0. , 0. , 0. , 0. , 0. , 0.7, 1.7, 3.3, 3.6, 5. , 5. , 5. , 5. , 5. , 5. ])
        n2   = 10
        p2   = 6
        knot2= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.3, 1.8, 3. , 4.3, 5. , 5. , 5. , 5. , 5. , 5. ])
        surf  = lr.LRSplineSurface(n1,n2,p1,p2,knot1,knot2, controlpoints)
        surf2 = surf.clone()
        surf2.insert_knot([1.181], 0, 1) # insert C4-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 17)
        surf2.insert_knot([2.877], 0, 2) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 19)
        surf2.insert_knot([1.333], 0, 3) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 22)
        surf2.insert_knot([0.953], 0, 4) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 26)
        surf2.insert_knot([2.912], 0, 5) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 31)
        surf2.insert_knot([1.718], 1, 1) # insert C4-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 17)
        surf2.insert_knot([1.538], 1, 2) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 19)
        surf2.insert_knot([3.121], 1, 3) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 22)
        surf2.insert_knot([2.617], 1, 4) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 26)
        surf2.insert_knot([2.921], 1, 5) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 31)

        u    = np.linspace(surf.start(0), surf.end(0), 9)
        v    = np.linspace(surf.start(1), surf.end(1), 9)
        U,V  = np.meshgrid(u,v)
        pt   = surf(U,V)
        pt2  = surf2(U,V)

        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_surface_3D_p55(self):
        controlpoints = np.array([[  4.,  -3.,  -4.],       [  9.,   2.,  -1.],       [ 32.,   3.,  -4.],       [ 47.,   1.,  -3.],       [ 56.,  -1.,  -2.],       [ 70.,  -2.,   0.],       [ 88.,   4.,   2.],       [ 97.,   1.,  -3.],       [  3.,  17.,  -1.],       [ 15.,  15.,   4.],       [ 32.,  15.,  -4.],       [ 37.,  18.,   2.],       [ 52.,  17.,  -4.],       [ 67.,  12.,  -5.],       [ 89.,  15.,  -1.],       [102.,  19.,   3.],       [ -2.,  29.,  -2.],       [ 16.,  28.,   3.],       [ 31.,  37.,  -4.],       [ 39.,  37.,  -2.],       [ 53.,  31.,  -3.],       [ 73.,  29.,  -5.],       [ 89.,  36.,  -2.],       [100.,  36.,   3.],       [ -1.,  48.,   4.],       [ 12.,  45.,   1.],       [ 30.,  45.,  -2.],       [ 46.,  52.,  -1.],       [ 54.,  48.,  -1.],       [ 74.,  53.,   3.],       [ 84.,  47.,   2.],       [ 95.,  51.,  -4.],       [ -3.,  71.,  -2.],       [  9.,  65.,   3.],       [ 29.,  63.,  -1.],       [ 39.,  66.,  -4.],       [ 57.,  70.,   0.],       [ 75.,  66.,  -1.],       [ 80.,  68.,  -1.],       [ 98.,  70.,  -4.],       [ -4.,  78.,  -1.],       [ 15.,  82.,  -5.],       [ 32.,  86.,  -1.],       [ 43.,  86.,  -5.],       [ 56.,  85.,  -3.],       [ 68.,  78.,   1.],       [ 83.,  87.,   3.],       [ 98.,  85.,   2.],       [ -2.,  98.,   2.],       [ 17., 104.,   3.],       [ 27.,  95.,   2.],       [ 39.,  95.,  -5.],       [ 54., 101.,   2.],       [ 75.,  97.,  -3.],       [ 83., 103.,  -1.],       [102.,  99.,   4.]])
        n1   = 8
        p1   = 5
        knot1= np.array([0. , 0. , 0. , 0. , 0. , 1. , 2.1, 3.3, 4. , 4. , 4. , 4. , 4. ])
        n2   = 7
        p2   = 5
        knot2= np.array([0., 0., 0., 0., 0., 1., 2., 3., 3., 3., 3., 3.])
        surf  = lr.LRSplineSurface(n1,n2,p1,p2,knot1,knot2, controlpoints)
        surf2 = surf.clone()
        surf2.insert_knot([1.452], 0, 1) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 14)
        surf2.insert_knot([1.549], 0, 2) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 16)
        surf2.insert_knot([3.061], 0, 3) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 19)
        surf2.insert_knot([3.012], 0, 4) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 23)
        surf2.insert_knot([1.642], 1, 1) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 13)
        surf2.insert_knot([1.784], 1, 2) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 15)
        surf2.insert_knot([1.352], 1, 3) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 18)
        surf2.insert_knot([1.278], 1, 4) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 22)

        u    = np.linspace(surf.start(0), surf.end(0), 9)
        v    = np.linspace(surf.start(1), surf.end(1), 9)
        U,V  = np.meshgrid(u,v)
        pt   = surf(U,V)
        pt2  = surf2(U,V)

        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_volume_3D_p666(self):
        controlpoints = np.array([[ -3.,  -2.,   2.],       [ 10.,  -2.,   1.],       [ 20.,   4.,  -4.],       [ 37.,   1.,   0.],       [ 49.,  -4.,   2.],       [ 52.,  -3.,   1.],       [ 65.,   0.,   2.],       [ 73.,   3.,   4.],       [ 90.,   4.,   4.],       [ 99.,  -1.,  -4.],       [  2.,  13.,  -5.],       [ 11.,   9.,   4.],       [ 17.,  11.,  -1.],       [ 31.,  11.,  -2.],       [ 44.,  15.,   0.],       [ 55.,  14.,  -1.],       [ 63.,  12.,  -4.],       [ 77.,   6.,  -5.],       [ 93.,  13.,   1.],       [101.,   6.,  -1.],       [  0.,  26.,   4.],       [ 11.,  17.,  -4.],       [ 19.,  25.,  -1.],       [ 37.,  18.,   3.],       [ 46.,  22.,   2.],       [ 56.,  17.,  -5.],       [ 64.,  18.,   1.],       [ 78.,  25.,  -3.],       [ 84.,  18.,   1.],       [ 96.,  20.,  -4.],       [ -3.,  32.,  -1.],       [ 13.,  31.,  -3.],       [ 18.,  29.,  -2.],       [ 29.,  32.,  -4.],       [ 42.,  36.,  -2.],       [ 56.,  30.,   4.],       [ 69.,  34.,   0.],       [ 74.,  32.,  -5.],       [ 92.,  31.,   3.],       [101.,  29.,  -1.],       [ -4.,  46.,  -5.],       [ 15.,  42.,   2.],       [ 22.,  41.,   4.],       [ 35.,  46.,  -1.],       [ 44.,  49.,   4.],       [ 58.,  47.,   3.],       [ 63.,  46.,   0.],       [ 76.,  41.,  -5.],       [ 89.,  45.,   4.],       [ 98.,  43.,  -1.],       [ -5.,  50.,   4.],       [  7.,  53.,  -2.],       [ 25.,  54.,  -3.],       [ 28.,  54.,   3.],       [ 42.,  59.,  -3.],       [ 58.,  51.,   0.],       [ 67.,  56.,  -5.],       [ 82.,  60.,  -4.],       [ 91.,  54.,  -4.],       [ 96.,  55.,   3.],       [  2.,  65.,   4.],       [  9.,  66.,   0.],       [ 17.,  67.,   3.],       [ 31.,  69.,  -4.],       [ 41.,  68.,  -3.],       [ 50.,  68.,  -5.],       [ 62.,  65.,   3.],       [ 75.,  64.,   2.],       [ 93.,  71.,   4.],       [103.,  68.,   2.],       [ -4.,  78.,   2.],       [  6.,  73.,  -2.],       [ 21.,  80.,   0.],       [ 34.,  76.,  -2.],       [ 44.,  82.,  -5.],       [ 57.,  79.,   0.],       [ 68.,  78.,   4.],       [ 73.,  75.,  -5.],       [ 89.,  79.,  -3.],       [ 96.,  74.,  -4.],       [ -3.,  85.,  -4.],       [  7.,  93.,   4.],       [ 23.,  88.,   4.],       [ 33.,  93.,   2.],       [ 40.,  86.,  -5.],       [ 57.,  85.,  -2.],       [ 69.,  93.,  -3.],       [ 78.,  89.,  -4.],       [ 92.,  91.,   2.],       [100.,  92.,   4.],       [  2., 100.,   4.],       [  9., 101.,   2.],       [ 24., 100.,  -4.],       [ 34., 100.,   0.],       [ 42., 103.,  -5.],       [ 59., 102.,   3.],       [ 66., 101.,  -2.],       [ 79., 100.,   0.],       [ 92., 100.,  -1.],       [100., 104.,   0.],       [  3.,   1.,  10.],       [  9.,   1.,  12.],       [ 20.,   0.,  11.],       [ 36.,   1.,  16.],       [ 40.,   1.,  17.],       [ 50.,   4.,  15.],       [ 67.,   4.,  16.],       [ 75.,  -3.,  10.],       [ 93.,   3.,   9.],       [102.,   1.,  10.],       [  2.,  15.,  15.],       [  6.,  10.,  12.],       [ 21.,  12.,  13.],       [ 35.,   7.,  18.],       [ 49.,  12.,  11.],       [ 58.,  13.,  15.],       [ 68.,   7.,  14.],       [ 82.,   8.,  15.],       [ 84.,   9.,  16.],       [102.,  14.,  16.],       [  0.,  22.,   9.],       [  8.,  21.,  17.],       [ 23.,  20.,  18.],       [ 29.,  19.,  14.],       [ 43.,  17.,  10.],       [ 52.,  25.,  18.],       [ 69.,  24.,  17.],       [ 75.,  21.,   9.],       [ 89.,  24.,  10.],       [ 96.,  21.,  12.],       [ -5.,  36.,  15.],       [  9.,  33.,  10.],       [ 17.,  35.,  12.],       [ 30.,  35.,  10.],       [ 44.,  35.,  11.],       [ 50.,  35.,  10.],       [ 67.,  32.,  15.],       [ 80.,  30.,  18.],       [ 85.,  30.,  10.],       [ 99.,  31.,  14.],       [  0.,  47.,   9.],       [ 14.,  41.,  17.],       [ 22.,  48.,  15.],       [ 33.,  40.,  18.],       [ 39.,  46.,  18.],       [ 58.,  41.,  13.],       [ 70.,  46.,  12.],       [ 81.,  43.,  14.],       [ 90.,  46.,  11.],       [ 97.,  43.,  11.],       [  0.,  51.,  12.],       [ 12.,  56.,   9.],       [ 27.,  55.,  17.],       [ 34.,  56.,  12.],       [ 46.,  54.,   9.],       [ 56.,  56.,   9.],       [ 66.,  53.,  17.],       [ 80.,  57.,  18.],       [ 89.,  57.,  16.],       [ 95.,  58.,  11.],       [ -4.,  63.,  18.],       [  8.,  69.,  13.],       [ 25.,  63.,  10.],       [ 29.,  65.,   9.],       [ 43.,  66.,  11.],       [ 53.,  68.,  17.],       [ 69.,  71.,  16.],       [ 81.,  66.,  14.],       [ 87.,  68.,  13.],       [100.,  66.,  12.],       [  2.,  76.,  11.],       [ 14.,  78.,  11.],       [ 18.,  79.,  11.],       [ 30.,  77.,  15.],       [ 46.,  78.,  17.],       [ 52.,  76.,  16.],       [ 65.,  75.,   9.],       [ 73.,  79.,  12.],       [ 88.,  72.,  12.],       [102.,  72.,  11.],       [  1.,  85.,  12.],       [ 13.,  91.,  16.],       [ 23.,  88.,  18.],       [ 36.,  92.,  13.],       [ 45.,  90.,   9.],       [ 59.,  88.,  15.],       [ 69.,  88.,  11.],       [ 81.,  87.,   9.],       [ 85.,  88.,  19.],       [102.,  92.,  12.],       [ -5.,  96.,  10.],       [ 11.,  99.,  12.],       [ 25.,  98.,  12.],       [ 34.,  95.,  16.],       [ 42.,  97.,  10.],       [ 58.,  95.,  14.],       [ 62., 100.,  16.],       [ 79.,  99.,  10.],       [ 86.,  99.,  17.],       [ 97., 102.,  16.],       [  4.,  -4.,  30.],       [ 12.,  -4.,  23.],       [ 24.,  -3.,  31.],       [ 33.,  -1.,  29.],       [ 49.,   0.,  32.],       [ 53.,   1.,  26.],       [ 67.,  -4.,  29.],       [ 79.,   1.,  25.],       [ 93.,   4.,  24.],       [103.,  -3.,  29.],       [  3.,   9.,  32.],       [ 12.,  11.,  25.],       [ 20.,   9.,  30.],       [ 30.,   6.,  27.],       [ 43.,   8.,  33.],       [ 55.,  14.,  32.],       [ 71.,   7.,  24.],       [ 74.,   8.,  29.],       [ 85.,  12.,  26.],       [ 98.,   9.,  31.],       [ -2.,  20.,  32.],       [ 13.,  21.,  31.],       [ 22.,  24.,  28.],       [ 31.,  22.,  27.],       [ 45.,  21.,  25.],       [ 56.,  18.,  33.],       [ 68.,  23.,  27.],       [ 75.,  25.,  31.],       [ 90.,  18.,  25.],       [101.,  25.,  23.],       [  4.,  30.,  31.],       [  7.,  28.,  29.],       [ 25.,  34.,  32.],       [ 33.,  31.,  26.],       [ 49.,  33.,  27.],       [ 58.,  33.,  26.],       [ 62.,  36.,  23.],       [ 79.,  34.,  23.],       [ 85.,  32.,  29.],       [ 95.,  30.,  27.],       [  0.,  49.,  30.],       [  7.,  40.,  25.],       [ 20.,  44.,  28.],       [ 29.,  41.,  26.],       [ 44.,  47.,  27.],       [ 53.,  44.,  26.],       [ 63.,  43.,  28.],       [ 77.,  46.,  29.],       [ 93.,  49.,  31.],       [103.,  44.,  29.],       [ -4.,  51.,  28.],       [  9.,  59.,  23.],       [ 20.,  51.,  26.],       [ 35.,  59.,  27.],       [ 40.,  53.,  25.],       [ 55.,  52.,  32.],       [ 68.,  53.,  25.],       [ 78.,  54.,  31.],       [ 85.,  60.,  32.],       [ 96.,  52.,  26.],       [  1.,  66.,  30.],       [  9.,  62.,  29.],       [ 27.,  69.,  26.],       [ 35.,  65.,  26.],       [ 46.,  66.,  23.],       [ 51.,  66.,  28.],       [ 66.,  69.,  29.],       [ 81.,  67.,  31.],       [ 84.,  71.,  26.],       [ 98.,  62.,  29.],       [ -2.,  77.,  32.],       [ 14.,  73.,  30.],       [ 20.,  76.,  25.],       [ 31.,  72.,  27.],       [ 41.,  77.,  27.],       [ 58.,  75.,  26.],       [ 68.,  77.,  29.],       [ 79.,  81.,  31.],       [ 86.,  75.,  27.],       [ 97.,  81.,  31.],       [ -2.,  83.,  32.],       [ 15.,  89.,  27.],       [ 26.,  85.,  30.],       [ 28.,  92.,  27.],       [ 45.,  86.,  29.],       [ 52.,  90.,  30.],       [ 68.,  85.,  31.],       [ 75.,  89.,  27.],       [ 84.,  93.,  29.],       [ 96.,  90.,  28.],       [  2.,  99.,  26.],       [  6.,  99.,  24.],       [ 22.,  97.,  28.],       [ 36., 103.,  31.],       [ 40., 102.,  33.],       [ 51., 101.,  26.],       [ 68.,  98.,  33.],       [ 82., 102.,  28.],       [ 90., 103.,  23.],       [103., 103.,  32.],       [  1.,  -4.,  47.],       [ 14.,   2.,  38.],       [ 18.,  -5.,  40.],       [ 30.,  -5.,  41.],       [ 41.,   1.,  47.],       [ 59.,  -4.,  39.],       [ 64.,  -3.,  40.],       [ 78.,   4.,  47.],       [ 86.,  -2.,  43.],       [104.,  -3.,  38.],       [  1.,   6.,  44.],       [ 11.,   9.,  42.],       [ 25.,  13.,  39.],       [ 32.,  15.,  40.],       [ 43.,  15.,  47.],       [ 55.,   9.,  41.],       [ 69.,  14.,  42.],       [ 76.,  15.,  43.],       [ 87.,  14.,  39.],       [104.,   6.,  46.],       [ -3.,  18.,  46.],       [ 15.,  21.,  44.],       [ 23.,  18.,  44.],       [ 33.,  25.,  38.],       [ 45.,  24.,  42.],       [ 60.,  18.,  38.],       [ 68.,  20.,  43.],       [ 77.,  23.,  40.],       [ 87.,  18.,  44.],       [ 95.,  19.,  40.],       [  3.,  28.,  39.],       [ 10.,  30.,  45.],       [ 18.,  36.,  43.],       [ 31.,  37.,  43.],       [ 49.,  31.,  44.],       [ 51.,  35.,  42.],       [ 61.,  31.,  41.],       [ 73.,  29.,  43.],       [ 84.,  37.,  42.],       [ 99.,  33.,  38.],       [ -2.,  47.,  46.],       [ 13.,  44.,  42.],       [ 23.,  48.,  44.],       [ 32.,  42.,  45.],       [ 39.,  44.,  45.],       [ 56.,  42.,  43.],       [ 61.,  40.,  46.],       [ 80.,  45.,  38.],       [ 88.,  44.,  43.],       [ 97.,  41.,  39.],       [  3.,  58.,  44.],       [ 13.,  54.,  46.],       [ 23.,  52.,  45.],       [ 31.,  60.,  39.],       [ 41.,  56.,  47.],       [ 53.,  51.,  42.],       [ 61.,  58.,  42.],       [ 81.,  57.,  46.],       [ 86.,  57.,  43.],       [ 95.,  54.,  38.],       [  4.,  64.,  44.],       [ 10.,  67.,  42.],       [ 18.,  71.,  47.],       [ 28.,  65.,  41.],       [ 43.,  66.,  42.],       [ 60.,  64.,  40.],       [ 69.,  71.,  40.],       [ 74.,  64.,  43.],       [ 87.,  66.,  39.],       [103.,  62.,  43.],       [  3.,  75.,  42.],       [  9.,  79.,  42.],       [ 21.,  73.,  38.],       [ 29.,  80.,  41.],       [ 48.,  75.,  44.],       [ 57.,  75.,  46.],       [ 68.,  73.,  44.],       [ 75.,  78.,  41.],       [ 85.,  73.,  42.],       [102.,  78.,  40.],       [ -3.,  92.,  39.],       [  6.,  89.,  47.],       [ 21.,  92.,  39.],       [ 29.,  84.,  38.],       [ 39.,  93.,  39.],       [ 58.,  87.,  42.],       [ 65.,  84.,  45.],       [ 81.,  90.,  44.],       [ 84.,  91.,  47.],       [ 95.,  89.,  39.],       [  1., 104.,  43.],       [  9., 104.,  40.],       [ 19., 101.,  45.],       [ 33., 104.,  43.],       [ 44., 101.,  41.],       [ 57., 100.,  47.],       [ 64., 102.,  43.],       [ 82., 100.,  43.],       [ 89., 104.,  37.],       [ 98., 101.,  47.],       [  2.,  -1.,  60.],       [ 13.,  -4.,  55.],       [ 17.,   3.,  55.],       [ 33.,   3.,  56.],       [ 43.,   0.,  56.],       [ 52.,  -3.,  56.],       [ 65.,   4.,  57.],       [ 75.,   4.,  57.],       [ 87.,   0.,  52.],       [102.,   1.,  55.],       [ -3.,  10.,  54.],       [ 15.,   7.,  56.],       [ 18.,   7.,  52.],       [ 32.,   7.,  57.],       [ 47.,  12.,  61.],       [ 56.,  12.,  56.],       [ 67.,  15.,  58.],       [ 82.,  15.,  60.],       [ 88.,  10.,  60.],       [ 99.,   6.,  56.],       [ -1.,  20.,  61.],       [ 15.,  23.,  59.],       [ 22.,  23.,  61.],       [ 34.,  24.,  56.],       [ 46.,  25.,  57.],       [ 54.,  19.,  52.],       [ 63.,  24.,  56.],       [ 76.,  26.,  57.],       [ 85.,  23.,  53.],       [ 97.,  18.,  55.],       [ -1.,  35.,  54.],       [  9.,  30.,  62.],       [ 25.,  29.,  54.],       [ 37.,  38.,  53.],       [ 46.,  36.,  53.],       [ 54.,  29.,  60.],       [ 63.,  32.,  58.],       [ 75.,  34.,  57.],       [ 84.,  30.,  61.],       [103.,  29.,  52.],       [ -3.,  42.,  54.],       [ 13.,  40.,  59.],       [ 23.,  48.,  60.],       [ 30.,  41.,  61.],       [ 48.,  46.,  53.],       [ 60.,  41.,  61.],       [ 71.,  46.,  54.],       [ 81.,  42.,  54.],       [ 88.,  45.,  60.],       [100.,  41.,  55.],       [  1.,  56.,  56.],       [  9.,  51.,  52.],       [ 21.,  58.,  59.],       [ 28.,  51.,  55.],       [ 49.,  58.,  61.],       [ 55.,  59.,  58.],       [ 69.,  58.,  60.],       [ 72.,  56.,  52.],       [ 89.,  58.,  59.],       [101.,  55.,  55.],       [ -5.,  65.,  56.],       [  7.,  69.,  56.],       [ 20.,  65.,  61.],       [ 34.,  70.,  55.],       [ 41.,  63.,  55.],       [ 58.,  70.,  57.],       [ 67.,  62.,  58.],       [ 74.,  62.,  61.],       [ 91.,  71.,  57.],       [ 97.,  65.,  52.],       [  2.,  75.,  57.],       [  9.,  77.,  57.],       [ 26.,  75.,  62.],       [ 36.,  76.,  52.],       [ 47.,  75.,  55.],       [ 54.,  73.,  55.],       [ 70.,  73.,  57.],       [ 73.,  80.,  58.],       [ 89.,  80.,  55.],       [102.,  73.,  53.],       [  0.,  89.,  58.],       [  8.,  87.,  59.],       [ 21.,  93.,  59.],       [ 36.,  91.,  53.],       [ 43.,  90.,  53.],       [ 52.,  88.,  60.],       [ 67.,  83.,  53.],       [ 75.,  89.,  56.],       [ 92.,  87.,  53.],       [ 98.,  85.,  53.],       [  2., 103.,  55.],       [ 15.,  95.,  52.],       [ 24., 103.,  53.],       [ 37.,  96.,  60.],       [ 43., 101.,  56.],       [ 52.,  96.,  52.],       [ 68., 102.,  57.],       [ 80., 101.,  57.],       [ 89.,  98.,  58.],       [100.,  97.,  61.],       [  0.,  -2.,  67.],       [ 13.,   3.,  75.],       [ 20.,  -4.,  70.],       [ 30.,   0.,  72.],       [ 45.,   0.,  72.],       [ 55.,   0.,  76.],       [ 66.,  -1.,  66.],       [ 74.,  -1.,  73.],       [ 89.,   3.,  73.],       [ 98.,   2.,  66.],       [  0.,  14.,  71.],       [ 12.,  12.,  76.],       [ 19.,   9.,  74.],       [ 29.,  12.,  72.],       [ 44.,   7.,  70.],       [ 52.,  12.,  72.],       [ 70.,  12.,  67.],       [ 80.,  14.,  72.],       [ 84.,  10.,  67.],       [ 96.,   9.,  74.],       [  2.,  25.,  66.],       [  8.,  26.,  69.],       [ 18.,  17.,  75.],       [ 37.,  23.,  70.],       [ 41.,  19.,  73.],       [ 50.,  21.,  72.],       [ 69.,  22.,  74.],       [ 78.,  22.,  73.],       [ 88.,  23.,  73.],       [101.,  24.,  75.],       [ -5.,  29.,  71.],       [  6.,  35.,  68.],       [ 18.,  37.,  74.],       [ 37.,  29.,  76.],       [ 41.,  31.,  75.],       [ 59.,  33.,  70.],       [ 61.,  33.,  71.],       [ 75.,  33.,  68.],       [ 90.,  30.,  67.],       [ 95.,  34.,  67.],       [  0.,  48.,  76.],       [ 11.,  46.,  73.],       [ 22.,  45.,  74.],       [ 34.,  46.,  69.],       [ 48.,  43.,  71.],       [ 56.,  42.,  67.],       [ 66.,  45.,  72.],       [ 80.,  42.,  68.],       [ 91.,  45.,  71.],       [ 97.,  43.,  72.],       [  2.,  54.,  74.],       [ 13.,  51.,  72.],       [ 22.,  53.,  71.],       [ 28.,  56.,  72.],       [ 48.,  59.,  67.],       [ 53.,  55.,  72.],       [ 66.,  53.,  66.],       [ 76.,  51.,  67.],       [ 91.,  58.,  71.],       [102.,  56.,  71.],       [  2.,  70.,  74.],       [ 10.,  64.,  67.],       [ 19.,  66.,  73.],       [ 35.,  66.,  66.],       [ 39.,  71.,  68.],       [ 55.,  70.,  66.],       [ 69.,  61.,  69.],       [ 78.,  63.,  71.],       [ 86.,  70.,  70.],       [102.,  70.,  75.],       [  0.,  81.,  76.],       [ 12.,  81.,  73.],       [ 21.,  74.,  69.],       [ 32.,  81.,  69.],       [ 46.,  79.,  69.],       [ 54.,  80.,  68.],       [ 69.,  77.,  74.],       [ 81.,  82.,  71.],       [ 84.,  75.,  73.],       [101.,  79.,  68.],       [  0.,  87.,  70.],       [  6.,  84.,  70.],       [ 24.,  93.,  66.],       [ 28.,  86.,  66.],       [ 39.,  93.,  68.],       [ 57.,  89.,  69.],       [ 64.,  92.,  69.],       [ 76.,  91.,  68.],       [ 91.,  87.,  67.],       [100.,  91.,  74.],       [ -5.,  99.,  69.],       [  6., 104.,  73.],       [ 21.,  96.,  76.],       [ 35., 101.,  75.],       [ 48.,  98.,  67.],       [ 54., 101.,  66.],       [ 69., 102.,  68.],       [ 76., 104.,  73.],       [ 89., 103.,  67.],       [104.,  99.,  73.],       [  3.,   4.,  82.],       [ 15.,  -4.,  87.],       [ 23.,  -5.,  85.],       [ 32.,  -5.,  90.],       [ 39.,   3.,  87.],       [ 56.,   3.,  88.],       [ 69.,  -2.,  88.],       [ 76.,  -3.,  84.],       [ 86.,   2.,  89.],       [103.,  -5.,  83.],       [ -3.,  11.,  88.],       [ 13.,  15.,  81.],       [ 26.,   6.,  90.],       [ 35.,  10.,  87.],       [ 46.,   9.,  82.],       [ 59.,  14.,  89.],       [ 67.,  12.,  81.],       [ 73.,  14.,  88.],       [ 83.,  14.,  82.],       [ 97.,   9.,  85.],       [  0.,  20.,  81.],       [ 14.,  19.,  89.],       [ 24.,  18.,  84.],       [ 34.,  22.,  88.],       [ 39.,  23.,  82.],       [ 59.,  21.,  86.],       [ 70.,  19.,  84.],       [ 81.,  26.,  84.],       [ 88.,  24.,  86.],       [101.,  26.,  90.],       [  2.,  30.,  80.],       [  8.,  33.,  85.],       [ 24.,  36.,  85.],       [ 33.,  35.,  81.],       [ 44.,  29.,  87.],       [ 59.,  37.,  83.],       [ 66.,  36.,  83.],       [ 80.,  31.,  89.],       [ 85.,  31.,  88.],       [102.,  32.,  85.],       [ -3.,  45.,  82.],       [ 14.,  42.,  81.],       [ 21.,  47.,  86.],       [ 35.,  47.,  84.],       [ 42.,  45.,  89.],       [ 55.,  43.,  83.],       [ 62.,  46.,  89.],       [ 78.,  44.,  88.],       [ 83.,  42.,  84.],       [ 99.,  43.,  86.],       [ -4.,  55.,  82.],       [ 11.,  59.,  80.],       [ 26.,  52.,  87.],       [ 32.,  57.,  85.],       [ 40.,  57.,  85.],       [ 58.,  57.,  88.],       [ 64.,  56.,  83.],       [ 74.,  54.,  86.],       [ 85.,  50.,  85.],       [ 98.,  58.,  84.],       [ -2.,  69.,  90.],       [ 15.,  67.,  87.],       [ 17.,  65.,  87.],       [ 35.,  63.,  90.],       [ 39.,  62.,  81.],       [ 56.,  65.,  84.],       [ 66.,  66.,  87.],       [ 74.,  69.,  85.],       [ 93.,  67.,  85.],       [104.,  68.,  81.],       [  3.,  79.,  86.],       [ 14.,  75.,  90.],       [ 21.,  77.,  85.],       [ 29.,  76.,  82.],       [ 43.,  75.,  82.],       [ 56.,  79.,  89.],       [ 66.,  77.,  82.],       [ 79.,  73.,  90.],       [ 88.,  74.,  84.],       [100.,  78.,  87.],       [ -1.,  84.,  89.],       [  7.,  91.,  85.],       [ 17.,  85.,  87.],       [ 37.,  90.,  89.],       [ 43.,  91.,  90.],       [ 60.,  83.,  84.],       [ 70.,  89.,  85.],       [ 77.,  89.,  89.],       [ 92.,  90.,  86.],       [104.,  88.,  80.],       [ -2.,  97.,  81.],       [ 10., 100.,  89.],       [ 17., 100.,  80.],       [ 35.,  98.,  90.],       [ 45.,  97.,  89.],       [ 57., 102.,  85.],       [ 71.,  97.,  86.],       [ 75., 102.,  89.],       [ 91., 104.,  88.],       [ 99., 103.,  85.],       [  3.,  -5., 101.],       [ 13.,  -1., 101.],       [ 27.,   3.,  97.],       [ 38.,  -1.,  99.],       [ 46.,   2., 104.],       [ 53.,   4., 103.],       [ 67.,   3., 103.],       [ 77.,   0., 100.],       [ 93.,  -3.,  95.],       [ 96.,   4.,  96.],       [ -2.,  14., 104.],       [ 14.,   7., 101.],       [ 22.,   8., 100.],       [ 36.,  14., 104.],       [ 42.,   6.,  99.],       [ 56.,   9.,  97.],       [ 63.,  13.,  96.],       [ 76.,  12., 100.],       [ 93.,  10., 101.],       [103.,   7.,  98.],       [ -1.,  20.,  97.],       [ 15.,  23., 103.],       [ 22.,  27., 104.],       [ 32.,  19., 100.],       [ 47.,  22.,  97.],       [ 52.,  23., 103.],       [ 65.,  19., 100.],       [ 82.,  22.,  97.],       [ 86.,  22.,  97.],       [100.,  18., 104.],       [  1.,  29.,  96.],       [  6.,  35., 101.],       [ 20.,  36., 102.],       [ 29.,  31., 104.],       [ 42.,  36.,  98.],       [ 54.,  36., 102.],       [ 61.,  32.,  97.],       [ 80.,  34.,  95.],       [ 85.,  35., 104.],       [ 97.,  30.,  99.],       [  0.,  47., 102.],       [ 15.,  41., 100.],       [ 21.,  45.,  98.],       [ 37.,  40., 103.],       [ 41.,  45.,  95.],       [ 55.,  46., 100.],       [ 62.,  46., 104.],       [ 72.,  48.,  98.],       [ 87.,  44., 101.],       [ 96.,  41., 103.],       [ -4.,  54.,  95.],       [  8.,  59.,  99.],       [ 20.,  59., 103.],       [ 31.,  59.,  97.],       [ 47.,  59.,  98.],       [ 57.,  52.,  98.],       [ 63.,  53.,  96.],       [ 81.,  54., 104.],       [ 85.,  54., 101.],       [ 95.,  55., 104.],       [  1.,  69., 100.],       [ 13.,  69.,  95.],       [ 20.,  67., 100.],       [ 33.,  65., 102.],       [ 42.,  69., 102.],       [ 53.,  66., 103.],       [ 70.,  70., 103.],       [ 77.,  65., 102.],       [ 85.,  65.,  95.],       [101.,  67., 101.],       [  4.,  80., 103.],       [  7.,  81., 102.],       [ 26.,  82.,  99.],       [ 30.,  74., 104.],       [ 48.,  79.,  97.],       [ 53.,  80., 100.],       [ 61.,  75., 104.],       [ 78.,  77.,  99.],       [ 87.,  73.,  97.],       [101.,  78.,  96.],       [  2.,  91., 103.],       [ 12.,  88.,  99.],       [ 23.,  93., 102.],       [ 28.,  86.,  99.],       [ 46.,  89., 102.],       [ 52.,  87.,  95.],       [ 62.,  91.,  97.],       [ 74.,  92., 102.],       [ 87.,  84.,  97.],       [103.,  93.,  98.],       [  1., 100., 103.],       [  7.,  95., 101.],       [ 20.,  99.,  96.],       [ 30.,  97., 102.],       [ 44.,  98., 103.],       [ 57.,  97., 104.],       [ 68., 103., 100.],       [ 79.,  98.,  99.],       [ 92.,  99.,  95.],       [101., 103.,  95.]])
        n1   = 10
        p1   = 6
        knot1= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.4, 2.2, 3.1, 4. , 5. , 5. , 5. , 5. , 5. , 5. ])
        n2   = 10
        p2   = 6
        knot2= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.4, 2. , 2.6, 3.9, 5. , 5. , 5. , 5. , 5. , 5. ])
        n3   = 8
        p3   = 6
        knot3= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.1, 1.7, 3. , 3. , 3. , 3. , 3. , 3. ])
        vol  = lr.LRSplineVolume(n1,n2,n3,p1,p2,p3,knot1,knot2,knot3,controlpoints)
        vol2 = vol.clone()
        vol2.insert_knot([3.883], 0, 1) # insert C4-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 17)
        vol2.insert_knot([3.261], 0, 2) # insert C3-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 19)
        vol2.insert_knot([2.518], 0, 3) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 22)
        vol2.insert_knot([2.473], 0, 4) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 26)
        vol2.insert_knot([2.309], 0, 5) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 31)
        vol2.insert_knot([2.252], 1, 1) # insert C4-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 17)
        vol2.insert_knot([3.873], 1, 2) # insert C3-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 19)
        vol2.insert_knot([2.451], 1, 3) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 22)
        vol2.insert_knot([1.686], 1, 4) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 26)
        vol2.insert_knot([1.906], 1, 5) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 31)
        vol2.insert_knot([1.303], 2, 1) # insert C4-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 15)
        vol2.insert_knot([1.421], 2, 2) # insert C3-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 17)
        vol2.insert_knot([1.238], 2, 3) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 20)
        vol2.insert_knot([1.697], 2, 4) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 24)
        vol2.insert_knot([1.604], 2, 5) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 29)

        u    = np.linspace(vol.start(0), vol.end(0), 7)
        v    = np.linspace(vol.start(1), vol.end(1), 7)
        w    = np.linspace(vol.start(2), vol.end(2), 7)
        U,V,W= np.meshgrid(u,v,w)
        pt   = vol(U,V,W)
        pt2  = vol2(U,V,W)
        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_surface_5D_p66(self):
        controlpoints = np.array([[  2.,   3.,  -2.,   0.,  -2.],       [  9.,   1.,  -5.,  -1.,  -2.],       [ 24.,  -4.,  -5.,  -4.,   3.],       [ 31.,   0.,   1.,  -1.,   1.],       [ 44.,   0.,  -1.,   0.,  -5.],       [ 59.,  -2.,   1.,  -2.,  -2.],       [ 69.,  -4.,  -3.,  -5.,  -4.],       [ 77.,  -3.,   4.,   4.,   2.],       [ 85.,  -3.,  -3.,  -3.,  -5.],       [ 97.,  -1.,   0.,  -3.,  -1.],       [ -4.,  10.,   4.,   2.,  -3.],       [ 15.,  14.,   4.,  -2.,   1.],       [ 25.,  10.,  -4.,   3.,   4.],       [ 32.,  18.,  -3.,   3.,   1.],       [ 49.,  10.,   0.,   4.,  -3.],       [ 51.,  11.,   2.,  -5.,   1.],       [ 67.,   9.,  -4.,  -5.,   3.],       [ 80.,   9.,  -3.,  -5.,   4.],       [ 91.,  11.,  -5.,  -3.,  -3.],       [103.,  12.,   4.,  -2.,  -2.],       [  2.,  31.,  -5.,   3.,  -3.],       [ 14.,  26.,   3.,   3.,   1.],       [ 18.,  25.,  -3.,  -3.,  -4.],       [ 34.,  25.,  -4.,   2.,   2.],       [ 41.,  29.,   4.,  -4.,  -4.],       [ 57.,  27.,   2.,   0.,   1.],       [ 63.,  24.,  -5.,   2.,   1.],       [ 78.,  25.,   0.,  -1.,   1.],       [ 85.,  27.,  -4.,   1.,  -3.],       [ 95.,  24.,  -1.,  -4.,   3.],       [ -1.,  47.,   1.,   4.,  -5.],       [  8.,  44.,   4.,  -1.,  -5.],       [ 18.,  44.,  -2.,   4.,   0.],       [ 37.,  44.,  -5.,   3.,   1.],       [ 44.,  40.,   4.,   2.,   2.],       [ 53.,  39.,  -3.,   3.,   2.],       [ 61.,  41.,   4.,  -1.,   1.],       [ 79.,  38.,   2.,  -1.,   3.],       [ 92.,  44.,   3.,   2.,   0.],       [ 99.,  41.,   1.,  -4.,  -1.],       [  3.,  56.,  -2.,  -4.,   0.],       [ 10.,  58.,  -2.,   0.,   2.],       [ 23.,  61.,  -4.,  -2.,   4.],       [ 34.,  54.,  -1.,   2.,   3.],       [ 43.,  57.,   4.,   4.,  -5.],       [ 54.,  58.,   4.,  -2.,   0.],       [ 69.,  52.,   3.,   3.,   2.],       [ 77.,  55.,  -4.,  -2.,  -2.],       [ 93.,  55.,  -5.,  -4.,  -5.],       [ 96.,  57.,   4.,   3.,  -1.],       [ -1.,  71.,  -3.,   2.,   4.],       [ 10.,  68.,   2.,   2.,  -4.],       [ 19.,  68.,  -5.,   1.,   1.],       [ 37.,  74.,   1.,  -1.,   4.],       [ 41.,  74.,   4.,  -3.,   0.],       [ 52.,  76.,  -3.,   0.,  -5.],       [ 68.,  67.,   0.,   0.,   3.],       [ 82.,  69.,   3.,   1.,  -4.],       [ 85.,  72.,   0.,   0.,  -1.],       [ 99.,  76.,   3.,   2.,  -5.],       [ -1.,  81.,   2.,   0.,   1.],       [ 14.,  80.,   0.,   4.,  -3.],       [ 21.,  89.,  -5.,   1.,   3.],       [ 31.,  84.,  -1.,  -3.,  -1.],       [ 45.,  84.,   3.,   3.,  -3.],       [ 50.,  82.,   4.,   0.,   3.],       [ 68.,  88.,   0.,   2.,   0.],       [ 74.,  82.,   3.,   4.,   4.],       [ 90.,  82.,  -4.,   3.,   0.],       [100.,  85.,  -2.,   4.,  -2.],       [  1.,  98.,  -5.,   4.,   3.],       [ 13.,  97.,  -3.,  -5.,   4.],       [ 26., 104.,  -5.,   3.,  -5.],       [ 36., 104.,  -5.,   1.,   3.],       [ 43., 104.,  -4.,  -4.,   3.],       [ 60., 104.,  -2.,  -2.,   3.],       [ 70.,  95.,  -3.,  -4.,   2.],       [ 72.,  98.,   4.,  -1.,  -4.],       [ 89., 100.,  -3.,  -4.,   4.],       [102.,  95.,   1.,  -4.,   1.]])
        n1   = 10
        p1   = 6
        knot1= np.array([0. , 0. , 0. , 0. , 0. , 0. , 0.6, 1.7, 3.3, 3.6, 5. , 5. , 5. , 5. , 5. , 5. ])
        n2   = 8
        p2   = 6
        knot2= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.1, 2.1, 3. , 3. , 3. , 3. , 3. , 3. ])
        surf  = lr.LRSplineSurface(n1,n2,p1,p2,knot1,knot2, controlpoints)
        surf2 = surf.clone()
        surf2.insert_knot([1.118], 0, 1) # insert C4-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 17)
        surf2.insert_knot([2.609], 0, 2) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 19)
        surf2.insert_knot([2.103], 0, 3) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 22)
        surf2.insert_knot([3.123], 0, 4) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 26)
        surf2.insert_knot([2.773], 0, 5) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=0,with_multiplicities=True)), 31)
        surf2.insert_knot([1.668], 1, 1) # insert C4-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 15)
        surf2.insert_knot([1.550], 1, 2) # insert C3-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 17)
        surf2.insert_knot([1.210], 1, 3) # insert C2-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 20)
        surf2.insert_knot([2.084], 1, 4) # insert C1-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 24)
        surf2.insert_knot([1.367], 1, 5) # insert C0-knot
        self.assertEqual(len(surf2.knots(direction=1,with_multiplicities=True)), 29)

        u    = np.linspace(surf.start(0), surf.end(0), 9)
        v    = np.linspace(surf.start(1), surf.end(1), 9)
        U,V  = np.meshgrid(u,v)
        pt   = surf(U,V)
        pt2  = surf2(U,V)

        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)

    def test_volume_5D_p677(self):
        controlpoints = np.array([[  2.,  -5.,   4.,  -3.,  -4.],       [  8.,  -4.,   0.,  -2.,  -2.],       [ 15.,  -2.,   3.,  -2.,  -1.],       [ 27.,   4.,  -4.,  -1.,  -4.],       [ 43.,  -3.,  -5.,   2.,  -4.],       [ 45.,  -5.,   3.,  -3.,  -5.],       [ 60.,   4.,  -3.,  -1.,   0.],       [ 74.,  -5.,   2.,   2.,   4.],       [ 82.,   3.,   4.,   4.,   2.],       [ 89.,  -2.,   1.,  -3.,   1.],       [102.,  -4.,   4.,  -5.,   3.],       [  1.,   6.,   1.,   4.,  -3.],       [  5.,   7.,   0.,   4.,   1.],       [ 15.,  13.,  -1.,   2.,   4.],       [ 31.,   6.,   1.,  -3.,   1.],       [ 44.,   6.,   2.,  -1.,  -4.],       [ 48.,   5.,  -4.,   3.,   0.],       [ 55.,   7.,  -1.,  -1.,  -2.],       [ 69.,  14.,  -2.,  -3.,  -2.],       [ 82.,   7.,   2.,  -2.,   2.],       [ 91.,  11.,  -2.,  -5.,   0.],       [ 95.,  11.,  -5.,   1.,  -3.],       [ -2.,  17.,   3.,  -1.,  -5.],       [ 13.,  15.,  -2.,  -5.,  -1.],       [ 20.,  21.,   2.,   1.,  -4.],       [ 29.,  21.,   3.,   1.,   4.],       [ 43.,  22.,  -1.,  -5.,  -5.],       [ 54.,  17.,   3.,   3.,  -4.],       [ 62.,  21.,   2.,  -5.,  -1.],       [ 67.,  18.,  -4.,  -3.,  -4.],       [ 81.,  16.,  -3.,  -4.,   1.],       [ 86.,  15.,  -2.,   0.,   3.],       [ 95.,  22.,   4.,   3.,   0.],       [  2.,  30.,   3.,  -5.,  -3.],       [  6.,  25.,  -5.,   0.,  -1.],       [ 20.,  34.,   1.,   2.,  -2.],       [ 27.,  30.,  -2.,  -2.,   2.],       [ 37.,  26.,   1.,  -1.,  -4.],       [ 54.,  31.,  -5.,  -1.,   4.],       [ 60.,  26.,   0.,  -2.,   4.],       [ 65.,  32.,  -1.,   3.,  -5.],       [ 81.,  25.,  -2.,  -3.,  -1.],       [ 88.,  33.,  -3.,   4.,   3.],       [ 95.,  25.,   0.,  -1.,  -3.],       [ -1.,  40.,  -5.,  -1.,   1.],       [ 10.,  38.,  -2.,  -4.,   4.],       [ 20.,  38.,   2.,   4.,   3.],       [ 32.,  37.,  -2.,  -4.,   3.],       [ 43.,  39.,   4.,  -5.,  -4.],       [ 52.,  41.,   1.,   4.,   4.],       [ 60.,  35.,  -5.,   4.,   1.],       [ 69.,  40.,   3.,  -1.,   2.],       [ 81.,  36.,   4.,  -2.,   4.],       [ 92.,  42.,   1.,   0.,  -5.],       [103.,  41.,   3.,  -3.,   3.],       [ -2.,  48.,   3.,  -4.,  -5.],       [ 11.,  52.,  -1.,  -2.,  -3.],       [ 20.,  54.,   1.,  -1.,   2.],       [ 32.,  49.,  -4.,   0.,  -2.],       [ 44.,  51.,  -4.,   0.,  -2.],       [ 46.,  52.,  -5.,  -4.,   0.],       [ 55.,  50.,  -1.,   1.,   1.],       [ 69.,  54.,  -2.,   2.,   4.],       [ 81.,  53.,  -4.,   2.,  -1.],       [ 86.,  49.,   2.,   2.,   3.],       [102.,  47.,  -4.,   2.,  -1.],       [ -2.,  58.,   0.,   1.,   2.],       [  8.,  57.,  -4.,   4.,  -1.],       [ 23.,  56.,   0.,   3.,  -4.],       [ 33.,  59.,   0.,   3.,  -5.],       [ 41.,  64.,   3.,   2.,   2.],       [ 52.,  64.,   2.,  -4.,   3.],       [ 61.,  59.,  -3.,   0.,  -3.],       [ 72.,  64.,  -1.,   4.,  -3.],       [ 82.,  56.,  -2.,   2.,   2.],       [ 94.,  56.,  -2.,  -1.,  -2.],       [104.,  60.,   0.,  -5.,  -2.],       [  4.,  72.,   3.,   2.,   2.],       [  9.,  66.,   0.,  -2.,  -5.],       [ 20.,  65.,   2.,   1.,  -3.],       [ 27.,  72.,  -4.,  -3.,   4.],       [ 39.,  69.,  -2.,  -1.,   1.],       [ 51.,  67.,  -2.,  -1.,   3.],       [ 64.,  68.,   3.,   2.,  -4.],       [ 70.,  68.,   3.,   3.,   0.],       [ 75.,  69.,  -2.,  -3.,  -4.],       [ 88.,  73.,  -3.,  -5.,  -1.],       [ 98.,  73.,  -2.,  -1.,  -2.],       [  2.,  82.,  -4.,  -2.,  -5.],       [  9.,  77.,   4.,   4.,  -5.],       [ 22.,  82.,  -2.,  -1.,  -4.],       [ 26.,  83.,  -1.,  -5.,   3.],       [ 35.,  80.,   4.,   2.,   1.],       [ 54.,  76.,  -4.,  -5.,   3.],       [ 55.,  82.,   4.,  -3.,  -5.],       [ 70.,  77.,  -3.,  -2.,   1.],       [ 84.,  76.,  -3.,  -2.,   0.],       [ 87.,  84.,   4.,   0.,  -3.],       [ 96.,  78.,   2.,   4.,  -4.],       [  0.,  94.,   2.,   2.,  -4.],       [  5.,  85.,   1.,   2.,   2.],       [ 23.,  90.,  -1.,   4.,  -5.],       [ 30.,  86.,  -5.,   3.,  -4.],       [ 37.,  88.,   3.,  -3.,  -2.],       [ 45.,  94.,   3.,   0.,   1.],       [ 59.,  91.,  -3.,  -4.,  -5.],       [ 69.,  93.,   3.,  -2.,  -4.],       [ 83.,  92.,  -3.,   0.,   2.],       [ 85.,  88.,   2.,  -2.,   2.],       [100.,  91.,   2.,   3.,  -5.],       [  0., 102.,  -4.,   2.,  -4.],       [  7., 101.,  -3.,  -3.,   0.],       [ 17., 101.,  -1.,   4.,   4.],       [ 31.,  97.,   1.,   2.,  -3.],       [ 36., 101.,  -5.,   2.,  -3.],       [ 47.,  99.,  -5.,   0.,   3.],       [ 56.,  99.,   4.,  -2.,  -3.],       [ 72., 100.,   4.,  -4.,  -3.],       [ 79.,  95.,   4.,  -5.,  -2.],       [ 92.,  97.,   1.,   2.,   2.],       [102.,  96.,  -1.,   0.,   0.],       [  0.,   2.,  12.,   1.,  -5.],       [ 14.,   4.,   7.,  -2.,  -1.],       [ 15.,   3.,  10.,  -2.,   3.],       [ 31.,  -5.,  10.,   0.,   3.],       [ 36.,  -1.,  15.,  -2.,  -5.],       [ 54.,  -1.,   6.,  -4.,  -4.],       [ 59.,  -3.,   6.,  -3.,  -3.],       [ 73.,  -2.,  15.,   0.,  -3.],       [ 77.,  -2.,   7.,  -2.,   1.],       [ 90.,   4.,  13.,   0.,  -1.],       [ 98.,   4.,   8.,  -3.,   4.],       [ -2.,  11.,   7.,   1.,  -5.],       [  9.,   9.,   9.,  -3.,   2.],       [ 17.,   6.,   9.,   2.,   1.],       [ 29.,  14.,   8.,  -4.,  -2.],       [ 38.,  12.,  14.,  -5.,   1.],       [ 46.,  12.,  10.,  -4.,   3.],       [ 60.,  12.,   9.,   2.,   3.],       [ 65.,   9.,  13.,  -3.,  -3.],       [ 78.,   9.,   8.,   4.,   2.],       [ 90.,   8.,   9.,  -2.,   1.],       [104.,  13.,   6.,  -2.,  -5.],       [ -2.,  16.,  10.,  -2.,   0.],       [ 12.,  18.,  14.,  -4.,  -2.],       [ 23.,  16.,  12.,  -3.,  -3.],       [ 28.,  24.,   8.,   2.,   4.],       [ 42.,  17.,   6.,   3.,   3.],       [ 46.,  15.,  15.,   0.,  -1.],       [ 61.,  23.,   7.,   2.,  -5.],       [ 74.,  22.,   8.,   4.,   1.],       [ 82.,  20.,  13.,  -1.,   2.],       [ 94.,  16.,   9.,  -4.,  -3.],       [100.,  24.,  13.,   4.,   4.],       [  2.,  32.,  13.,   0.,  -2.],       [  8.,  26.,   7.,  -1.,  -3.],       [ 23.,  33.,   9.,   0.,   4.],       [ 26.,  28.,  10.,   2.,  -5.],       [ 44.,  32.,  15.,  -2.,  -3.],       [ 50.,  30.,   8.,   1.,   3.],       [ 55.,  33.,  13.,   2.,   2.],       [ 66.,  31.,  11.,   3.,  -3.],       [ 84.,  31.,   7.,  -5.,  -3.],       [ 93.,  31.,   8.,  -3.,   2.],       [100.,  27.,  12.,   3.,   0.],       [ -5.,  44.,   7.,   2.,  -3.],       [  6.,  39.,   6.,   3.,   4.],       [ 17.,  42.,   7.,   0.,   2.],       [ 25.,  39.,  14.,  -1.,  -4.],       [ 35.,  39.,   6.,  -4.,   2.],       [ 52.,  35.,  14.,  -1.,  -1.],       [ 63.,  42.,   7.,   2.,   4.],       [ 72.,  42.,  13.,   3.,  -4.],       [ 79.,  39.,  14.,  -1.,   1.],       [ 94.,  41.,   6.,   0.,  -3.],       [ 99.,  38.,  11.,  -2.,   0.],       [  1.,  46.,   9.,   2.,   4.],       [ 11.,  51.,  10.,   4.,   1.],       [ 24.,  53.,  10.,   0.,   1.],       [ 27.,  48.,  10.,   3.,   1.],       [ 36.,  45.,   6.,   2.,  -1.],       [ 48.,  53.,  14.,  -2.,  -1.],       [ 57.,  51.,  10.,  -2.,  -1.],       [ 72.,  47.,  11.,   3.,  -2.],       [ 84.,  51.,  14.,  -3.,  -4.],       [ 89.,  47.,   6.,  -3.,  -5.],       [103.,  47.,   8.,  -3.,  -4.],       [ -5.,  61.,  15.,   3.,  -5.],       [  6.,  59.,  15.,  -1.,  -5.],       [ 19.,  62.,  12.,   0.,   4.],       [ 34.,  59.,  13.,   3.,   4.],       [ 42.,  62.,  15.,  -2.,   1.],       [ 45.,  55.,   8.,   1.,   0.],       [ 61.,  56.,   6.,   3.,  -1.],       [ 69.,  59.,  13.,   0.,   3.],       [ 77.,  62.,   9.,  -4.,   2.],       [ 90.,  62.,   7.,  -5.,   3.],       [ 95.,  57.,  12.,  -3.,  -3.],       [ -3.,  69.,   9.,   4.,  -3.],       [  7.,  69.,   6.,   4.,  -5.],       [ 24.,  71.,  11.,   0.,  -3.],       [ 28.,  72.,  12.,   1.,  -2.],       [ 42.,  67.,  14.,   1.,   0.],       [ 54.,  70.,  11.,   1.,  -2.],       [ 62.,  71.,  14.,  -3.,  -4.],       [ 68.,  67.,   7.,  -2.,  -1.],       [ 82.,  68.,  10.,   0.,  -1.],       [ 94.,  67.,  11.,  -4.,   0.],       [102.,  67.,  13.,  -3.,   0.],       [ -3.,  76.,  14.,  -3.,  -3.],       [  6.,  76.,   6.,  -3.,   0.],       [ 22.,  81.,  14.,  -4.,   3.],       [ 34.,  82.,   9.,  -2.,  -4.],       [ 44.,  78.,  15.,   4.,   4.],       [ 50.,  84.,   6.,  -1.,   1.],       [ 57.,  78.,  13.,  -4.,  -5.],       [ 68.,  76.,  10.,   0.,   3.],       [ 79.,  81.,  15.,   3.,  -5.],       [ 93.,  77.,  12.,  -3.,  -4.],       [101.,  76.,   9.,  -4.,  -3.],       [ -2.,  86.,  13.,   4.,  -5.],       [  6.,  92.,  10.,   3.,  -2.],       [ 22.,  88.,  15.,   4.,   0.],       [ 30.,  91.,  12.,  -5.,  -5.],       [ 37.,  91.,  11.,   2.,  -5.],       [ 53.,  86.,   8.,  -1.,  -1.],       [ 56.,  90.,  11.,   3.,   0.],       [ 74.,  93.,  13.,   1.,  -5.],       [ 84.,  85.,  12.,  -5.,  -3.],       [ 90.,  88.,  13.,   3.,  -2.],       [ 99.,  89.,   8.,  -2.,   2.],       [ -1.,  96.,  12.,  -3.,   2.],       [  7.,  97.,  16.,  -4.,   2.],       [ 24.,  96.,  16.,  -2.,   0.],       [ 32., 100.,   7.,  -3.,   2.],       [ 44.,  95.,   7.,  -2.,  -3.],       [ 45., 103.,  10.,   0.,  -3.],       [ 62.,  98.,  10.,   4.,   4.],       [ 74., 103.,  15.,  -2.,  -2.],       [ 84., 103.,   9.,   0.,   3.],       [ 93., 101.,   6.,   1.,   1.],       [100., 102.,   9.,   4.,  -3.],       [ -1.,  -4.,  21.,  -4.,   2.],       [  5.,   3.,  26.,   4.,  -5.],       [ 18.,  -4.,  26.,   1.,   2.],       [ 30.,  -2.,  17.,   3.,   4.],       [ 40.,  -1.,  19.,   4.,   2.],       [ 50.,   2.,  26.,  -2.,   1.],       [ 61.,  -3.,  17.,   1.,  -5.],       [ 70.,  -2.,  21.,  -4.,   3.],       [ 75.,  -5.,  21.,  -4.,   0.],       [ 91.,   4.,  23.,  -3.,   0.],       [ 97.,   1.,  20.,  -5.,  -5.],       [ -4.,   9.,  18.,  -2.,   3.],       [ 12.,  11.,  24.,  -2.,   3.],       [ 15.,   7.,  19.,   4.,  -5.],       [ 33.,  10.,  22.,  -2.,   2.],       [ 35.,  11.,  25.,   0.,   2.],       [ 47.,   7.,  22.,  -1.,   2.],       [ 57.,  11.,  20.,   3.,   2.],       [ 67.,   5.,  27.,   4.,   1.],       [ 76.,  13.,  25.,   0.,  -5.],       [ 93.,  12.,  21.,   0.,   4.],       [101.,  11.,  23.,   1.,   0.],       [ -4.,  18.,  19.,  -5.,   0.],       [ 13.,  22.,  23.,  -1.,   2.],       [ 23.,  19.,  26.,  -1.,   3.],       [ 26.,  24.,  24.,   2.,  -4.],       [ 40.,  16.,  22.,   0.,  -2.],       [ 50.,  16.,  17.,  -4.,   1.],       [ 56.,  18.,  20.,   0.,   2.],       [ 73.,  21.,  22.,   0.,   0.],       [ 84.,  18.,  20.,   3.,   3.],       [ 88.,  23.,  22.,  -4.,  -3.],       [ 95.,  23.,  20.,  -1.,  -4.],       [  2.,  30.,  26.,   3.,   3.],       [  8.,  29.,  24.,  -2.,   1.],       [ 24.,  27.,  18.,  -1.,  -5.],       [ 26.,  26.,  27.,  -2.,  -3.],       [ 37.,  33.,  19.,  -4.,  -5.],       [ 53.,  27.,  19.,   2.,  -1.],       [ 62.,  32.,  18.,  -2.,  -1.],       [ 71.,  25.,  17.,  -2.,   2.],       [ 76.,  29.,  22.,   3.,   4.],       [ 92.,  27.,  24.,   1.,   0.],       [100.,  31.,  19.,   1.,   1.],       [  2.,  39.,  18.,   1.,   1.],       [ 10.,  41.,  20.,  -1.,  -2.],       [ 24.,  44.,  18.,   4.,   3.],       [ 31.,  43.,  25.,  -5.,  -1.],       [ 41.,  40.,  18.,   4.,   2.],       [ 50.,  37.,  24.,   0.,  -2.],       [ 58.,  44.,  17.,  -2.,  -2.],       [ 68.,  37.,  24.,  -4.,   2.],       [ 77.,  43.,  21.,   1.,  -5.],       [ 91.,  38.,  18.,   2.,  -5.],       [102.,  37.,  20.,   3.,   0.],       [  1.,  53.,  23.,  -1.,   3.],       [  6.,  51.,  26.,   1.,   1.],       [ 19.,  47.,  21.,  -5.,  -2.],       [ 28.,  51.,  22.,   3.,   3.],       [ 41.,  47.,  17.,   1.,  -4.],       [ 53.,  46.,  17.,  -1.,  -2.],       [ 55.,  54.,  22.,  -3.,  -3.],       [ 71.,  54.,  24.,  -5.,   0.],       [ 77.,  46.,  22.,  -4.,  -4.],       [ 89.,  52.,  17.,   0.,   3.],       [102.,  54.,  24.,   1.,   3.],       [ -3.,  60.,  25.,   1.,   4.],       [ 12.,  56.,  19.,   2.,  -1.],       [ 21.,  64.,  23.,   4.,  -3.],       [ 33.,  57.,  20.,  -5.,  -4.],       [ 44.,  64.,  26.,   0.,   0.],       [ 54.,  55.,  19.,  -3.,   2.],       [ 60.,  56.,  18.,   0.,  -3.],       [ 66.,  55.,  20.,   4.,  -2.],       [ 84.,  60.,  18.,  -1.,  -4.],       [ 93.,  56.,  24.,  -3.,   4.],       [100.,  62.,  19.,   2.,   1.],       [ -1.,  72.,  17.,   2.,  -5.],       [  7.,  71.,  17.,  -3.,   4.],       [ 21.,  74.,  22.,  -2.,  -4.],       [ 33.,  70.,  24.,  -4.,  -3.],       [ 38.,  72.,  26.,   4.,   4.],       [ 54.,  68.,  26.,   0.,   2.],       [ 56.,  65.,  25.,   2.,  -1.],       [ 65.,  65.,  24.,  -5.,   4.],       [ 83.,  70.,  17.,  -1.,  -3.],       [ 93.,  67.,  22.,   2.,   3.],       [ 95.,  73.,  19.,  -4.,  -3.],       [  0.,  75.,  25.,   3.,   0.],       [  5.,  82.,  17.,  -3.,   3.],       [ 18.,  75.,  26.,  -2.,   1.],       [ 32.,  83.,  19.,   4.,   1.],       [ 36.,  79.,  18.,  -1.,  -4.],       [ 51.,  82.,  19.,  -3.,  -1.],       [ 64.,  80.,  25.,  -2.,  -3.],       [ 67.,  77.,  26.,   0.,  -3.],       [ 80.,  75.,  26.,  -1.,  -3.],       [ 94.,  76.,  18.,   1.,  -2.],       [104.,  75.,  24.,   0.,  -2.],       [  0.,  90.,  19.,  -2.,   1.],       [ 14.,  90.,  20.,  -1.,   1.],       [ 16.,  87.,  23.,  -3.,   0.],       [ 33.,  85.,  25.,   3.,  -5.],       [ 43.,  89.,  26.,   0.,  -5.],       [ 45.,  87.,  22.,   0.,  -2.],       [ 60.,  94.,  24.,   3.,  -2.],       [ 66.,  91.,  19.,   3.,   0.],       [ 79.,  87.,  18.,   2.,   0.],       [ 87.,  88.,  21.,   4.,  -3.],       [103.,  93.,  25.,  -3.,  -5.],       [  1.,  99.,  26.,   3.,   4.],       [  7., 100.,  21.,   3.,  -4.],       [ 20., 104.,  25.,   1.,  -3.],       [ 29.,  97.,  26.,  -3.,   2.],       [ 44., 101.,  26.,   2.,   3.],       [ 45.,  97.,  23.,   3.,   3.],       [ 55.,  95.,  27.,  -2.,  -2.],       [ 70., 101.,  24.,   4.,   4.],       [ 84., 103.,  22.,  -3.,  -1.],       [ 87.,  96.,  25.,  -5.,   2.],       [100., 100.,  18.,  -2.,   0.],       [  2.,  -4.,  35.,  -4.,   2.],       [  9.,  -4.,  34.,   0.,  -5.],       [ 21.,  -2.,  37.,   2.,  -4.],       [ 26.,  -1.,  34.,   1.,   4.],       [ 39.,  -1.,  35.,  -1.,  -1.],       [ 53.,  -1.,  29.,  -1.,   1.],       [ 64.,   0.,  36.,   3.,  -2.],       [ 74.,   2.,  29.,  -2.,   0.],       [ 80.,   2.,  30.,   4.,   0.],       [ 92.,   2.,  33.,  -5.,   1.],       [ 95.,   2.,  34.,   2.,   3.],       [  3.,  14.,  28.,   3.,   0.],       [ 10.,  10.,  34.,  -4.,  -3.],       [ 18.,  12.,  37.,   1.,   2.],       [ 30.,  13.,  28.,   0.,  -3.],       [ 36.,   8.,  28.,  -2.,  -1.],       [ 48.,   7.,  32.,   1.,   1.],       [ 62.,  14.,  29.,   3.,  -3.],       [ 74.,  11.,  33.,  -2.,   1.],       [ 81.,   8.,  33.,   4.,  -3.],       [ 89.,  12.,  28.,   3.,   1.],       [104.,   9.,  37.,  -1.,  -5.],       [  0.,  20.,  37.,  -5.,  -4.],       [  9.,  21.,  32.,  -2.,  -4.],       [ 22.,  21.,  30.,  -4.,   0.],       [ 33.,  18.,  37.,  -4.,  -2.],       [ 42.,  17.,  30.,   2.,   4.],       [ 49.,  17.,  34.,   4.,  -2.],       [ 56.,  19.,  34.,   4.,  -5.],       [ 66.,  19.,  35.,  -4.,   2.],       [ 81.,  20.,  31.,  -4.,   2.],       [ 85.,  19.,  34.,  -2.,   4.],       [104.,  15.,  36.,  -5.,  -4.],       [ -4.,  26.,  32.,   3.,  -3.],       [  7.,  26.,  37.,  -1.,  -1.],       [ 16.,  28.,  29.,   3.,  -4.],       [ 25.,  33.,  31.,   0.,  -1.],       [ 42.,  32.,  32.,  -2.,   4.],       [ 51.,  32.,  33.,   1.,   4.],       [ 59.,  25.,  29.,  -5.,   4.],       [ 74.,  28.,  33.,   0.,  -2.],       [ 81.,  33.,  36.,  -2.,   3.],       [ 91.,  28.,  32.,   0.,  -5.],       [100.,  25.,  31.,   0.,  -4.],       [ -2.,  39.,  36.,   3.,   0.],       [  5.,  36.,  35.,  -3.,  -2.],       [ 20.,  37.,  28.,  -2.,  -2.],       [ 32.,  42.,  34.,  -1.,   3.],       [ 43.,  36.,  36.,   2.,   0.],       [ 46.,  43.,  38.,   3.,   2.],       [ 62.,  43.,  37.,   4.,   1.],       [ 69.,  35.,  38.,   0.,   0.],       [ 77.,  39.,  29.,  -5.,   1.],       [ 90.,  39.,  33.,   2.,  -4.],       [102.,  38.,  30.,   3.,  -2.],       [  4.,  45.,  30.,  -4.,  -3.],       [ 11.,  54.,  35.,   4.,  -4.],       [ 23.,  50.,  29.,   4.,   0.],       [ 32.,  48.,  35.,  -1.,   1.],       [ 38.,  53.,  28.,   1.,  -4.],       [ 52.,  46.,  34.,   3.,  -4.],       [ 55.,  54.,  32.,   4.,  -4.],       [ 66.,  51.,  32.,  -4.,  -5.],       [ 84.,  53.,  32.,  -1.,  -3.],       [ 86.,  54.,  31.,  -4.,  -2.],       [ 97.,  48.,  37.,   1.,   2.],       [  2.,  59.,  37.,  -3.,  -4.],       [ 14.,  59.,  36.,   0.,   3.],       [ 21.,  55.,  32.,  -5.,  -5.],       [ 34.,  59.,  35.,   3.,   1.],       [ 38.,  62.,  29.,   2.,  -4.],       [ 46.,  55.,  36.,  -3.,   1.],       [ 56.,  62.,  28.,  -4.,   1.],       [ 66.,  59.,  35.,   3.,   3.],       [ 75.,  55.,  28.,  -3.,   2.],       [ 92.,  56.,  30.,   3.,   3.],       [103.,  61.,  36.,  -5.,   3.],       [  0.,  74.,  28.,   3.,   0.],       [ 14.,  65.,  34.,   3.,  -4.],       [ 23.,  73.,  30.,  -1.,  -3.],       [ 26.,  65.,  37.,  -5.,  -5.],       [ 40.,  73.,  36.,   2.,  -1.],       [ 45.,  72.,  37.,   1.,  -5.],       [ 58.,  71.,  32.,  -1.,  -3.],       [ 74.,  65.,  30.,  -2.,  -2.],       [ 84.,  68.,  34.,   4.,  -2.],       [ 85.,  69.,  31.,   1.,  -3.],       [100.,  67.,  29.,   0.,   1.],       [ -3.,  76.,  34.,   4.,  -1.],       [ 10.,  76.,  33.,  -5.,  -4.],       [ 17.,  79.,  34.,  -3.,  -3.],       [ 29.,  75.,  31.,   2.,  -5.],       [ 41.,  76.,  33.,  -3.,  -5.],       [ 50.,  80.,  35.,   0.,   1.],       [ 58.,  78.,  32.,  -4.,  -2.],       [ 74.,  76.,  36.,   0.,   3.],       [ 75.,  80.,  37.,  -4.,   4.],       [ 94.,  84.,  33.,   3.,   0.],       [100.,  77.,  32.,  -3.,  -2.],       [  4.,  86.,  35.,   0.,   2.],       [ 13.,  86.,  37.,   0.,  -3.],       [ 18.,  94.,  35.,   0.,  -5.],       [ 29.,  92.,  37.,  -5.,   0.],       [ 37.,  88.,  38.,   0.,  -1.],       [ 46.,  88.,  31.,   2.,   1.],       [ 58.,  91.,  29.,   2.,   1.],       [ 65.,  90.,  31.,  -3.,   1.],       [ 83.,  87.,  35.,   0.,  -2.],       [ 92.,  91.,  35.,   2.,   0.],       [100.,  85.,  32.,  -1.,  -3.],       [  3.,  99.,  33.,  -3.,  -5.],       [  6.,  97.,  30.,   2.,  -1.],       [ 17., 101.,  31.,   3.,   1.],       [ 25., 101.,  31.,   1.,   4.],       [ 36.,  96.,  29.,   2.,  -3.],       [ 53.,  97.,  29.,  -4.,  -4.],       [ 60., 102.,  36.,  -1.,  -3.],       [ 65.,  95.,  36.,  -2.,   0.],       [ 77., 101.,  30.,   3.,   3.],       [ 89., 101.,  33.,   4.,  -1.],       [ 95.,  98.,  29.,  -1.,   4.],       [  1.,   4.,  42.,   4.,   4.],       [  6.,  -4.,  43.,   2.,  -5.],       [ 16.,  -3.,  41.,   4.,   0.],       [ 32.,   2.,  41.,  -4.,   3.],       [ 44.,  -3.,  48.,  -1.,   4.],       [ 50.,  -3.,  41.,  -2.,  -1.],       [ 55.,   4.,  42.,  -5.,   4.],       [ 67.,   4.,  47.,   2.,  -5.],       [ 77.,   1.,  48.,  -2.,   4.],       [ 88.,   4.,  41.,  -2.,   2.],       [102.,  -1.,  49.,   0.,  -3.],       [  3.,  12.,  39.,  -3.,  -5.],       [ 14.,   8.,  49.,  -2.,  -1.],       [ 17.,  10.,  45.,   1.,  -3.],       [ 32.,  14.,  46.,   4.,  -4.],       [ 42.,   5.,  44.,   0.,  -1.],       [ 53.,  11.,  44.,  -2.,  -2.],       [ 57.,  14.,  43.,  -3.,   2.],       [ 70.,   7.,  42.,  -5.,  -1.],       [ 83.,  12.,  42.,   3.,   3.],       [ 86.,  10.,  47.,   4.,  -2.],       [100.,   8.,  41.,  -4.,  -3.],       [  4.,  22.,  48.,  -3.,  -4.],       [  5.,  22.,  47.,   0.,  -3.],       [ 17.,  22.,  44.,   2.,   1.],       [ 30.,  16.,  45.,  -5.,  -3.],       [ 39.,  17.,  43.,  -1.,  -5.],       [ 45.,  22.,  47.,  -2.,  -2.],       [ 58.,  20.,  47.,   3.,   0.],       [ 68.,  22.,  40.,   2.,  -2.],       [ 81.,  23.,  42.,   1.,   1.],       [ 90.,  20.,  42.,   0.,   2.],       [ 98.,  17.,  46.,   2.,  -1.],       [ -1.,  28.,  46.,  -3.,   0.],       [ 11.,  28.,  48.,   0.,  -1.],       [ 17.,  27.,  46.,   0.,   1.],       [ 26.,  31.,  43.,   1.,   3.],       [ 42.,  27.,  45.,   3.,  -1.],       [ 54.,  25.,  47.,   0.,   3.],       [ 56.,  29.,  43.,   1.,   3.],       [ 74.,  26.,  39.,  -3.,  -5.],       [ 83.,  25.,  42.,  -4.,   1.],       [ 94.,  26.,  46.,  -1.,  -3.],       [ 97.,  34.,  46.,  -4.,   4.],       [  1.,  38.,  46.,  -2.,   4.],       [  6.,  39.,  44.,   1.,   0.],       [ 23.,  43.,  47.,   2.,  -3.],       [ 25.,  38.,  39.,   3.,  -4.],       [ 36.,  42.,  48.,  -1.,   3.],       [ 50.,  35.,  48.,  -5.,  -2.],       [ 63.,  37.,  39.,   2.,   0.],       [ 68.,  35.,  44.,  -3.,  -5.],       [ 77.,  44.,  41.,   0.,  -4.],       [ 89.,  41.,  48.,   1.,   1.],       [104.,  36.,  45.,   2.,  -5.],       [ -1.,  50.,  44.,  -5.,  -5.],       [ 12.,  47.,  41.,   1.,  -5.],       [ 16.,  51.,  47.,  -1.,  -4.],       [ 31.,  53.,  46.,  -2.,   2.],       [ 39.,  54.,  45.,  -3.,   3.],       [ 45.,  51.,  47.,  -3.,  -5.],       [ 63.,  45.,  46.,   4.,   2.],       [ 72.,  46.,  48.,   1.,   4.],       [ 80.,  46.,  41.,   0.,   4.],       [ 85.,  51.,  44.,   0.,  -1.],       [ 97.,  46.,  47.,   2.,   0.],       [ -2.,  63.,  41.,   2.,   2.],       [ 13.,  58.,  42.,   3.,  -2.],       [ 23.,  64.,  39.,  -4.,  -2.],       [ 28.,  64.,  42.,   1.,  -3.],       [ 38.,  62.,  42.,  -5.,   0.],       [ 50.,  57.,  43.,  -1.,  -4.],       [ 62.,  55.,  45.,  -2.,  -4.],       [ 69.,  58.,  39.,   2.,   0.],       [ 76.,  63.,  46.,   2.,   3.],       [ 92.,  63.,  39.,   1.,   4.],       [ 98.,  59.,  43.,   2.,  -4.],       [  4.,  67.,  40.,   3.,   4.],       [ 14.,  67.,  39.,  -3.,   4.],       [ 24.,  70.,  49.,   4.,  -4.],       [ 33.,  70.,  40.,   2.,   3.],       [ 35.,  72.,  46.,   4.,  -5.],       [ 51.,  73.,  45.,   3.,   0.],       [ 55.,  70.,  48.,   4.,   3.],       [ 68.,  67.,  45.,   2.,  -5.],       [ 78.,  74.,  47.,  -2.,   0.],       [ 92.,  74.,  46.,   0.,   1.],       [ 98.,  69.,  48.,   3.,  -2.],       [ -3.,  81.,  39.,  -3.,  -4.],       [ 13.,  77.,  41.,   2.,   2.],       [ 23.,  79.,  44.,  -5.,   4.],       [ 31.,  79.,  40.,  -2.,   3.],       [ 37.,  77.,  47.,   1.,   1.],       [ 50.,  82.,  39.,  -4.,  -4.],       [ 57.,  78.,  42.,  -3.,  -5.],       [ 70.,  76.,  47.,  -4.,   0.],       [ 77.,  76.,  47.,  -4.,   4.],       [ 88.,  82.,  42.,  -1.,   4.],       [ 96.,  78.,  40.,  -2.,  -2.],       [ -4.,  88.,  46.,   3.,  -2.],       [ 12.,  88.,  43.,  -4.,   0.],       [ 18.,  88.,  49.,   1.,   1.],       [ 33.,  85.,  45.,  -5.,  -5.],       [ 44.,  92.,  45.,  -2.,   1.],       [ 52.,  90.,  44.,   0.,   0.],       [ 63.,  92.,  47.,   0.,  -5.],       [ 69.,  92.,  44.,  -3.,   0.],       [ 75.,  86.,  48.,  -2.,   3.],       [ 85.,  94.,  44.,  -5.,  -3.],       [ 96.,  86.,  47.,  -5.,   3.],       [ -4., 100.,  44.,   0.,  -4.],       [ 10.,  96.,  41.,   3.,  -4.],       [ 23., 102.,  46.,   1.,   0.],       [ 28.,  95.,  46.,  -2.,  -3.],       [ 37., 101.,  48.,  -4.,  -5.],       [ 48.,  96.,  46.,  -1.,  -1.],       [ 64.,  95.,  44.,   0.,  -5.],       [ 65.,  96.,  44.,   4.,   1.],       [ 82.,  95.,  43.,   3.,   4.],       [ 91., 104.,  44.,  -4.,  -3.],       [ 98., 100.,  43.,   2.,   3.],       [  4.,  -2.,  51.,   2.,   2.],       [ 12.,   1.,  59.,  -4.,   3.],       [ 18.,  -2.,  56.,   0.,  -5.],       [ 34.,   1.,  55.,  -5.,   2.],       [ 44.,   2.,  58.,  -1.,  -1.],       [ 45.,  -5.,  59.,  -4.,  -1.],       [ 62.,  -4.,  59.,  -5.,  -4.],       [ 73.,  -5.,  51.,   3.,   2.],       [ 81.,   2.,  59.,   0.,  -3.],       [ 92.,  -2.,  54.,  -4.,  -5.],       [ 98.,  -4.,  55.,  -3.,   2.],       [ -1.,   9.,  57.,   2.,   1.],       [ 10.,  11.,  53.,  -2.,   1.],       [ 21.,   7.,  57.,  -4.,   3.],       [ 34.,   9.,  57.,   3.,   4.],       [ 41.,  10.,  52.,   3.,   1.],       [ 48.,   7.,  58.,  -3.,   4.],       [ 55.,  14.,  59.,   3.,  -4.],       [ 73.,  10.,  58.,  -2.,   0.],       [ 80.,   9.,  57.,   2.,  -5.],       [ 93.,   5.,  55.,   3.,   3.],       [ 96.,   5.,  51.,  -2.,  -5.],       [  2.,  23.,  53.,  -5.,   0.],       [ 10.,  21.,  55.,   2.,  -3.],       [ 17.,  19.,  58.,   4.,   3.],       [ 33.,  22.,  54.,  -2.,  -3.],       [ 37.,  18.,  51.,   4.,  -3.],       [ 54.,  20.,  51.,   4.,   0.],       [ 64.,  24.,  50.,  -1.,   0.],       [ 68.,  15.,  51.,  -3.,   4.],       [ 83.,  18.,  58.,  -4.,  -4.],       [ 93.,  18.,  51.,   3.,   4.],       [ 98.,  22.,  54.,   1.,   2.],       [  2.,  30.,  56.,   3.,  -3.],       [  5.,  29.,  52.,  -5.,   4.],       [ 23.,  34.,  54.,   1.,  -3.],       [ 30.,  29.,  52.,   2.,  -3.],       [ 37.,  32.,  55.,  -3.,  -3.],       [ 54.,  28.,  56.,   3.,   1.],       [ 62.,  28.,  57.,   1.,   1.],       [ 67.,  34.,  55.,   3.,   2.],       [ 79.,  28.,  53.,  -2.,  -3.],       [ 86.,  28.,  51.,   3.,   0.],       [104.,  33.,  56.,   3.,   2.],       [  1.,  42.,  51.,   1.,  -2.],       [  7.,  36.,  55.,  -3.,   0.],       [ 24.,  39.,  52.,  -1.,   0.],       [ 29.,  38.,  53.,  -2.,  -4.],       [ 35.,  43.,  51.,  -5.,   4.],       [ 51.,  37.,  56.,  -2.,  -4.],       [ 61.,  41.,  54.,  -5.,  -2.],       [ 65.,  35.,  50.,   2.,   0.],       [ 84.,  35.,  50.,  -4.,  -5.],       [ 89.,  40.,  59.,  -3.,   2.],       [103.,  42.,  56.,  -4.,   1.],       [  2.,  47.,  58.,   3.,   4.],       [ 11.,  45.,  52.,   4.,   4.],       [ 18.,  47.,  54.,   3.,  -3.],       [ 31.,  51.,  55.,   0.,  -5.],       [ 38.,  50.,  57.,   1.,   1.],       [ 45.,  50.,  59.,  -5.,  -3.],       [ 63.,  49.,  59.,  -1.,  -1.],       [ 72.,  54.,  56.,  -1.,  -4.],       [ 78.,  47.,  59.,  -1.,  -3.],       [ 85.,  54.,  55.,  -4.,  -4.],       [101.,  45.,  57.,  -1.,   3.],       [  2.,  64.,  54.,  -2.,   1.],       [  6.,  57.,  54.,  -1.,   3.],       [ 19.,  62.,  60.,   2.,  -2.],       [ 28.,  59.,  55.,   0.,   3.],       [ 38.,  63.,  50.,  -4.,   0.],       [ 47.,  60.,  59.,   3.,   4.],       [ 59.,  56.,  55.,  -5.,   2.],       [ 69.,  60.,  55.,  -4.,   1.],       [ 82.,  62.,  58.,  -2.,   3.],       [ 90.,  59.,  53.,  -1.,  -2.],       [101.,  58.,  51.,  -2.,  -2.],       [ -5.,  67.,  59.,   2.,  -1.],       [  7.,  70.,  53.,   0.,   2.],       [ 18.,  72.,  52.,   3.,  -5.],       [ 32.,  73.,  50.,  -5.,   2.],       [ 35.,  70.,  50.,  -2.,   2.],       [ 54.,  67.,  59.,  -2.,  -3.],       [ 64.,  70.,  57.,  -5.,  -5.],       [ 67.,  65.,  54.,   2.,  -5.],       [ 81.,  65.,  57.,  -3.,   3.],       [ 90.,  71.,  53.,  -3.,   4.],       [100.,  70.,  58.,  -2.,  -1.],       [ -4.,  77.,  53.,  -3.,  -3.],       [ 11.,  80.,  58.,  -4.,  -5.],       [ 16.,  75.,  54.,  -1.,   1.],       [ 26.,  83.,  60.,  -1.,  -1.],       [ 40.,  80.,  59.,   0.,  -5.],       [ 52.,  83.,  58.,   4.,   0.],       [ 62.,  81.,  60.,   1.,   3.],       [ 67.,  77.,  55.,   0.,   0.],       [ 83.,  83.,  52.,   4.,   0.],       [ 90.,  76.,  53.,  -2.,  -1.],       [101.,  79.,  57.,   4.,  -1.],       [  2.,  91.,  53.,   2.,  -3.],       [ 12.,  88.,  51.,  -1.,  -5.],       [ 15.,  93.,  57.,  -5.,  -3.],       [ 25.,  90.,  59.,   2.,  -4.],       [ 36.,  86.,  54.,   2.,  -2.],       [ 48.,  89.,  59.,   4.,   2.],       [ 58.,  91.,  51.,   0.,  -3.],       [ 70.,  93.,  53.,   2.,   0.],       [ 78.,  93.,  55.,   4.,  -1.],       [ 94.,  85.,  51.,   4.,  -3.],       [ 97.,  91.,  60.,   3.,   4.],       [  4.,  96.,  56.,  -4.,   3.],       [ 14.,  95.,  51.,   1.,   2.],       [ 20.,  97.,  59.,   3.,  -3.],       [ 34.,  97.,  60.,   1.,  -4.],       [ 43.,  97.,  59.,  -3.,   4.],       [ 45., 102.,  51.,   2.,  -3.],       [ 59.,  97.,  51.,   3.,  -3.],       [ 70., 102.,  58.,  -2.,   2.],       [ 77., 100.,  55.,   1.,   4.],       [ 92., 104.,  53.,  -5.,  -4.],       [101., 101.,  57.,  -5.,   2.],       [ -3.,   1.,  62.,  -5.,   2.],       [ 14.,  -3.,  68.,   4.,  -4.],       [ 16.,  -5.,  65.,   0.,   2.],       [ 31.,   2.,  70.,   3.,   3.],       [ 35.,   4.,  67.,  -2.,   1.],       [ 53.,   3.,  67.,   4.,   0.],       [ 60.,  -1.,  68.,  -3.,   2.],       [ 66.,   1.,  69.,   2.,  -3.],       [ 80.,   4.,  61.,  -5.,  -3.],       [ 85.,   1.,  61.,  -4.,  -2.],       [103.,  -2.,  65.,  -3.,   2.],       [ -1.,  11.,  65.,  -2.,   3.],       [  5.,   7.,  71.,   2.,  -5.],       [ 16.,  14.,  62.,   4.,  -3.],       [ 34.,   8.,  62.,   2.,  -4.],       [ 39.,   7.,  70.,  -4.,   4.],       [ 49.,  10.,  68.,   4.,  -5.],       [ 58.,  11.,  71.,  -2.,  -1.],       [ 70.,  14.,  65.,  -3.,   4.],       [ 83.,  12.,  71.,   2.,  -2.],       [ 86.,  11.,  66.,  -5.,   1.],       [101.,   7.,  70.,  -4.,  -3.],       [  3.,  17.,  61.,  -2.,  -3.],       [  6.,  18.,  62.,   0.,   0.],       [ 20.,  19.,  68.,  -5.,  -4.],       [ 28.,  19.,  68.,   3.,  -2.],       [ 37.,  22.,  69.,   3.,   3.],       [ 47.,  20.,  71.,  -1.,   1.],       [ 61.,  24.,  68.,  -2.,   0.],       [ 71.,  16.,  69.,  -2.,   3.],       [ 81.,  18.,  65.,   4.,  -3.],       [ 94.,  15.,  70.,  -3.,   1.],       [ 95.,  23.,  63.,   1.,   0.],       [  2.,  33.,  67.,   3.,  -1.],       [ 14.,  34.,  68.,  -1.,   4.],       [ 19.,  27.,  68.,  -1.,   0.],       [ 26.,  30.,  69.,   0.,   0.],       [ 37.,  27.,  69.,  -2.,  -5.],       [ 54.,  30.,  64.,  -2.,   0.],       [ 56.,  34.,  69.,  -4.,   1.],       [ 68.,  34.,  69.,  -1.,   3.],       [ 76.,  30.,  62.,   0.,   0.],       [ 89.,  30.,  64.,  -1.,   2.],       [104.,  33.,  66.,   4.,  -4.],       [ -1.,  35.,  69.,   0.,  -4.],       [ 14.,  43.,  70.,  -5.,   4.],       [ 23.,  42.,  64.,   1.,  -1.],       [ 32.,  43.,  70.,   2.,   0.],       [ 44.,  35.,  63.,  -4.,   0.],       [ 47.,  41.,  68.,   1.,   2.],       [ 60.,  43.,  71.,   2.,  -5.],       [ 71.,  44.,  65.,   1.,  -3.],       [ 79.,  39.,  65.,   3.,   1.],       [ 87.,  39.,  66.,   3.,   3.],       [104.,  38.,  66.,   3.,   4.],       [ -4.,  54.,  65.,  -4.,  -3.],       [  6.,  49.,  71.,  -2.,   0.],       [ 24.,  49.,  61.,   0.,  -5.],       [ 31.,  49.,  66.,   1.,   3.],       [ 37.,  51.,  66.,  -2.,  -4.],       [ 54.,  52.,  70.,  -5.,   2.],       [ 58.,  52.,  70.,  -5.,  -3.],       [ 66.,  52.,  71.,  -3.,   0.],       [ 76.,  49.,  71.,  -4.,   1.],       [ 91.,  53.,  66.,  -4.,  -2.],       [ 95.,  51.,  69.,  -4.,  -2.],       [  0.,  64.,  64.,  -4.,  -3.],       [ 12.,  57.,  68.,   1.,   0.],       [ 15.,  56.,  68.,  -3.,   4.],       [ 27.,  64.,  63.,   2.,   0.],       [ 35.,  63.,  63.,  -4.,   4.],       [ 46.,  60.,  67.,   2.,  -5.],       [ 55.,  63.,  64.,  -1.,  -2.],       [ 71.,  58.,  64.,   4.,  -4.],       [ 76.,  60.,  66.,   3.,   0.],       [ 85.,  63.,  69.,   2.,   1.],       [102.,  62.,  71.,  -5.,   0.],       [  0.,  65.,  64.,   0.,  -3.],       [ 14.,  73.,  68.,   0.,   0.],       [ 21.,  65.,  67.,  -2.,  -1.],       [ 31.,  68.,  67.,  -4.,   4.],       [ 36.,  74.,  62.,  -3.,  -3.],       [ 53.,  72.,  65.,  -2.,   1.],       [ 58.,  65.,  67.,  -3.,  -2.],       [ 66.,  74.,  63.,   3.,  -2.],       [ 78.,  66.,  71.,   1.,   3.],       [ 91.,  70.,  65.,   4.,  -1.],       [ 96.,  69.,  61.,   3.,  -2.],       [ -4.,  81.,  63.,  -2.,   0.],       [ 14.,  83.,  62.,  -3.,   4.],       [ 20.,  82.,  61.,  -4.,  -4.],       [ 30.,  79.,  64.,   0.,  -3.],       [ 36.,  82.,  65.,  -1.,   4.],       [ 53.,  76.,  69.,  -5.,   0.],       [ 61.,  78.,  63.,  -1.,   2.],       [ 73.,  80.,  65.,  -5.,  -2.],       [ 81.,  81.,  63.,   2.,  -2.],       [ 92.,  80.,  61.,  -1.,  -3.],       [104.,  78.,  70.,  -5.,   0.],       [  3.,  86.,  66.,  -1.,  -2.],       [  5.,  86.,  64.,   4.,   2.],       [ 18.,  89.,  70.,  -3.,   4.],       [ 29.,  91.,  65.,  -2.,   0.],       [ 41.,  89.,  70.,  -5.,   3.],       [ 52.,  86.,  69.,  -3.,  -4.],       [ 55.,  87.,  63.,   3.,  -2.],       [ 70.,  92.,  67.,   4.,  -4.],       [ 75.,  92.,  67.,   2.,   4.],       [ 85.,  86.,  70.,  -5.,  -5.],       [103.,  86.,  68.,   1.,   3.],       [ -2., 101.,  62.,  -3.,  -3.],       [  6.,  96.,  68.,   2.,  -4.],       [ 24., 104.,  65.,  -1.,  -3.],       [ 31., 103.,  66.,   1.,  -1.],       [ 43., 103.,  64.,  -4.,   3.],       [ 48., 100.,  67.,   4.,  -3.],       [ 55., 104.,  64.,  -2.,   1.],       [ 66.,  95.,  65.,  -1.,   3.],       [ 79.,  98.,  66.,  -5.,   4.],       [ 93.,  99.,  65.,  -2.,   3.],       [102., 102.,  67.,   4.,  -3.],       [  2.,  -1.,  77.,   4.,  -3.],       [  5.,  -4.,  78.,  -1.,   2.],       [ 20.,  -2.,  72.,  -2.,   1.],       [ 25.,  -2.,  81.,   2.,   2.],       [ 35.,   1.,  76.,  -1.,   3.],       [ 49.,   3.,  79.,  -4.,   1.],       [ 58.,  -5.,  81.,   3.,   3.],       [ 68.,  -5.,  76.,   2.,  -1.],       [ 82.,   3.,  79.,  -5.,  -4.],       [ 87.,  -3.,  76.,   3.,  -5.],       [101.,  -4.,  80.,   3.,   2.],       [ -4.,   9.,  80.,  -4.,  -3.],       [ 14.,  11.,  74.,   3.,  -1.],       [ 22.,  14.,  79.,  -3.,  -5.],       [ 34.,   5.,  75.,   2.,   2.],       [ 35.,   6.,  75.,   3.,   0.],       [ 48.,   6.,  73.,   2.,  -1.],       [ 61.,  13.,  73.,  -2.,   3.],       [ 66.,  13.,  75.,  -5.,   2.],       [ 80.,   7.,  73.,   4.,   4.],       [ 90.,   7.,  81.,   0.,   1.],       [ 98.,  12.,  77.,  -4.,  -5.],       [ -1.,  16.,  78.,  -2.,   3.],       [  5.,  18.,  80.,  -3.,   1.],       [ 21.,  24.,  74.,  -1.,  -4.],       [ 25.,  15.,  74.,   0.,  -2.],       [ 44.,  15.,  77.,  -2.,  -1.],       [ 46.,  20.,  75.,   0.,   3.],       [ 61.,  22.,  81.,   1.,   2.],       [ 72.,  15.,  73.,   3.,  -2.],       [ 83.,  16.,  75.,  -1.,  -3.],       [ 88.,  17.,  78.,  -4.,  -4.],       [ 95.,  22.,  77.,   3.,  -4.],       [  3.,  27.,  76.,  -1.,  -3.],       [  9.,  26.,  78.,  -5.,  -4.],       [ 18.,  29.,  76.,  -3.,  -1.],       [ 29.,  27.,  76.,   3.,  -4.],       [ 44.,  33.,  73.,  -1.,   1.],       [ 52.,  31.,  76.,  -2.,   2.],       [ 64.,  32.,  80.,  -5.,  -1.],       [ 67.,  25.,  75.,   3.,  -1.],       [ 75.,  34.,  73.,  -5.,  -3.],       [ 86.,  32.,  80.,  -5.,   2.],       [ 98.,  33.,  79.,   2.,   3.],       [ -4.,  43.,  75.,   0.,   4.],       [ 13.,  35.,  81.,   3.,   2.],       [ 16.,  39.,  82.,  -1.,   0.],       [ 29.,  38.,  75.,  -2.,  -5.],       [ 41.,  40.,  77.,   2.,  -3.],       [ 47.,  38.,  80.,  -2.,  -4.],       [ 61.,  40.,  73.,  -2.,   1.],       [ 65.,  38.,  79.,   2.,  -2.],       [ 84.,  35.,  76.,   4.,  -2.],       [ 94.,  39.,  73.,   0.,  -1.],       [ 96.,  42.,  74.,  -4.,   0.],       [  4.,  45.,  74.,  -5.,   0.],       [ 12.,  50.,  75.,   1.,  -4.],       [ 24.,  48.,  81.,   4.,  -4.],       [ 30.,  53.,  79.,  -1.,   2.],       [ 42.,  54.,  74.,  -2.,   0.],       [ 53.,  48.,  75.,  -3.,  -3.],       [ 64.,  52.,  81.,   2.,  -4.],       [ 70.,  50.,  74.,   4.,   4.],       [ 75.,  49.,  78.,  -3.,   4.],       [ 87.,  46.,  78.,   0.,  -5.],       [ 99.,  54.,  82.,   2.,  -2.],       [  4.,  61.,  77.,  -3.,   4.],       [ 11.,  60.,  81.,  -5.,   1.],       [ 18.,  61.,  81.,  -5.,   1.],       [ 31.,  61.,  82.,   2.,   2.],       [ 38.,  58.,  78.,  -3.,   2.],       [ 45.,  55.,  82.,   1.,  -3.],       [ 62.,  60.,  78.,  -1.,   1.],       [ 70.,  55.,  79.,  -5.,  -2.],       [ 83.,  64.,  78.,   0.,  -3.],       [ 91.,  57.,  72.,   1.,  -2.],       [ 96.,  64.,  78.,   1.,   3.],       [ -2.,  69.,  82.,   2.,   3.],       [ 14.,  69.,  76.,   0.,  -4.],       [ 21.,  70.,  73.,  -1.,   2.],       [ 25.,  68.,  72.,  -1.,  -2.],       [ 35.,  68.,  76.,  -2.,  -3.],       [ 53.,  72.,  74.,   1.,  -2.],       [ 62.,  68.,  82.,   1.,   1.],       [ 73.,  65.,  75.,  -4.,   0.],       [ 78.,  67.,  72.,  -5.,   1.],       [ 86.,  69.,  74.,   0.,   1.],       [ 98.,  73.,  78.,   3.,  -1.],       [ -5.,  80.,  76.,  -1.,   1.],       [  6.,  82.,  82.,   3.,   4.],       [ 16.,  75.,  82.,   3.,   4.],       [ 28.,  81.,  79.,   2.,  -3.],       [ 35.,  77.,  74.,   0.,   2.],       [ 50.,  84.,  79.,  -3.,  -1.],       [ 55.,  82.,  82.,   4.,   1.],       [ 66.,  78.,  82.,   1.,   4.],       [ 77.,  79.,  80.,   1.,   1.],       [ 93.,  75.,  80.,   4.,   4.],       [ 97.,  82.,  75.,   4.,   4.],       [ -5.,  86.,  78.,   4.,  -1.],       [  9.,  91.,  77.,  -1.,  -2.],       [ 22.,  90.,  73.,  -2.,  -1.],       [ 27.,  88.,  81.,   0.,   3.],       [ 39.,  85.,  82.,  -2.,  -1.],       [ 52.,  93.,  73.,  -4.,  -5.],       [ 57.,  86.,  75.,  -4.,  -3.],       [ 66.,  93.,  78.,  -5.,  -5.],       [ 79.,  93.,  78.,  -5.,  -1.],       [ 92.,  92.,  75.,  -2.,  -2.],       [101.,  89.,  82.,   4.,   3.],       [  4., 102.,  77.,   0.,   0.],       [  7.,  96.,  80.,   4.,   2.],       [ 23., 102.,  80.,  -3.,   2.],       [ 34., 102.,  80.,   4.,  -2.],       [ 43., 101.,  81.,   2.,   0.],       [ 49.,  96.,  73.,  -5.,   3.],       [ 56., 100.,  77.,   3.,   0.],       [ 73.,  96.,  77.,  -1.,   0.],       [ 84.,  97.,  77.,  -2.,   3.],       [ 92.,  98.,  80.,  -2.,  -4.],       [ 95., 100.,  77.,   3.,   4.],       [  0.,   2.,  93.,   1.,   3.],       [  9.,   2.,  84.,   4.,  -5.],       [ 17.,   2.,  87.,  -1.,  -3.],       [ 26.,   2.,  84.,   0.,  -1.],       [ 38.,  -2.,  85.,  -4.,  -2.],       [ 47.,  -2.,  91.,  -3.,  -2.],       [ 56.,  -4.,  92.,  -4.,  -2.],       [ 68.,   0.,  87.,  -3.,  -4.],       [ 83.,  -5.,  84.,   3.,   4.],       [ 94.,   4.,  87.,  -3.,  -5.],       [101.,  -2.,  84.,  -3.,   4.],       [  3.,   5.,  93.,  -1.,  -3.],       [  8.,  12.,  85.,  -2.,   3.],       [ 15.,   6.,  93.,  -2.,   1.],       [ 33.,  14.,  84.,   3.,   2.],       [ 43.,   9.,  89.,   4.,   1.],       [ 45.,   8.,  90.,  -3.,   4.],       [ 60.,  14.,  87.,  -2.,  -5.],       [ 74.,  12.,  84.,  -5.,   4.],       [ 83.,  12.,  86.,  -1.,   1.],       [ 88.,   6.,  90.,  -1.,  -1.],       [102.,  13.,  86.,   1.,   2.],       [  1.,  24.,  89.,   4.,  -4.],       [  9.,  20.,  88.,   2.,  -2.],       [ 20.,  16.,  91.,  -1.,   0.],       [ 33.,  16.,  93.,  -2.,  -2.],       [ 40.,  24.,  87.,  -2.,  -2.],       [ 49.,  15.,  84.,  -3.,   4.],       [ 61.,  17.,  86.,   4.,   0.],       [ 69.,  19.,  86.,   4.,   1.],       [ 75.,  23.,  87.,   4.,   3.],       [ 85.,  15.,  92.,   3.,  -3.],       [ 97.,  19.,  86.,  -3.,   3.],       [  3.,  31.,  91.,   1.,  -2.],       [ 10.,  32.,  86.,   0.,   3.],       [ 18.,  26.,  91.,  -3.,   2.],       [ 30.,  28.,  84.,  -5.,   4.],       [ 42.,  28.,  88.,   1.,  -4.],       [ 46.,  29.,  85.,   1.,  -5.],       [ 59.,  31.,  86.,   0.,  -4.],       [ 65.,  29.,  89.,   4.,  -2.],       [ 83.,  31.,  90.,  -2.,  -1.],       [ 87.,  29.,  93.,  -5.,   4.],       [104.,  28.,  84.,   4.,   1.],       [ -5.,  37.,  93.,   4.,   1.],       [ 13.,  42.,  92.,  -2.,  -5.],       [ 17.,  40.,  90.,   4.,  -3.],       [ 32.,  43.,  87.,   3.,  -4.],       [ 44.,  44.,  90.,   0.,  -1.],       [ 49.,  43.,  85.,  -2.,   3.],       [ 60.,  44.,  88.,   3.,   1.],       [ 74.,  38.,  91.,  -4.,  -2.],       [ 81.,  44.,  89.,  -1.,   4.],       [ 88.,  44.,  90.,  -4.,   1.],       [ 99.,  36.,  88.,  -3.,  -5.],       [ -4.,  47.,  87.,   1.,   0.],       [  6.,  46.,  88.,   0.,   3.],       [ 18.,  48.,  89.,  -3.,  -3.],       [ 32.,  54.,  92.,  -1.,  -1.],       [ 38.,  45.,  86.,  -4.,  -2.],       [ 53.,  48.,  86.,   3.,   1.],       [ 58.,  53.,  85.,  -3.,   1.],       [ 74.,  52.,  89.,  -2.,   2.],       [ 80.,  47.,  89.,   1.,  -4.],       [ 85.,  46.,  92.,  -1.,  -1.],       [ 98.,  49.,  90.,   3.,   0.],       [  0.,  59.,  84.,   2.,   0.],       [ 14.,  55.,  85.,   3.,   0.],       [ 21.,  63.,  89.,  -2.,  -1.],       [ 25.,  63.,  90.,   3.,   1.],       [ 41.,  61.,  89.,  -2.,  -5.],       [ 49.,  58.,  91.,   3.,  -1.],       [ 55.,  64.,  84.,  -1.,   0.],       [ 70.,  64.,  90.,  -2.,  -2.],       [ 77.,  59.,  89.,  -3.,  -1.],       [ 88.,  60.,  85.,  -2.,   0.],       [103.,  61.,  89.,   0.,  -1.],       [ -3.,  73.,  85.,  -4.,  -2.],       [  7.,  69.,  88.,   2.,  -1.],       [ 24.,  68.,  85.,  -3.,  -1.],       [ 29.,  71.,  91.,  -4.,   0.],       [ 41.,  70.,  88.,   2.,   2.],       [ 50.,  65.,  86.,  -5.,  -2.],       [ 64.,  70.,  85.,  -1.,   0.],       [ 74.,  74.,  85.,   4.,   4.],       [ 79.,  70.,  85.,   3.,  -5.],       [ 92.,  66.,  86.,  -1.,  -1.],       [104.,  72.,  87.,  -3.,   0.],       [ -5.,  78.,  89.,   0.,  -3.],       [ 14.,  76.,  86.,  -1.,  -1.],       [ 18.,  79.,  88.,  -5.,   3.],       [ 26.,  83.,  83.,   0.,   0.],       [ 35.,  82.,  91.,  -2.,   2.],       [ 51.,  81.,  88.,  -2.,   2.],       [ 59.,  78.,  92.,   3.,  -3.],       [ 68.,  79.,  85.,   2.,  -5.],       [ 76.,  80.,  85.,  -4.,  -2.],       [ 93.,  81.,  91.,  -3.,  -2.],       [104.,  81.,  90.,  -3.,  -2.],       [  2.,  94.,  88.,  -4.,  -3.],       [ 11.,  89.,  84.,   0.,   0.],       [ 24.,  91.,  85.,  -3.,   0.],       [ 28.,  93.,  84.,  -4.,  -3.],       [ 38.,  91.,  89.,   4.,  -2.],       [ 48.,  89.,  92.,  -3.,  -3.],       [ 57.,  87.,  90.,   2.,  -2.],       [ 65.,  87.,  89.,   2.,   3.],       [ 78.,  85.,  91.,  -1.,  -3.],       [ 88.,  85.,  90.,   3.,  -4.],       [ 99.,  91.,  90.,   3.,   3.],       [ -5.,  99.,  85.,   0.,   4.],       [  9.,  96.,  86.,   1.,   1.],       [ 15., 100.,  92.,  -3.,   4.],       [ 27., 100.,  92.,  -3.,   2.],       [ 35., 104.,  84.,  -1.,   2.],       [ 54.,  98.,  88.,  -4.,  -5.],       [ 64., 100.,  86.,   0.,   4.],       [ 73.,  98.,  90.,   2.,  -4.],       [ 83.,  98.,  87.,   2.,  -3.],       [ 86.,  97.,  85.,   0.,   1.],       [ 98.,  97.,  90.,  -2.,  -2.],       [  2.,  -3., 103.,   1.,  -2.],       [  6.,   0.,  99.,   3.,  -2.],       [ 15.,  -4.,  98.,  -3.,  -5.],       [ 33.,   4., 100.,   1.,   1.],       [ 36.,  -4., 100.,   1.,  -2.],       [ 46.,  -4., 102.,  -3.,   2.],       [ 64.,   2., 103.,   0.,  -2.],       [ 74.,   2., 101.,  -4.,   0.],       [ 78.,   2., 102.,   3.,  -1.],       [ 86.,  -5., 103.,   0.,   2.],       [ 99.,  -1.,  97.,  -5.,   4.],       [ -3.,  11., 101.,  -4.,  -2.],       [ 13.,  12., 104.,  -5.,   0.],       [ 22.,  11., 103.,   0.,  -5.],       [ 28.,   6., 100.,  -4.,   3.],       [ 38.,   9., 100.,  -2.,   1.],       [ 54.,  13.,  98.,   3.,  -5.],       [ 63.,   5.,  96.,  -2.,   0.],       [ 69.,  11.,  99.,  -4.,  -3.],       [ 83.,  12., 101.,   0.,   4.],       [ 86.,  12.,  99.,   1.,   1.],       [100.,   7., 104.,   2.,   3.],       [ -2.,  17., 100.,   4.,  -5.],       [  6.,  23.,  98.,   2.,  -1.],       [ 20.,  20., 102.,  -3.,   2.],       [ 33.,  24.,  97.,  -2.,  -5.],       [ 42.,  16., 100.,   2.,  -2.],       [ 51.,  18.,  98.,   3.,  -3.],       [ 60.,  15., 104.,  -4.,   2.],       [ 74.,  21.,  95.,   4.,   1.],       [ 75.,  21.,  95.,   1.,  -4.],       [ 87.,  17., 103.,  -3.,   4.],       [100.,  15.,  97.,  -5.,  -3.],       [  1.,  25.,  96.,   0.,   4.],       [  8.,  26., 103.,  -2.,   2.],       [ 24.,  33.,  98.,   2.,   3.],       [ 29.,  33.,  97.,  -2.,  -2.],       [ 40.,  33., 102.,  -1.,  -3.],       [ 45.,  32., 103.,  -3.,  -3.],       [ 59.,  32., 104.,   0.,   0.],       [ 68.,  25., 104.,   0.,  -4.],       [ 75.,  30., 102.,   3.,  -3.],       [ 90.,  25.,  97.,  -3.,   1.],       [102.,  31.,  97.,  -1.,  -2.],       [  2.,  41., 101.,  -5.,   1.],       [  5.,  37.,  98.,  -3.,   1.],       [ 15.,  38., 100.,   2.,  -2.],       [ 34.,  37.,  98.,   2.,  -4.],       [ 38.,  44.,  98.,   2.,  -5.],       [ 54.,  44., 102.,   2.,   1.],       [ 58.,  44.,  98.,  -2.,   1.],       [ 73.,  37.,  99.,  -4.,  -4.],       [ 83.,  39., 101.,   4.,   2.],       [ 92.,  41.,  96.,  -5.,  -1.],       [ 95.,  36., 103.,   2.,   1.],       [ -5.,  50., 103.,   1.,   3.],       [  5.,  45., 100.,  -4.,   3.],       [ 15.,  52.,  96.,  -2.,   3.],       [ 32.,  50.,  97.,  -5.,   3.],       [ 37.,  53.,  95.,   4.,   1.],       [ 54.,  45., 101.,   3.,   4.],       [ 57.,  52.,  95.,  -2.,  -5.],       [ 66.,  47.,  99.,  -1.,   1.],       [ 77.,  51., 104.,   0.,  -1.],       [ 88.,  49., 101.,   0.,   4.],       [103.,  53., 100.,   3.,  -4.],       [  4.,  59., 100.,   1.,  -3.],       [  5.,  57., 100.,   0.,  -5.],       [ 17.,  64., 102.,  -3.,   4.],       [ 31.,  56., 103.,  -4.,  -5.],       [ 35.,  63., 100.,  -1.,  -3.],       [ 54.,  63.,  95.,   0.,   1.],       [ 59.,  61., 102.,   4.,  -2.],       [ 71.,  57., 104.,   4.,   0.],       [ 77.,  56., 101.,  -4.,  -4.],       [ 91.,  58.,  97.,   2.,  -5.],       [103.,  56.,  97.,   4.,  -3.],       [ -4.,  71., 100.,   4.,  -1.],       [ 13.,  74.,  96.,   3.,   0.],       [ 18.,  68.,  96.,  -4.,  -5.],       [ 26.,  66.,  98.,  -4.,  -1.],       [ 42.,  66.,  99.,   4.,   2.],       [ 46.,  68., 100.,   3.,   4.],       [ 56.,  65.,  99.,   1.,  -4.],       [ 65.,  70.,  97.,   0.,   1.],       [ 76.,  69., 103.,  -3.,   2.],       [ 94.,  67.,  99.,   4.,  -1.],       [100.,  72.,  97.,  -4.,   1.],       [ -3.,  80., 104.,   4.,  -5.],       [ 12.,  83., 101.,   0.,  -3.],       [ 23.,  76., 104.,  -1.,   0.],       [ 31.,  80.,  98.,   2.,  -3.],       [ 41.,  82., 104.,  -1.,  -3.],       [ 47.,  79., 104.,  -5.,  -2.],       [ 56.,  81., 101.,  -2.,  -5.],       [ 69.,  79.,  99.,  -2.,  -4.],       [ 75.,  76., 101.,  -5.,   1.],       [ 94.,  78., 103.,   2.,  -4.],       [103.,  83., 102.,   3.,  -4.],       [ -1.,  91.,  99.,  -2.,   2.],       [ 10.,  94., 103.,   3.,   3.],       [ 16.,  92.,  96.,   1.,   0.],       [ 30.,  85.,  97.,   1.,   2.],       [ 39.,  92., 103.,   2.,   2.],       [ 50.,  90., 103.,   2.,  -3.],       [ 55.,  94., 103.,   1.,   4.],       [ 65.,  85.,  97.,   3.,   4.],       [ 83.,  86., 100.,   4.,  -4.],       [ 86.,  94.,  99.,  -1.,  -2.],       [104.,  87., 102.,   0.,   3.],       [ -3.,  99.,  97.,   2.,   4.],       [ 13., 100.,  98.,   3.,  -5.],       [ 19., 100.,  98.,   2.,   4.],       [ 25., 104., 100.,   1.,   1.],       [ 35., 101.,  97.,  -3.,  -3.],       [ 46., 104., 100.,  -1.,  -1.],       [ 63.,  95., 104.,   2.,  -2.],       [ 71., 100.,  97.,  -4.,  -3.],       [ 79.,  99.,  98.,  -2.,  -4.],       [ 88.,  99., 101.,   0.,  -5.],       [ 95., 100.,  99.,   2.,   2.]])
        n1   = 11
        p1   = 6
        knot1= np.array([0. , 0. , 0. , 0. , 0. , 0. , 1.3, 2. , 2.9, 4.1, 5.1, 6. , 6. , 6. , 6. , 6. , 6. ])
        n2   = 11
        p2   = 7
        knot2= np.array([0. , 0. , 0. , 0. , 0. , 0. , 0. , 0.9, 1.8, 3.4, 3.7, 5. , 5. , 5. , 5. , 5. , 5. , 5. ])
        n3   = 10
        p3   = 7
        knot3= np.array([0. , 0. , 0. , 0. , 0. , 0. , 0. , 1.3, 2.2, 3.2, 4. , 4. , 4. , 4. , 4. , 4. , 4. ])
        vol  = lr.LRSplineVolume(n1,n2,n3,p1,p2,p3,knot1,knot2,knot3,controlpoints)
        vol2 = vol.clone()
        vol2.insert_knot([2.247], 0, 1) # insert C4-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 18)
        vol2.insert_knot([4.061], 0, 2) # insert C3-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 20)
        vol2.insert_knot([5.065], 0, 3) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 23)
        vol2.insert_knot([2.448], 0, 4) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 27)
        vol2.insert_knot([2.316], 0, 5) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=0,with_multiplicities=True)), 32)
        vol2.insert_knot([2.600], 1, 1) # insert C5-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 19)
        vol2.insert_knot([3.637], 1, 2) # insert C4-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 21)
        vol2.insert_knot([3.271], 1, 3) # insert C3-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 24)
        vol2.insert_knot([2.779], 1, 4) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 28)
        vol2.insert_knot([2.634], 1, 5) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 33)
        vol2.insert_knot([1.234], 1, 6) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=1,with_multiplicities=True)), 39)
        vol2.insert_knot([2.400], 2, 1) # insert C5-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 18)
        vol2.insert_knot([2.687], 2, 2) # insert C4-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 20)
        vol2.insert_knot([1.940], 2, 3) # insert C3-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 23)
        vol2.insert_knot([2.959], 2, 4) # insert C2-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 27)
        vol2.insert_knot([1.439], 2, 5) # insert C1-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 32)
        vol2.insert_knot([2.612], 2, 6) # insert C0-knot
        self.assertEqual(len(vol2.knots(direction=2,with_multiplicities=True)), 38)

        u    = np.linspace(vol.start(0), vol.end(0), 7)
        v    = np.linspace(vol.start(1), vol.end(1), 7)
        w    = np.linspace(vol.start(2), vol.end(2), 7)
        U,V,W= np.meshgrid(u,v,w)
        pt   = vol(U,V,W)
        pt2  = vol2(U,V,W)
        self.assertAlmostEqual(np.linalg.norm(pt-pt2), 0.0)


if __name__ == '__main__':
    unittest.main()
